// translator: goal-diff-accepted; wopt: yes
#include "problem.h"
#include "preprocess.h"
#include "parser.h"
#include "plans.h"
#include "heuristic.h"
#include "bandit.h"
#include <set>
#include <iterator>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <errno.h>
#include "stats.h"
#include <string.h>
#include <stdio.h>
#include <iostream>
//#include <list>
#include <vector>
#include <fstream>
#include <string>
#include <sstream>
#include <algorithm>
#include <cstdlib>
//#include <time.h>
#include <sys/time.h>
#include <cmath>
#include "lmcut.h"

#include <unistd.h>
//#include <sys/types.h>
//#include <fcntl.h>
#include <stdlib.h>
//#include <unistd.h>
//#include <signal.h>
#include <bitset>

#include <pwd.h>
#include <unistd.h>

#include <limits>

#include <functional>   // std::logical_or

//#include <map>
#include <tr1/unordered_map>
using namespace std::tr1;

//#define READ 0
//#define WRITE 1
using namespace std;

const std::string planner_location = ".";
const std::string fd_src_location = planner_location + "/downward/src";
//const std::string validator_location = planner_location + "/downward/src";
const std::string validator_location = planner_location + "/downward/builds/release32/bin";
const std::string aras_src_location = planner_location + "/aras/src";


string results_dir = ".";
string temp_dir = results_dir + "/temp";
const string com_file = results_dir + "/run_planner.sh";

double alloted_tm = 22000;
const float do_tm_bound = 600;
const float WF_TIME_BOUND_ONCE = 120; // 600
const int MAX_WINDOW_BOUND_ONCE = 20; // 80
const int MAX_WINDOW_BOUND_PER_WPOLICY = 10; // 30
const int max_tot_windows = 2000;
const int max_deorder = 50000;
const int TOT_PLANNERS = 2;

const int PLAN_TBOUND = 15;
const int TRAN_TBOUND = 100;

//const int MAX_BANDIT_SIZE = 3;
int MAX_IMPROVEMENT_ATTEMPT = 4;
const int WINDOW_POLICY_TOT = 6;

HSPS::Instance instance;
HSPS::Statistics  stats;
HSPS::ActionSequence theplan;
double swatch;
double swatch_temp;
double swatch_temp2;

int prf_size;
int fob_length;
int window_counter_general = -1;
int window_counter_twister = -1;
Bandit_Planner *bandit_planner;
vector<Window> window;
vector<int> window_rank;

vector<int> *mfb_basic, *prf_full_basic, *mfb_ext, *prf_full_ext;
int mfb_basic_tot, mfb_ext_tot;

vector<int> fixed_rec, cyclic_rec, causal_rec;
vector<int> live_atoms;
vector<bool> *order_all;//, *order_all_r;
vector<int> *pfull, *pfull_r;
vector<int> size_on_off;
vector<int> planner_on_off;
vector<double> init_time_bound;
vector<double> current_time_bound;
vector<int> *prf_order_vector, *straight_dependent_vector, *sd_vector_new, *prf_full;
vector<int> **sd_atoms;
vector<int> *pre_vector, *add_vector, *del_vector;
vector<int> *macro_clusters, *mfb;
vector<int> *key_blocks, *block_tree;
vector<int> redundant_actions;
vector<int> frozen_actions;
vector<int> frozen_wids;
vector<int> unusable_blocks;

typedef unordered_map<string,int> W_UMAP;
typedef unordered_map<string, int> S_UMAP;
W_UMAP window_umap;
S_UMAP sprob_umap; // trial - cost - hcost - costImpr - exhaust - wid

vector<int> hcut(WINDOW_POLICY_TOT, 0);

int key_blocks_tot;
char **arguments;

vector<int> *block_thread;
int block_thread_tot;
vector<int> self_looped_blocks;

vector<int> *thread_cluster;
int thread_cluster_tot;

vector<int> lin_blocks, lin_actions;

vector<int> improvement_coverage;
vector<int> trial_coverage;

vector<int> cndt_outer_block, cndt_fib;
int mac_tot = 0;
//int fob_tot = 0;
//int merged_fob_tot = 0;
//int fib_tot = 0;
int mfb_tot = 0;
//int lin_tot = 0;
int tot_deorder = 0;
//int test_count = 0;

int bigger_value;
float flex = 0;

//time
//double deorder_tm = 0;
double merge_tm = 0;
double windowform_tm = 0;
double lmcut_tm = 0;
double windowsort_tm = 0;
double total_tm = 0;
size_t iteration = 0;
size_t bplan_isnum = 0;
//int window_size = 1;

const string unproductive_arm_param = "-u";
const string reset_bandit_param = "-r";

bool switch_off_unproductive_arms_flag = false;
bool reset_bandit_flag = false;
bool redundant_block_exist = false;

int plan_cost_init = 0;
int plan_cost_last = 0;
//int plan_length_init = 0;
int plan_length_last = 0;
//int rejected_windows = 0;
int improved_windows = 0;

int wpid;
bool basic_block;
vector<int> *wg_status;

double vm, rss;

vector<int> rank_policy(2,0); // ranking policy for each planner

const string planners_desc[TOT_PLANNERS] = {
  // LAMA
  //    com_file + " " + fd_src_location + "/search/downward  --heuristic 'hlm,hff=lm_ff_syn(lm_rhw(reasonable_orders=true,cost_type=2,lm_cost_type=2))' --search 'iterated([lazy_wastar([hff,hlm],preferred=[hff,hlm],w=1)], repeat_last=true, bound=CBD)' < output",
    
  //    com_file + " " + fd_src_location + "/search/downward  --heuristic 'hlm,hff=lm_ff_syn(lm_rhw(reasonable_orders=true,lm_cost_type=2,cost_type=2))' "
  //           "--search 'iterated([lazy_wastar([hff,hlm],preferred=[hff,hlm],w=3), "
  //                               "lazy_wastar([hff,hlm],preferred=[hff,hlm],w=1)], "
  //                               "repeat_last=true, continue_on_fail=true, bound=CBD)' < output" ,
  // BCS
  //    com_file + " " + fd_src_location + "/search/downward  --heuristic 'hff=ff(cost_type=ONE)' --search 'eager_greedy(hff, preferred=[hff], f_eval=sum([g(),lmcut()]), bound=)' < output",
  // IBCS
  com_file + " " + fd_src_location + "/search/downward  --heuristic 'hff=ff(cost_type=ONE)' --search 'iterated([eager_greedy(hff, preferred=[hff], f_eval=sum([g(),lmcut()]))], repeat_last=true, bound=CBD)' < output",
  // 
  // PNGS
  // com_file + " " + aras_src_location + "/plan DFILE RFILE --postprocessor \"aras(cost_type=PLUSONE)\" --input-plan-file PFILE --plan-file aplan"
  com_file + " " + aras_src_location + "/search/downward --postprocessor \"aras(cost_type=PLUSONE)\" --input-plan-file PFILE --plan-file aplan < output"
};


const string planners_desc_short[TOT_PLANNERS] = {
    "ibcs",
    "pngs"
//    "lazy_wastar: (lm_cost_type=2,cost_type=2)", 
//    "lazy_wastar_2"
};



vector<float> string_to_vector_float(string line, string delimiter){
    char *p;
    float x;
    vector<float> tokens;
    
    if(line.empty() || line.compare(delimiter) == 0) return tokens;
    
    p = strtok( &line[0], delimiter.c_str() );
    while(p != NULL){
        stringstream ss; 
        ss << p;
        ss >> x;
        tokens.push_back(x);
        p = strtok( NULL, delimiter.c_str() );        
    }
    
    return tokens;
}

vector<int> string_to_vector(string line, string delimiter){
    char *p;
    int x;
    vector<int> tokens;
    
    if(line.empty() || line.compare(delimiter) == 0) return tokens;
    
    p = strtok( &line[0], delimiter.c_str() );
    while(p != NULL){
        stringstream ss; 
        ss << p;
        ss >> x;
        tokens.push_back(x);
        p = strtok( NULL, delimiter.c_str() );        
    }
    
    return tokens;
}

template <typename T>
string vector_to_string(vector<T> vec, string delimiter){
  if(vec.empty()) return delimiter;

  
  std::ostringstream oss;

    // Convert all but the last element to avoid a trailing ","
    std::copy(vec.begin(), vec.end()-1,
        std::ostream_iterator<T>(oss, delimiter.c_str()));

    // Now add the last element with no delimiter
    oss << vec.back();

  return oss.str();
  
}

bool contains( std::vector<int> Vec, int Element ) 
{
    if (std::find(Vec.begin(), Vec.end(), Element) != Vec.end()) return true;        
    return false;
}

bool contains( std::vector<float> Vec, float Element ) 
{
    if (std::find(Vec.begin(), Vec.end(), Element) != Vec.end()) return true;        
    return false;
}

void unique_vec(vector<int> &k){
    std::vector< int >::iterator r , w ;

    std::set< int > tmpset ;

    for( r = k.begin() , w = k.begin() ; r != k.end() ; ++r )
    {
            if( tmpset.insert( *r ).second )
            {
                    *w++ = *r ;
            }
    }

    k.erase( w , k.end() );
} 

template <typename T> 
void unique_sorted_vec(vector<T>& k){
    // std::vector<int>::iterator it = unique(k.begin(), k.end());
    k.resize( std::distance(k.begin(), unique(k.begin(), k.end())) );
}

template <typename T> 
void remove_val( std::vector<T>& Vec, const T& Element ) 
{
    Vec.resize( std::distance(Vec.begin(), remove(Vec.begin(), Vec.end(), Element)) );
}

void remove_vec(vector<int>  &l1, vector<int>  &l2){
    vector<int>  l3 ;
    if(l2.empty()) return;
    
    for (vector<int>::iterator it1 = l1.begin(); it1 != l1.end(); it1++){
        if(!contains(l2, *it1))
            l3.push_back(*it1);
    }
    
    l1.clear();
    l1 = l3;
}

// a predicate implemented as a function:
bool bigger_digit (const int& value) { return (value > bigger_value); }

string delSpaces(string &str) 
{
   str.erase(std::remove(str.begin(), str.end(), ' '), str.end());
   return str;
}

bool DirectoryExists( const char* pzPath )
{
    if ( pzPath == NULL) return false;

    DIR *pDir;
    bool bExists = false;

    pDir = opendir (pzPath);

    if (pDir != NULL)
    {
        bExists = true;    
        (void) closedir (pDir);
    }

    return bExists;
}

int getdir (string dir, vector<string> &files, string pattern)
{
    DIR *dp;
    struct dirent *dirp;
    if((dp  = opendir(dir.c_str())) == NULL) {
        cout << "Error(" << errno << ") opening " << dir << endl;
        return errno;
    }

    while ((dirp = readdir(dp)) != NULL) {
        string fname = string(dirp->d_name);
//        cout << "fname...........: " << fname << endl;
        size_t found = fname.find(pattern);
        if(found!=string::npos) files.push_back(fname);

    }
    closedir(dp);
    return 0;
}

double get_wall_time(){
    struct timeval time;
    if (gettimeofday(&time,NULL)){
        //  Handle error
        return 0;
    }
    return (double)time.tv_sec + (double)time.tv_usec * .000001;
}

double get_cpu_time(){
    return (double)clock() / CLOCKS_PER_SEC;
}

class Timer {
public:
    Timer() { start = ::time(NULL); }
    virtual ~Timer() { }
 
    unsigned long Lapse() {
        return ::time(NULL)-start;
    }
private:
    unsigned long start;
};

//=====
inline std::string TrimStr(const std::string& Src, const std::string& c = " \r\n")
{
int p2 = Src.find_last_not_of(c);
if (p2 == std::string::npos) return std::string();
int p1 = Src.find_first_not_of(c);
if (p1 == std::string::npos) p1 = 0;
return Src.substr(p1, (p2-p1)+1);
}
//=====

vector<int> get_predecessors(vector<int> *prfol, int c_action, int size);
vector<int> get_successors(vector<int> *prfol, int c_action, int size);

void user_defined_subproblem(char *argv[]);
vector<int> get_pom_values(string token_vector);
vector<int> linearize_dfs();
vector<int> get_all_atoms();
vector<int> get_active_init_atoms();
vector<int> get_vector(HSPS::index_set iset);
vector<int> intersection_set(vector<int>  l1, vector<int>  l2);
vector<int> union_set(vector<int>  l1, vector<int>  l2);
vector<int> difference_set(vector<int>  l1, vector<int>  l2);
int last_producer(int atom, int i, int j);
int earliest_producer(int atom, int i, int j);

void print_vector(vector<int> *prf_order_vector, ofstream *myoutput);
void print_2d_vector(vector<int> *prf_order_vector);
void print_sd_vector(vector<int> *sd_vector);
void print_sd_vector(vector<int> *sd_vector, ofstream *myoutput);
void print_vector(vector<int> pl);
void print_2d_string(string *str, int size, ofstream *myoutput);
vector<int>* delete_transitive_order(vector<int> *iol, int size);

bool have_path(vector<int> *straight_dependent_vector, int from_action, int to_action, int size);
bool have_common(vector<int>  l1, vector<int>  l2);

vector<int>* macro_vector(vector<int> pol);

vector<int>*  macro_dependency(vector<int> pom1, vector<int> pom2);

bool have_straight_dependency(int i, int j);
bool have_straight_goal_dependency(int i);

void find_po_macro_output();
void print_actions_for_atom();
void print_all_actions();
void print_all_actions(ofstream *myoutput);
void print_init_goal_atoms();

vector<int> get_intermediate_nodes(vector<int> *order_vector, int from_action, int to_action);
vector<int> get_intermediate_nodes(vector<int> *order_vector, int size, int from_action, int to_action);
vector<int> get_intermediate_nodes(vector<int> *order_vector, int size, vector<int> from_actions, vector<int> to_actions);
vector<int> get_intermediate_nodes(vector<int> *order_vector, int size, vector<int> actions);

void create_deordered_macros_of_pop(vector<int> *td_prf);

vector<int>* resolve_dependency_of_pop(int rear_action, int front_action);

bool have_po_macro_dependency(vector<int> pom1, vector<int> pom2);

vector<int>* reverse_order_vector(vector<int>* vector);

vector<int> resolve_ap_dependency(vector<int> macro1, vector<int> macro2);
vector<int> resolve_da_dependency(vector<int> macro1, vector<int> macro2);
vector<int>* resolve_pd_dependency(vector<int> macro1, vector<int> macro2);

vector<int> responsible_actions_for_pre(vector<int> pol, int atom);
vector<int> responsible_actions_for_add(vector<int> macro1, vector<int> macro2, int atom);
vector<int> responsible_actions_for_del(vector<int> pol, int atom);
vector<int> incoming_causal_producers(vector<int> macro, vector<int> atoms);

void print_responsible_actions();

int nearest_action(vector<int> *ol, vector<int> macro, int root, int atom, string pad, string direction);

bool equal_set(vector<int>  l1, vector<int>  l2);
bool equal_list(vector<int>  l1, vector<int>  l2);
bool have_subset(vector<int>  l1, vector<int>  l2);
bool have_strict_subset(vector<int>  l1, vector<int>  l2);
bool have_overlap(vector<int>  l1, vector<int>  l2);
int have_insert_permission(vector<int> *temp_clusters);

void update_prf_order(vector<int> cluster1, vector<int> cluster2, vector<int> *free_edges);
void update_prf_order(vector<int> cluster1, vector<int> cluster2);

void set_pad();

void remove_inactive_actions();

float calculate_flex();
vector<int> nearest_cluster_neighbors(vector<int> *ol, vector<int> macro);
vector<int> nearest_cluster_neighbors_2(vector<int> *ol, vector<int> macro);

void do_linearization();

vector<int>* get_new_lin_actions(vector<int> lin_actions, vector<int> isb);

vector<int>* get_independent_sub_blocks(int fob_no);

vector<int>* get_new_lin_actions_2(vector<int> lin_actions, vector<int> action_pair);

void have_test();
void  action_linearizer(vector<int> lin_actions, vector<int> cib, vector<int> indp_actions);
vector<int> encrypt_action_sequence(vector<int> actions);
vector<int> decrypt_action_sequence(vector<int> actions);

void generate_subproblem(char *argv[]);
void plan_optimisation_using_MTAB(char *argv[]);

void write_file_sub_problem(const char *problem_name, vector<int> init_atoms, vector<int> goal_atoms, vector<int> block_vector);
void create_state_transition_model(char *argv[], string model_loc);
void create_atom_transition_model(char *argv[], string model_loc);
void remove_zero_cost_cycles(string model_loc, string cycle_loc, string cycle_loc_non_zero);
int action_set_cost(vector<int> action_set);
double plan_cost();
string exec(const char* cmd);
vector<int>* generate_init_goal(vector<int> pom1_ids, vector<int> pom2_ids);
string file_get_next_token_from_1st_match(string file, string token);
void print_file_contents(string file);
vector<int> accepted_improvement(vector<int>* improved_block_window, vector<double>* improved_block_cost, int improved_tot, vector<int> block_vector, double improvement);
int store_new_sub_plan(string outfile_name, string terminate_string);
string get_dotted_string_vector(vector<int> pl);

vector<int> get_action_names_from_file(string file_name);

void write_new_prf_dot_file(string file_name, vector<int> *dot_vector, int iba[], int length);
void populate_prf(int tot_blocks, int iba[], vector<int> *improved_block_actions, vector<int> *prf_new);
void write_prf_block_file(string file_name, vector<int> *dot_vector);
vector<int> prioritize_windows(vector<int> *c_length, vector<double> *c_cost, vector<int> *improved_block_window_c, int improved_tot_c, int lowindex, int highindex);
vector<int> window_locs_in_prf(int iba[], int size);
vector<int> get_independent_prf_elements(int wi, vector<int> *prf_new, int tot_blocks);
void print_2d_vector(vector<int> *ol, int size, string sep);
int get_plan_cost(string dom, string prob, string plan);

bool have_path(vector<int> *prfol, vector<int> from_actions, vector<int> to_actions, int size);
bool have_any_dependency(int i, int j);
string get_any_dependency(int i, int j);
void print_vector_to_file(vector<int> pl, ofstream &myoutput);
void print_2d_vector_to_file(vector<int> *ol, int size, string sep, ofstream *myoutput);
void print_action_dependencies_to_file();
void do_iterative_test();
void macro_dependency_user_interface();
bool have_po_macro_dependency_special(vector<int> pom1, bool pol1, vector<int> pom2, bool pol2);

vector<int>* formulate_window_pwq(vector<int> macro);

vector<int> formulate_window_w(vector<int> macro);

vector<int> get_window_actions(vector<int> block_vector);
vector<int>* retrieve_init_goal_atoms(int wid);
vector<int> retrieve_actions(int wid);
vector<int> retrieve_new_actions(int wid);

void write_run_planner(int time_bound);

vector<int>* generate_init_goal_atoms(vector<int> window_actions);
void save_window_state(ofstream &fileout_stat, int wid, int old_cost, int upper_cost_bound, double time_bound, int pid, double translation_time, double preprocess_time, double time_1st_plan, double time_last_plan);

vector<int>* formulate_window_pwq(vector<int> macro, vector<int> boundary);

ofstream fileout; 

void process_mem_usage(double& vm_usage, double& resident_set)
{
   using std::ios_base;
   using std::ifstream;
   using std::string;

   vm_usage     = 0.0;
   resident_set = 0.0;

   // 'file' stat seems to give the most reliable results
   //
   ifstream stat_stream("/proc/self/stat",ios_base::in);

   // dummy vars for leading entries in stat that we don't care about
   //
   string pid, comm, state, ppid, pgrp, session, tty_nr;
   string tpgid, flags, minflt, cminflt, majflt, cmajflt;
   string utime, stime, cutime, cstime, priority, nice;
   string O, itrealvalue, starttime;

   // the two fields we want
   //
   unsigned long vsize;
   long rss;

   stat_stream >> pid >> comm >> state >> ppid >> pgrp >> session >> tty_nr
               >> tpgid >> flags >> minflt >> cminflt >> majflt >> cmajflt
               >> utime >> stime >> cutime >> cstime >> priority >> nice
               >> O >> itrealvalue >> starttime >> vsize >> rss; // don't care about the rest

   stat_stream.close();

   long page_size_kb = sysconf(_SC_PAGE_SIZE) / 1024; // in case x86-64 is configured to use 2MB pages
   vm_usage     = vsize / 1024.0;
   resident_set = rss * page_size_kb;
}

string file_get_next_token_from_1st_match(string file, string token){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
    if(infile.fail()){
        return "no_file";
	// cout << "Error: Unable to open test.c.\n";
	// exit(1);
    }
    string next_token;
    while(!infile.eof())
    {
        infile >> next_token;        
        if(next_token.compare(token) == 0){
            break;
        }        
    }  
    if(infile.eof()) return "not_exist";
    infile >> next_token;  
    infile.close();
    return next_token;
}

string file_get_next_token_from_last_match(string file, string token){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
   if(infile.fail()) return "no_file";
    
    string next_token, value;
    while(!infile.eof())
    {
        infile >> next_token;        
        if(next_token.compare(token) == 0) infile >> value;
              
    }  
    
    infile.close();
    return value;
}

bool file_keyword_exist(string file, string keyword){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
    if(infile.fail()) return "no_file";

    string line;
    while( getline(infile,line) )         
        if( line.find(keyword)!=std::string::npos ) { infile.close(); return true;}

    infile.close();
    return false;
}

string file_get_line_from_1st_match(string file, string keyword, string terminate_string){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
    if(infile.fail()) return "no_file";

    string line; 
    string next_line = "";
    while( getline(infile,line) ){        
        if( line.find(terminate_string)!=std::string::npos ) break;
        if( line.find(keyword)!=std::string::npos ) { next_line = line; break;}
    }
    
    infile.close();
    return next_line;
}

string file_get_line_from_last_match(string file, string keyword, string terminate_string){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
    if(infile.fail()) return "no_file";
        
    string line, next_line;
    while( getline(infile, line) ) {
        if( line.find(terminate_string)!=std::string::npos ) break;
        if(line.find(keyword)!=std::string::npos) next_line = line;
    }
    
    infile.close();
    return next_line;
}

string file_get_next_line_to_last_match(string file, string keyword, string terminate_string){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
    if(infile.fail()) return "no_file";
        
    string line, next_line;
    while( getline(infile, line) ) {
        if( line.find(terminate_string)!=std::string::npos ) break;
        if(line.find(keyword)!=std::string::npos){ 
            getline(infile, line);
            next_line = line;
        }
    }
    
    infile.close();
    return next_line;
}

string file_get_next_matched_line_after_nth_token_match(string file, string keyword, string token_str, int n, string terminate_string){
    ifstream infile;
    infile.open(file.c_str(), ios::in);
    
    if(infile.fail()) return "no_file";
  
    int count = 0;    
    string line, next_line;
    while( getline(infile, line) ) {
        if( line.find(terminate_string)!=std::string::npos) break;
        else if(count < n && line.find(token_str)!=std::string::npos){ 
            count++;
        }
        else if(count >= n && line.find(keyword)!=std::string::npos) break;
    }
    
    infile.close();
    if(count == 0) return "";
    else if(count < n) return file_get_next_matched_line_after_nth_token_match(file, keyword, token_str, n-1, terminate_string);
    else if(line.find(keyword)==std::string::npos) return "";
    else return line;
}

int get_tot_icl(vector<int> macro){
    int tot_icl = 0; 
    vector<int> ic_atoms, causal_producers;    
    for(int i = 0; i < prf_size-1; i++){
        if(contains(macro, i) ) continue;
        if(have_common(straight_dependent_vector[i], macro))
            causal_producers.push_back(i);
    }
     
    for (vector<int>::iterator itp = causal_producers.begin(); itp!= causal_producers.end(); itp++){
        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){
            if(!contains(macro, *itc)) continue;
            tot_icl += sd_atoms[*itp][*itc].size();
            ic_atoms = union_set(ic_atoms, sd_atoms[*itp][*itc]);

        }
    }
    
    return tot_icl;
    // return ic_atoms.size();
}

vector<int> get_consumed_atoms(vector<int> macro){
    vector<int> consumed_atoms, causal_producers;    
    for(int i = 0; i < prf_size-1; i++){
        if(contains(macro, i) ) continue;
        if(have_common(straight_dependent_vector[i], macro))
            causal_producers.push_back(i);
    }
     
    for (vector<int>::iterator itp = causal_producers.begin(); itp!= causal_producers.end(); itp++){
        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){
            if(!contains(macro, *itc)) continue;
            consumed_atoms = union_set(consumed_atoms, sd_atoms[*itp][*itc]);
        }
    }
    
    return consumed_atoms;
}

int get_tot_ocl(vector<int> pol){
    int tot_ocl = 0;
    vector<int> oc_atoms;
    
    for (vector<int>::iterator it1 = pol.begin(); it1 != pol.end(); it1++){
        int producer = *it1;
        if(straight_dependent_vector[producer].empty()) continue;
        vector<int> consumer_vector = difference_set(straight_dependent_vector[producer], pol);
        if(consumer_vector.empty()) continue;
        for (vector<int>::iterator it2 = consumer_vector.begin(); it2 != consumer_vector.end(); it2++){
            int consumer = *it2;
            tot_ocl += sd_atoms[producer][consumer].size();
            oc_atoms = union_set(oc_atoms, sd_atoms[producer][consumer]);
        }                
    }

    return tot_ocl;
    // return oc_atoms.size();
}

vector<int> get_causally_produced_atoms(vector<int> pol){
    vector<int> causally_produced_atoms;
    for (vector<int>::iterator it1 = pol.begin(); it1 != pol.end(); it1++){
        int producer = *it1;
        if(straight_dependent_vector[producer].empty()) continue;
        vector<int> consumer_vector = difference_set(straight_dependent_vector[producer], pol);
        if(consumer_vector.empty()) continue;
        for (vector<int>::iterator it2 = consumer_vector.begin(); it2 != consumer_vector.end(); it2++){
            int consumer = *it2;
            causally_produced_atoms = union_set(causally_produced_atoms, sd_atoms[producer][consumer]);
        }                
    }
    
    causally_produced_atoms = difference_set(causally_produced_atoms, get_consumed_atoms(pol));

    return causally_produced_atoms;
}

vector<int> get_deleted_atoms(vector<int> pol){
    vector<int> deleted_atoms;
    for (vector<int>::iterator action = pol.begin(); action != pol.end(); action++){
        for (vector<int>::iterator atom = del_vector[*action].begin(); atom != del_vector[*action].end(); atom++){
            bool candidate = true;
            if(contains(deleted_atoms, *atom)){
                continue;
            }
            for (vector<int>::iterator other_action = pol.begin(); other_action != pol.end(); other_action++){
                if(*other_action == *action){
                    continue;
                }
                if(!have_path(prf_order_vector, *action, *other_action, prf_size)){
                    continue;
                }
                if(contains(add_vector[*other_action],*atom)){
                    candidate = false;
                    break;
                }
                
            } // other_action 
            
            if(candidate){
                deleted_atoms.push_back(*atom);
            }
            
        } // atom
    } // action
    
    return deleted_atoms;
}

vector<int> get_producer_consumer_atoms(vector<int> macro1, vector<int> macro2){
    vector<int> pc_atoms;
    vector<int> consumed_atoms = get_consumed_atoms(macro1);
    // cout << "macro: " << vector_to_string(macro1) << endl;
    // cout << "old: " << vector_to_string(get_consumed_atoms(macro1)) << endl;
    // cout << "new: " << vector_to_string(get_consumed_atoms_2(macro1)) << endl << endl;
    
    for (vector<int>::iterator it1 = macro1.begin(); it1 != macro1.end(); ++it1){
        int producer = *it1;
        if(straight_dependent_vector[producer].empty()) continue;
        vector<int> consumer_vector = intersection_set(straight_dependent_vector[producer], macro2);
        if(consumer_vector.empty()) continue;
        for (vector<int>::iterator it2 = consumer_vector.begin(); it2 != consumer_vector.end(); it2++){
            int consumer = *it2;
            pc_atoms = union_set(pc_atoms, sd_atoms[producer][consumer]);
        }                
    }
    pc_atoms = difference_set(pc_atoms, consumed_atoms);

    return pc_atoms;
}

vector<int> get_consumer_deleter_atoms(vector<int> macro1, vector<int> macro2){
    return intersection_set(get_consumed_atoms(macro1), get_deleted_atoms(macro2));
}

vector<int> get_deleter_producer_atoms(int i, int j){
    vector<int> dp_atoms;
    vector<int> dp = intersection_set(del_vector[i], add_vector[j]);
    if(!dp.empty()){  
        for(vector<int>::iterator it = dp.begin(); it != dp.end(); ++it){
            for(vector<int>::iterator itx = straight_dependent_vector[j].begin(); itx != straight_dependent_vector[j].end(); itx++){
                if(contains(sd_atoms[j][*itx], *it)){
                    dp_atoms.push_back(*it);
                    break;
                }
            }
        }

    }
    
    return dp_atoms;
}

vector<int> get_deleter_producer_atoms(vector<int> macro1, vector<int> macro2){
    vector<int> del_add, da_atoms;
    del_add = intersection_set(get_deleted_atoms(macro1), get_causally_produced_atoms(macro2));
    
    for (vector<int>::iterator it1 = del_add.begin(); it1 != del_add.end(); it1++){
        int atom = *it1;
        bool participation = false;
        for (vector<int>::iterator it2 = macro2.begin(); it2 != macro2.end(); it2++){
            int producer = *it2;
            if(!contains(add_vector[producer], atom))
                continue;
            for (vector<int>::iterator it3 = straight_dependent_vector[producer].begin(); it3 != straight_dependent_vector[producer].end(); it3++){
                int consumer = *it3;
                if(contains(sd_atoms[producer][consumer], atom) && !contains(macro2, consumer)){
                    participation = true;
                    da_atoms.push_back(atom);
                    break;
                }
            }
            if(participation)
                break;
        }
    }

    return da_atoms;
}

vector<int> get_deleter_knight_atoms(vector<int> macro1, vector<int> macro2){
    vector<int> deleter_knight, deleted_atoms;
    deleted_atoms = get_deleted_atoms(macro1);
    
    if(deleted_atoms.empty()) return deleter_knight;
    
    for(vector<int>::iterator it = macro2.begin(); it != macro2.end(); ++it)
        deleter_knight = union_set(deleter_knight, add_vector[*it]);
    
    deleter_knight = difference_set(deleter_knight, get_causally_produced_atoms(macro2));
    if(deleter_knight.empty()) return deleter_knight;
    deleter_knight = difference_set(deleter_knight, get_consumed_atoms(macro2));
    if(deleter_knight.empty()) return deleter_knight;
    deleter_knight = difference_set(deleter_knight, get_deleted_atoms(macro2)); 
    if(deleter_knight.empty()) return deleter_knight;
    deleter_knight = intersection_set(deleted_atoms, deleter_knight);
    if(deleter_knight.empty()) return deleter_knight;
    
    vector<int> consumer_vector, consumer_vector_temp; 
    for(int i = 1; i < prf_size-1; i++) consumer_vector.push_back(i);
    consumer_vector = difference_set(consumer_vector, macro1);
    consumer_vector = difference_set(consumer_vector, macro2);
    consumer_vector = difference_set(consumer_vector, redundant_actions);
    
    // consumer_vector_temp = consumer_vector;
    vector<int> temp_vector, del_vec;
    for (vector<int>::iterator it = consumer_vector.begin(); it != consumer_vector.end(); ++it){
        if(!have_common(pre_vector[*it], deleter_knight)){ 
            del_vec.push_back(*it);
            continue;
        }
        temp_vector.clear();
        temp_vector.push_back(*it);
        if(have_path(prf_order_vector, temp_vector, macro1, prf_size) || have_path(prf_order_vector, temp_vector, macro2, prf_size)){
            del_vec.push_back(*it);
            continue;
        }
    }  
    
    remove_vec(consumer_vector, del_vec); del_vec.clear();
    
    vector<int> *bu_sd;
    bu_sd = reverse_order_vector(straight_dependent_vector);
    
    vector<int> deleter_knight_temp = deleter_knight;
    
    for (vector<int>::iterator it1 = deleter_knight_temp.begin(); it1 != deleter_knight_temp.end(); ++it1){
        int dk_atom = *it1;
        bool dk_guard = false;
        for (vector<int>::iterator it2 = consumer_vector.begin(); it2 != consumer_vector.end(); ++it2){            
            int consumer = *it2;
            vector<int> producer_vector = bu_sd[consumer];
            vector<int> pro_con;
            for (vector<int>::iterator it3 = producer_vector.begin(); it3 != producer_vector.end(); ++it3){
                int producer = *it3;
                if(!contains(sd_atoms[producer][consumer],dk_atom)) continue;
                pro_con.clear();
                pro_con.push_back(producer);
                if(have_path(prf_order_vector, macro1, pro_con, prf_size)) continue;
                
                pro_con.push_back(consumer);
                
                bool auto_guard = false;
                for(int i = 0; i < mac_tot; i++){
                    if(have_subset(macro_clusters[i], pro_con) && !have_common(macro_clusters[i], macro1) ){ 
                        auto_guard = true;     
                        break;
                    }
                }
                if(!auto_guard){
                    dk_guard = true;
                    break;
                }
            }
            
            if(dk_guard) break;
        
        }
        if(!dk_guard) 
            remove_val(deleter_knight, dk_atom);
	// deleter_knight.remove(dk_atom);
    }

    delete [] bu_sd;

    return deleter_knight;
}

void write_dot_file(string file_name, vector<int> traverse_order, vector<int> *label){
    ofstream myfile (file_name.c_str());
  
    if (!myfile.is_open())
        cout << "Unable to open file: " << file_name << endl;
  
    myfile << "digraph { \n";
    myfile << "node [width=0,height=0]; \n";    
    vector<int> traverse_order_unique = traverse_order;
    unique_vec(traverse_order_unique);
    sort(traverse_order_unique.begin(), traverse_order_unique.end());

    for (int i = 0; i < traverse_order_unique.size(); i++){ 
        if(label[traverse_order_unique[i]].empty())
            myfile << traverse_order_unique[i] << " [label=\" x \"]; \n";
        else{
            myfile << traverse_order_unique[i] << " [label=\"" ;
	    // for (vector<int>::iterator it = label[traverse_order_unique[i]].begin(); it != label[traverse_order_unique[i]].end(); it++)
	    //     myfile << instance.atoms[*it].name << "\\n";
            myfile << vector_to_string(label[traverse_order_unique[i]], " ");
            myfile << "\"]; \n";
        }
    }

    vector<int>::iterator it = lin_actions.begin();
    for (int i = 0; i < traverse_order.size()-1; i++) {        
        myfile << traverse_order[i] << "->" << traverse_order[i+1] << " [label=\"" << *it << "(" << instance.actions[theplan[*it]].cost << "):";
	// myfile << instance.actions[theplan[*it]].name;
        myfile << "\"]; \n";
        ++it;
    }
    
    myfile << "}";

    myfile.close();    
}

void write_dot_file_atom_transition(string file_name, vector<int> atom_vectors){
    ofstream myfile (file_name.c_str());

    if (!myfile.is_open())
        cout << "Unable to open file: " << file_name << endl;
  
    myfile << "digraph { \n";
    myfile << "node [width=0,height=0]; \n";    
    
    
    for (vector<int>::iterator it = atom_vectors.begin(); it != atom_vectors.end(); it++)
        myfile << *it << " [label=\"" << *it << "\"]; \n";
    // myfile << *it << " [label=\"" << *it << ":" << instance.atoms[*it].name  << "\"]; \n";
    vector<int> atom_vector;
    for (vector<int>::iterator it = lin_actions.begin(); it != lin_actions.end(); it++)
        atom_vector.push_back(*it);
    
    for (int x = 0; x < atom_vector.size(); x++) {
        int i = atom_vector[x];
        int j = atom_vector[x-1];
	// for (int i = 0; i < theplan.size(); i++) {
        vector<int> atoms_from;
        if(i == 0)
            atoms_from = get_active_init_atoms();
        else
            atoms_from = get_vector(instance.actions[theplan[j]].add);
        vector<int> atoms_to = get_vector(instance.actions[theplan[i]].add);
        
        for (vector<int>::iterator itf = atoms_from.begin(); itf != atoms_from.end(); itf++)
            for (vector<int>::iterator itt = atoms_to.begin(); itt != atoms_to.end(); itt++)
                myfile << *itf << "->" << *itt << " [label=\"" << i << ":" << instance.actions[theplan[i]].cost << "\"]; \n";
	// myfile << *itf << "->" << *itt << " [label=\"" << i << ":" << instance.actions[theplan[i]].name  << "\"]; \n";
    }
    
    myfile << "}";

    myfile.close();    
}

void write_dot_file_details(string file_name, vector<int> state_order, vector<int> *label){
    ofstream myfile (file_name.c_str());
  
    if (!myfile.is_open())
        cout << "Unable to open file: " << file_name << endl;
  
    myfile << "digraph { \n";
    myfile << "node [width=0,height=0]; \n";    
    vector<int> traverse_order_unique = state_order;
    unique_vec(traverse_order_unique);
    sort(traverse_order_unique.begin(), traverse_order_unique.end());

    for (int i = 0; i < traverse_order_unique.size(); i++){ 
        string temp_str;
        for (vector<int>::iterator it = label[traverse_order_unique[i]].begin(); it != label[traverse_order_unique[i]].end(); it++){
            string s;
            stringstream ss;
            ss << *it;
            ss >> s;
            temp_str += s + ":" + instance.atoms[*it].name->to_string(0) + " \\n";
        }  

        if(temp_str.empty())
            myfile << traverse_order_unique[i] << " [label=\" x \"]; \n";
        else
            myfile << traverse_order_unique[i] << " [label=\"" << temp_str  << "\"]; \n";
        temp_str.clear();
    }

    for (int i = 0; i < state_order.size()-1; i++) 
      // myfile << traverse_order[i] << "->" << traverse_order[i+1] << " [label=\"" << i  << "\"]; \n";
      // myfile << traverse_order[i] << "->" << traverse_order[i+1] << ";\n";
        myfile << state_order[i] << "->" << state_order[i+1] << " [label=\"" << i  << ":" << instance.actions[theplan[i]].cost << ":" << instance.actions[theplan[i]].name  << "\"]; \n";
    
    myfile << "}";

    myfile.close();    
}

void write_dot_file(string file_name, vector<int> *dot_vector, int length){
  ofstream myfile (file_name.c_str());
  
  if (myfile.is_open()){
    myfile << "digraph { \n";
    myfile << "node [width=0,height=0]; \n";    
    
    for (int i = 0; i < length; i++) {
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
	// myfile << i << " [label=\"" << instance.actions[theplan[i]].name  << "\"]; \n";
        myfile << i << " [label=\"" << i  << "\"]; \n";
    }
  
    for (int i = 0; i < length-1; i++) {
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
        for (vector<int>::iterator it = dot_vector[i].begin(); it != dot_vector[i].end(); it++){
          myfile << i << "->" << *it << ";\n";
        }        
    }
    
    myfile << "}";
    
    myfile.close();
  }
  else cout << "Unable to open file";
}

void write_dot_block_file(string file_name, vector<int> *dot_vector, vector<int> *block_vector, int length){
  ofstream myfile (file_name.c_str());
    
  if (myfile.is_open()){
    myfile << "digraph { \n";
    myfile << "node [width=0,height=0]; \n";    
    
    for (int i = 0; i < length; i++) {
        string bv_st = vector_to_string(block_vector[i], " ");
        myfile << i << " [label=\"b" << i << "( " << bv_st  << ")\"]; \n";
    }
  
    for (int i = 0; i < length-1; i++) {
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
        for (vector<int>::iterator it = dot_vector[i].begin(); it != dot_vector[i].end(); it++){
          myfile << i << "->" << *it << ";\n";
        }        
    }
    
    myfile << "}";
    
    myfile.close();
  }
  else cout << "Unable to open file";
}

// == including the action names
//
//void write_file(string file_name, vector<int> *dot_vector, float flex, string details){
//  ofstream myfile (file_name.c_str());
//  int length;
//  if(file_name.find("my_SD")!=string::npos){
//      length = prf_size+1;
//  }
//  else{
//      length = prf_size;
//  }
//  
//  if (myfile.is_open()){
//    myfile << "digraph { \n";
//    myfile << "node [width=0,height=0]; \n";  
//    myfile << "x [shape=polygon,sides=4,color=lightblue,style=filled, label=\"" << "File: " << file_name << "\\nFlex: " << flex << "\\n" << details << "\"]; \n";
////    myfile << "y [shape=polygon,sides=4,color=lightblue,style=filled, label=\"" << "Details: " << details << "\"]; \n";
//    myfile << "x->0 [style=invis];\n";
//
//    
//    for (int i = 0; i < length; i++) {
//        if(dot_vector[i].front() == -1)
//            continue;
//        if(i == prf_size)
//            myfile << i << " [label=\"" << "goal"  << "\"]; \n";
//        else
//            myfile << i << " [label=\"" << i << ":" << instance.actions[theplan[i]].name  << "\"]; \n";
//    }
//  
//    for (int i = 0; i < length-1; i++) {
//        if(dot_vector[i].front() == -1)
//            continue;
//        for (vector<int>::iterator it = dot_vector[i].begin(); it != dot_vector[i].end(); it++){
//          myfile << i << "->" << *it << ";\n";
//        }        
//    }
//    
//    myfile << "}";
//    
//    myfile.close();
//  }
//  else cout << "Unable to open file";
//}

vector<int> print_clusters(ofstream &myfile, int c, vector<int> queue){
    remove_val(queue, c);
    if(block_tree[c].empty()){
        myfile << "subgraph cluster_" << c << " { " << endl;
        for (vector<int>::iterator it = mfb[c].begin(); it != mfb[c].end(); ++it){
            myfile << *it << "; ";
        }
        myfile << " }" << endl;
        return queue;
    }
    myfile << "subgraph cluster_" << c << " { " << endl;
    for (vector<int>::iterator it = block_tree[c].begin(); it != block_tree[c].end(); ++it){
        queue = print_clusters(myfile, *it, queue);        
    }
    vector<int> reaining_elements = mfb[c];
    for (vector<int>::iterator it = block_tree[c].begin(); it != block_tree[c].end(); ++it)
        reaining_elements = difference_set(reaining_elements, mfb[*it]);
    
    for (vector<int>::iterator it = reaining_elements.begin(); it != reaining_elements.end(); ++it)
        myfile << *it << "; ";
    myfile << endl << " }" << endl;

   return queue;
}

void write_file(string file_name, vector<int> *dot_vector, float flex, string details){
  ofstream myfile (file_name.c_str());
  
  if (myfile.is_open()){
    myfile << "digraph { \n";
    myfile << "node [style=dotted,width=0,height=0]; \n";  
    // myfile << "x [shape=polygon,sides=4,color=lightblue,style=filled, label=\"" << "File: " << file_name << "\\nFlex: " << flex << "\\n" << details << "\"]; \n";
    myfile << "x [shape=polygon,sides=4,color=lightblue,style=filled, label=\"" << "File: " << file_name << "\\nFlex: " << flex << "\\n" << details << "\"]; \n";
    // myfile << "y [shape=polygon,sides=4,color=lightblue,style=filled, label=\"" << "Details: " << details << "\"]; \n";
    myfile << "x->0 [style=invis];\n";

    //    if(mfb_tot > 0){
    //        for (int g = 0; g < mfb_tot; g++) {
    //            myfile << "subgraph cluster_" << g << " { \n";
    //            for (vector<int>::iterator it = mfb[g].begin(); it != mfb[g].end(); it++)
    //                myfile << *it << "; ";
    //            myfile << "} \n";
    //        }
    //    }
    if(mfb_tot > 0){
        vector<int> queue;
        for (int i = 0; i < mfb_tot; i++)
          queue.push_back(i);
        while(!queue.empty())
             queue = print_clusters(myfile, queue.front(), queue);
    }
    
    // cout << "prf_size: " << prf_size << endl;
    
    for (int i = 0; i < prf_size; i++) {
      // cout << i << endl;
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
        if(i == 0)
            myfile << i << " [label=\"" << "Init"  << "\"]; \n";        
        else if(i == prf_size-1)
            myfile << i << " [label=\"" << "Goal"  << "\"]; \n";        
        else
            myfile << i << " [label=\"" << i << "(" << instance.actions[theplan[i-1]].cost  << ")" <<  "\"]; \n";
	// myfile << i << " [label=\"" << i << "(" << instance.actions[theplan[i-1]].cost  << "):" << instance.actions[theplan[i-1]].name  << "\"]; \n";
    }
    
    for (int i = 0; i < prf_size-1; i++) {
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
        for (vector<int>::iterator it = dot_vector[i].begin(); it != dot_vector[i].end(); it++){
            // new
            vector<int> from_macro, to_macro;
            from_macro.push_back(i);
            to_macro.push_back(*it);
            
            vector<int> pc, cd, dp;            
            pc = get_producer_consumer_atoms(from_macro, to_macro);            
            cd = get_consumer_deleter_atoms(from_macro, to_macro);
            dp = get_deleter_producer_atoms(from_macro, to_macro);
            
            string dependencies;
            if(!pc.empty()) dependencies += "pc:" + vector_to_string(pc, " ") + "\\n";
            if(!cd.empty()) dependencies += "cd:" + vector_to_string(cd, " ") + "\\n";
            if(!dp.empty()) dependencies += "dp:" + vector_to_string(dp, " ") + "\\n";
            
            if(dependencies.empty()){ 
                dependencies += "x";  
            }
            
            myfile << i << "->" << *it << " [label=\"" << dependencies  << "\"]; \n";       
            
            from_macro.clear();
            to_macro.clear();
          
        }        
    }
    
    // extra task
    myfile << "node [shape=plaintext, fontsize=16]; \n";  
    for (int i = 1; i < prf_size-1; i++) {
        // if(dot_vector[i].front() == -1)
        //     continue;
        myfile << prf_size+i << " [label=\"" << i << "(" << instance.actions[theplan[i-1]].cost  << "):" << instance.actions[theplan[i-1]].name  << "\"]; \n";
    }
    
    for (int i = 1; i < prf_size-2; i++) {
      //   if(dot_vector[i].front() == -1)
      //       continue;
        myfile << prf_size+i << "->" << prf_size+i+1 << " [style=dotted]; \n";
    }
    // end-extra-task
    
    myfile << "}";
    
    myfile.close();
  }
  else cout << "Unable to open file";
}

vector<int> get_on_off_status(string filename, string keyword, int size){
    string str = file_get_line_from_1st_match(filename, keyword , "#EOF#");
    istringstream iss(str);
    vector<string> tokens;
    copy(istream_iterator<string>(iss),
         istream_iterator<string>(),
         back_inserter<vector<string> >(tokens));  
    vector<int> vec_on_off;
    for(int i=1; i<=size; i++){
        istringstream iss(tokens[i]);
        int x;
        iss >> x;
        vec_on_off.push_back(x);
    }
    return vec_on_off;
}

vector<string> split_string(string line, string delimiter){
    char *p;
    vector<string> tokens;
    
    p = strtok( &line[0], delimiter.c_str() );
    while(p != NULL){
        tokens.push_back(TrimStr(p));
        p = strtok( NULL, delimiter.c_str() );        
    }
    
    return tokens;
}

string split_string_2(string line, string delimiter){
    vector<string> tokens = split_string(line, delimiter);
    
    string str = tokens[0];
    for (int i = 1; i < tokens.size(); i++)
        str = str + " " + tokens[i];
    
    return str;
}

void build_transition_models(char *argv[]){
    
    string plan_loc(argv[3]);
    
    // state_model ====================================  
    //  string model_loc = "stm.dot"; // state_transition_model
    //  string cycle_loc = plan_loc + "_sx.cycle";
    //  string cycle_loc_non_zero = plan_loc + "_nono.cycle";
    //  string cycle_finder_loc = planner_location + "/dot_find_cycles.py";  
    //  create_state_transition_model(argv, model_loc); // new
    //  create_state_transition_model_2(argv, model_loc);
  
  
    // single_atom_model =====================================
    //  model_loc = "atm.dot"; // atom_transition_model
    //  string cycle_loc = plan_loc + "_atm.cycle";
    //  string cycle_loc_non_zero = plan_loc + "_nono.cycle";
    //  string cycle_finder_loc = planner_location + "/dot_find_cycles.py";  
    //  create_atom_transition_model(argv, model_loc); // new
  
  
    //  string com = cycle_finder_loc + " " + model_loc + " > " + cycle_loc;  
    //  int comout = system(com.c_str());   
    //  remove_zero_cost_cycles(model_loc, cycle_loc, cycle_loc_non_zero);

    // vectoring atoms and actions
  
    string atomfile_loc =  "atoms.txt";
    string actionfile_loc =  "actions.txt";
    ofstream atomfile (atomfile_loc.c_str());
    ofstream actionfile (actionfile_loc.c_str());
  
    vector<int> all_atoms = get_all_atoms();
    for (vector<int>::iterator it = all_atoms.begin(); it != all_atoms.end(); it++)
      atomfile << *it << ":" << instance.atoms[*it].name << endl;            
  
    for (int i = 0; i < theplan.size(); i++)
      actionfile << i+1 << ":" << instance.actions[theplan[i]].cost << ":" << instance.actions[theplan[i]].name << endl;  
}

vector<int> get_vector(HSPS::index_set iset){
    vector<int>  l ;
    for(int x = 0; x < iset.length(); x++){
        l.push_back(iset[x]);
    }
    return l;
}

void print_2d_string(string *str, int size, ofstream *myoutput){
  for (int i = 0; i < size ; i++ ){
            cout << str[i] << endl;   
            *myoutput << str[i] << "\n";
  }
}


void print_vector(vector<int> pl){
  for (vector<int>::iterator it = pl.begin(); it != pl.end(); it++){
            cout << " " << *it;            
  }
}

void print_vector_to_file(vector<int> pl, ofstream &myoutput){
  for (vector<int>::iterator it = pl.begin(); it != pl.end(); it++){
            myoutput << " " << *it;            
  }
}

string get_dotted_string_vector(vector<int> pl){
  if(pl.empty()) return ".";
  string str; // = ":";
  stringstream ss;
  for (vector<int>::iterator it = pl.begin(); it != pl.end(); ++it){      
      ss << *it;              
      ss << ".";      
  }  
  str += ss.str();
  str.erase(str.end()-1);  
  return str;
}

void print_vector(vector<int> *prf_order_vector, ofstream *myoutput){
      for (int i = 0; i < prf_size-1;i++){
        cout << "Action " << i << " -> ";
        *myoutput << "Action " << i << " -> ";
        for (vector<int>::iterator it = prf_order_vector[i].begin(); it != prf_order_vector[i].end(); it++){
            cout << " " << *it;
            *myoutput << " " << *it;
        }
        cout << std::endl;
        *myoutput << "\n";
      }  
}
void print_sd_vector(vector<int> *sd_vector, ofstream *myoutput){
      for (int i = 0; i <= prf_size;i++){
        cout << "Action " << i << " -> ";
        *myoutput << "Action " << i << " -> ";
        for (vector<int>::iterator it = sd_vector[i].begin(); it != sd_vector[i].end(); it++){
            cout << " " << *it;
            *myoutput << " " << *it;
        }
        cout << std::endl;
        *myoutput << "\n";
      }  
}
void print_2d_vector(vector<int> *prf_order_vector){
      for (int i = 0; i < prf_size;i++){
        cout << "Action " << i << " -> ";
        for (vector<int>::iterator it = prf_order_vector[i].begin(); it != prf_order_vector[i].end(); it++){
            cout << " " << *it;
        }
        cout << std::endl;
      }  
}
void print_2d_vector(vector<int> *ol, int size, string sep){
      for (int i = 0; i < size; i++){
        cout << i << " " << sep << " ";
        for (vector<int>::iterator it = ol[i].begin(); it != ol[i].end(); it++){
            cout << " " << *it;
        }
        cout << std::endl;
      }  
}
void print_2d_vector_to_file(vector<int> *ol, int size, string sep, ofstream &myoutput){
      for (int i = 0; i < size; i++){
        myoutput << i << " " << sep << " ";
        for (vector<int>::iterator it = ol[i].begin(); it != ol[i].end(); it++){
            myoutput << " " << *it;
        }
        myoutput << std::endl;
      }  
}
void print_sd_vector(vector<int> *sd_vector){
      for (int i = 0; i < prf_size; i++){
        cout << "Action " << i << " -> ";
        for (vector<int>::iterator it = sd_vector[i].begin(); it != sd_vector[i].end(); it++){
            cout << " " << *it;
        }
        cout << std::endl;
      }  
}

vector<int> get_all_atoms(){
    vector<int> temp_atoms;
    vector<int> all_atoms = get_vector(instance.init_atoms);
    for (int i = 1; i < prf_size-1; i++)
        all_atoms.insert(all_atoms.end(), add_vector[i].begin(), add_vector[i].end());
    all_atoms.insert(all_atoms.end(), instance.goal_atoms.begin(), instance.goal_atoms.end());
    unique_vec(all_atoms);    
    return all_atoms;
}

vector<int> get_active_init_atoms(){
          
    vector<int> init_atoms =  get_vector(instance.init_atoms);
    vector<int> other_atoms;    
    for (int i = 0; i < theplan.size(); i++){
      // vector<int> temp_atoms = get_vector(instance.actions[theplan[i]].add);
        other_atoms.insert(other_atoms.end(), instance.actions[theplan[i]].add.begin(), instance.actions[theplan[i]].add.end());
    }
    // other_atoms.sort();
    unique_vec(other_atoms);
    
    // cout << vector_to_string(init_atoms) << endl;
    // cout << vector_to_string(other_atoms) << endl;
    
    init_atoms = intersection_set(init_atoms, other_atoms);
    
    // cout << vector_to_string(init_atoms) << endl;
    
    return init_atoms;
}

void create_state_transition_model(char *argv[], string model_loc){
    string dom(argv[1]);
    string prob(argv[2]);
    string plan(argv[3]);
    
    vector<int> *state_vector;
    state_vector = new vector<int> [theplan.size()+1];
    
    vector<int> temp;
    int top = 0;
    vector<int> state_traverse_order;
    
    state_traverse_order.push_back(top);
    state_vector[top++] = get_active_init_atoms();
    
    for (vector<int>::iterator it = lin_actions.begin(); it != lin_actions.end(); it++){
        int i = *it;
	// for (int i = 0; i < theplan.size(); i++) {
        temp.clear();
        temp = get_vector(instance.actions[theplan[i]].add);
        bool exist = false;
        for (int j = 0; j < top; j++){
            if(equal_set(temp, state_vector[j])){
                state_traverse_order.push_back(j);
                exist = true;
                break;
            }
        }
        
        if(!exist){
            state_traverse_order.push_back(top);
            state_vector[top++] = temp;
        }                
        
    }    
    write_dot_file(model_loc, state_traverse_order, state_vector);
    // write_dot_file_details(plan+"_sy.dot", state_traverse_order, state_vector);
}

void create_atom_transition_model(char *argv[], string model_loc){
    vector<int> atom_vector = get_active_init_atoms();
    for (int i = 0; i < theplan.size(); i++) {
      // vector<int> temp = get_vector(instance.actions[theplan[i]].add);
        atom_vector.insert(atom_vector.end(), instance.actions[theplan[i]].add.begin(), instance.actions[theplan[i]].add.end());
    }
    // atom_vector.sort();
    unique_vec(atom_vector); //.unique();
    
    write_dot_file_atom_transition(model_loc, atom_vector);
}

void remove_zero_cost_cycles(string model_loc, string cycle_loc, string cycle_loc_non_zero){
    ifstream file_in_model(model_loc.c_str());
    ifstream file_in_cycle(cycle_loc.c_str());
    ofstream file_out_cycle(cycle_loc_non_zero.c_str());
    
    string line;    
    while( getline(file_in_cycle,line) ){
        if (line.find("[")==string::npos) continue;
        vector<string> token_vector = split_string(line, "'");
        vector<string> atom_vector;
        
        for(int i = 1; i < token_vector.size(); i+=2){
            atom_vector.push_back(token_vector[i]);
        }
        
        bool cycle_with_cost = false;
        for(int i = 0; i < atom_vector.size(); i++){
            string edge = atom_vector[i] + "->" + atom_vector[(i+1)%atom_vector.size()];
            string line2;    
            file_in_model.clear();
            file_in_model.seekg(0, ios::beg);
            while( getline(file_in_model, line2) ){
                if (line2.find(edge)==string::npos) continue;
                std::size_t p = line2.find_first_of("\":");
                std::size_t q = line2.find_first_of("\":", p+1);
                string action_str = line2.substr(p+1, q-p-1);
		// cout << "action_str:" << action_str << endl;
                
                stringstream ss;                
                int aid;            
                ss << action_str;
                ss >> aid;
                ss.clear();
		// cout << "cost of [" << aid << "] for the edge [" << edge << "]: " << instance.actions[theplan[aid]].cost << endl;
                if(instance.actions[theplan[aid]].cost > 0){
                    cycle_with_cost = true;
                    
                    vector<int> atom_vector_int;
                    for(int i = 0; i < atom_vector.size(); i++){
                        stringstream ss; 
                        int x;
                        ss << atom_vector[i];
                        ss >> x;
                        atom_vector_int.push_back(x);
                        ss.clear();
                    }
                    sort(atom_vector_int.begin(), atom_vector_int.end());
                    
                    for(int i = 0; i < atom_vector_int.size(); i++)
                        file_out_cycle << atom_vector_int[i] << " ";
                    file_out_cycle << endl;
                    break;
                }
            } // end_while
            if(cycle_with_cost) break;
        } // end_for
        
        
    } // end_while
    file_in_model.close();
    file_in_cycle.close();
    file_out_cycle.close();
}

vector<int> get_pom_values(string token_vector){
    string sval;
    vector<int> pom;
    stringstream ss;
    ss << token_vector;
    while(ss >> sval){
        stringstream ss2;
        int start_val, end_val;
        if(sval.find("~")!=string::npos){
            vector<string> tokens = split_string(sval, "~");                
            ss2 << tokens[0];                
            ss2 >> start_val;
            ss2.clear();
            ss2 << tokens[1];                
            ss2 >> end_val;
            ss2.clear();
            if(end_val < start_val){ 
                pom.clear();
                return pom;
            }
            for(int i = start_val ; i <= end_val; i++)
                pom.push_back(i);
        }
        else{
            ss2 << sval;
            ss2 >> start_val;
            ss2.clear();
            pom.push_back(start_val);
        }
    }
    ss.clear();
    return pom;
}

void macro_dependency_user_interface(){
    string line;
    vector<int> pom1, pom2;
    vector<int> *m1, *m2;
    cin.ignore();
    
    do{
        pom1.clear();
        pom2.clear();
        line.clear();
        
        
        cout << endl << "print macro(s):"; 
        
        getline(cin, line);
        
	// cout <<  "line:" << line << endl;

        if(line.find("#")!=string::npos) return;

        if(line.find("|")!=string::npos){
            vector<string> token_vector = split_string(line, "|");        
            pom1 = get_pom_values(token_vector[0]);
            pom2 = get_pom_values(token_vector[1]);
        }
        else pom1 = get_pom_values(line);

        

        if(pom1.empty()) continue;

        m1 = macro_vector(pom1);

        cout << endl << "Macro (" ;
        print_vector(pom1);
        cout << " ):" << endl;

        cout << "# pre: "; print_vector(m1[0]); cout << endl;
        for(vector<int>::iterator it = m1[0].begin(); it != m1[0].end(); it++)
            cout << *it << ": " << instance.atoms[*it].name << endl;
        cout << "# add: "; print_vector(m1[1]); cout << endl;
        for(vector<int>::iterator it = m1[1].begin(); it != m1[1].end(); it++)
            cout << *it << ": " << instance.atoms[*it].name << endl;
        cout << "# del: "; print_vector(m1[2]); cout << endl;
        for(vector<int>::iterator it = m1[2].begin(); it != m1[2].end(); it++)
            cout << *it << ": " << instance.atoms[*it].name << endl;

        if(!pom2.empty()){ 

            m2 = macro_vector(pom2);
            cout << endl << "Macro (" ;
            print_vector(pom2); 
            cout << " ):" << endl;

            cout << "# pre: "; print_vector(m2[0]); cout << endl;
            for(vector<int>::iterator it = m2[0].begin(); it != m2[0].end(); it++)
                cout << *it << ": " << instance.atoms[*it].name << endl;
            cout << "# add: "; print_vector(m2[1]); cout << endl;
            for(vector<int>::iterator it = m2[1].begin(); it != m2[1].end(); it++)
                cout << *it << ": " << instance.atoms[*it].name << endl;
            cout << "# del: "; print_vector(m2[2]); cout << endl;
            for(vector<int>::iterator it = m2[2].begin(); it != m2[2].end(); it++)
                cout << *it << ": " << instance.atoms[*it].name << endl;

            vector<int> pc, ct, tp;
            pc = intersection_set(m1[1], m2[0]);
            ct = intersection_set(m1[0], m2[2]);
            tp = intersection_set(m1[2], m2[1]);

            cout << endl;
            cout << "Dependencies ..." << endl;
            if(!pc.empty()){
                cout << "PC: " << vector_to_string(pc, " ") << endl;
                for(vector<int>::iterator it = pc.begin(); it != pc.end(); it++)
                    cout << *it << ": " << instance.atoms[*it].name << endl;
            }
            if(!ct.empty()){
                cout << "CT: " << vector_to_string(ct, " ") << endl;
                for(vector<int>::iterator it = ct.begin(); it != ct.end(); it++)
                    cout << *it << ": " << instance.atoms[*it].name << endl;
            }
            if(!tp.empty()){
                cout << "TP: " << vector_to_string(tp, " ") << endl;
                for(vector<int>::iterator it = tp.begin(); it != tp.end(); it++)
                    cout << *it << ": " << instance.atoms[*it].name << endl;
            }
        }
        
    } while(true);

}


void have_test(){  
  //test work ================
  vector<int> l1, l2;
  l1.push_back(5);
  //  l1.push_back(21);
  //  l1.push_back(2);
  //  l1.push_back(3);
  //  l1.push_back(4);
  //  l1.push_back(5);
  //  
  //  l2.push_back(11);
  //  l2.push_back(12);
  //  l2.push_back(13);
  //  l2.push_back(14);
  l2.push_back(6);
  //  l2.push_back(7);
  //  l2.push_back(8);
  //  l2.push_back(9);
  //  l2.push_back(1);

  vector<int> *m1 = macro_vector(l1);
  vector<int> *m2 = macro_vector(l2);
    
  vector<int> pa, ap, pd, dp, ad, da;
    
  ap = intersection_set(m1[1], m2[0]); //AP
  ad = intersection_set(m1[1], m2[2]); //AD
  pd = intersection_set(m1[0], m2[2]); //PD
  pa = intersection_set(m1[0], m2[1]); //PA
  da = intersection_set(m1[2], m2[1]); //DA
  dp = intersection_set(m1[2], m2[0]); //DP
    
  cout << "AP: "; print_vector(ap); cout << endl;
  cout << "PA: "; print_vector(pa); cout << endl;
  cout << "AD: "; print_vector(ad); cout << endl;
  cout << "DA: "; print_vector(da); cout << endl;
  cout << "PD: "; print_vector(pd); cout << endl;
  cout << "DP: "; print_vector(dp); cout << endl;
  // END Testing ####################
}

void print_action_dependencies_to_file(){
    write_file(temp_dir + "/prf_simplified.dot", prf_order_vector, flex, "");
    write_file(temp_dir + "/prf_full.dot", prf_full, flex, "");
    write_file(temp_dir + "/SD.dot", straight_dependent_vector, flex, "");
}

void set_action_path(){
    for (int i = 0; i < prf_size; i++)
        fill(order_all[i].begin(), order_all[i].end(), false);

    for (int i = 0; i < prf_size-1; i++){
      for (vector<int>::iterator jt = prf_order_vector[i].begin(); jt != prf_order_vector[i].end(); jt++){  
            if(*jt == -1) continue;
	    // action_path_bit.set((i*prf_size) + *jt);
            order_all[i][*jt] = true;
            
            // if jt->x then i->x
            vector<int> actions;
            actions.push_back(*jt);
            
            for (int x = 0; x < prf_size-1; x++){
                if(order_all[i][x])
                    continue;
                if(order_all[*jt][x]){
                    order_all[i][x] = true;
                    actions.push_back(x);
                }
            }
            
            // if x->i then x->jt
            for (int x = 0; x < prf_size-1; x++){                
                if(order_all[x][i]){                    
                    for (vector<int>::iterator p = actions.begin(); p != actions.end(); p++){ 
                        if(order_all[x][*p]) continue;                    
                        order_all[x][*p] = true;
                    }
                }
            }
            actions.clear();
            
      }          
  }
}

void print_file_contents(string file){
  ifstream fin;                   // Initialise filestream object.
  char c;
  
  fin.open(file.c_str(), ios::in);    // Open an input filestream.
  
  // Check if file opened.
  // fin.fail() returns 1 if there is a fail in the filestream.
  if(fin.fail())
  {
    cout << "Error: Unable to open test.c.\n";
    exit(1);
  }
  
  fin.get(c);                    // Get first character for kicks.
   
  // While the stream hasn't failed or reached the end of file, read and display.
  while(!fin.fail() && !fin.eof())
  {
    cout << c;                 // Display character.
    fin.get(c);                 // Get the next character from the stream.
  }
  
  fin.close();                  // Always close the stream once done.
    
}

void push_pom(vector<int> block_ref, vector<int>* pom_ids){
    for (vector<int>::iterator itb = block_ref.begin(); itb != block_ref.end(); itb++){                     
        (*pom_ids).push_back(*itb);
	// for (vector<int>::iterator itm = merged_fob[*itb].begin(); itm != merged_fob[*itb].end(); itm++)
	// (*pom).push_back(*itm);  
    }
}

bool candidate_exist(vector<int> block_vector, vector<int> pom1_ids, vector<int> pom2_ids, vector<int>* c_window, vector<int>* c_pred, vector<int>* c_cons, int c_tot){
    bool included = false;
    for(int x = 0; x < c_tot; x++){ 
        if(equal_set(c_window[x], block_vector) && equal_set(c_pred[x], pom1_ids) && equal_set(c_cons[x], pom2_ids) ){
            included = true;
            break;
        }                    
    }   
    return included;
}

void push_candidate(vector<int> block_vector, vector<int> pom1_ids, vector<int> pom2_ids, vector<int>* c_window, vector<int>* c_pred, vector<int>* c_cons, vector<int>* c_length, vector<double>* c_cost, int plen, double pcost, double adhval, int* c_tot){
    //    bool included = false;
    //    for(int x = 0; x < *c_tot; x++){ 
    //        if(equal_set(c_window[x], block_vector) && equal_set(c_pred[x], pom1_ids) && equal_set(c_cons[x], pom2_ids) ){
    //            included = true;
    //            break;
    //        }                    
    //    }                
    //    if(!included){                
          
    //        double cst = 0;
    //        int len = 0;
    //        for (vector<int>::iterator it = block_vector.begin(); it != block_vector.end(); it++){
    //           len += merged_fob[*it].size();
    //           cst += action_set_cost(merged_fob[*it]);
    //        }
    //        cout << "cst: " << cst << endl;
    if(pcost == 0) return;

    c_window[*c_tot] = block_vector;
    c_pred[*c_tot] = pom1_ids;
    c_cons[*c_tot] = pom2_ids;
    c_length[*c_tot].push_back(plen); 
    c_cost[*c_tot].push_back(pcost);
    c_cost[*c_tot].push_back(adhval);
    (*c_tot)++;
    //    }
    
    //    if(!included){                
    //        c_window[*c_tot] = block_vector;
    //        c_pred[*c_tot] = pom1_ids;
    //        c_cons[*c_tot] = pom2_ids;
    //        double cst = 0;
    //        int len = 0;
    //        for (vector<int>::iterator it = c_window[*c_tot].begin(); it != c_window[*c_tot].end(); it++){
    //           len += merged_fob[*it].size();
    //           cst += action_set_cost(merged_fob[*it]);
    //        }
    //        c_length[*c_tot].push_back(len); 
    //        c_cost[*c_tot].push_back(cst);
    //        (*c_tot)++;
    //    }
}

// for local

int highest_lower_bound(string prob){
    char *p;
    int hlb;
    
    string *tokens;
    tokens = new string[6];

    int ti = 0;
    
    p = strtok( &prob[0], "/." );
    while(p != NULL){
        tokens[ti++] = p;
        p = strtok( NULL, "/." );        
    }
    string tok = tokens[1]+"."+tokens[2];
    
    string hlb_str = file_get_next_token_from_1st_match("ipc6.txt", tok); 
    istringstream iss(hlb_str);
    iss >> hlb;
        
    return hlb;
}


// for server !! careful

//int highest_lower_bound(string prob){
//    
//    char *p;
//    int hlb;
//    
//    string *tokens;
//    tokens = new string[20];
//
//    int ti = 0;
//    
//    p = strtok( &prob[0], "/." );    
//    while(p != NULL){
//        tokens[ti++] = p;
//        p = strtok( NULL, "/." );        
//    }
//    string tok = tokens[8]+"."+tokens[9];
//   
//    string hlb_str = file_get_next_token_from_1st_match(planner_location+"/ipc6.txt", tok); 
//    istringstream iss(hlb_str);
//    iss >> hlb;
//        
//    return hlb;
//}


bool have_common_block(vector<int>  vector_a, vector<int>  vector_b, int front, int back){
    for (vector<int>::iterator it = vector_a.begin(); it != vector_a.end(); it++){
        if(*it > back || *it < front) continue;
        if(contains(vector_b, *it)) return true;                  
    }
    return false;    
}

vector<int> get_unordered_actions(vector<int> macro){
    // current_window.sort();

    vector<int> unordered_actions;
    for(int i = 1; i < prf_size-1 ; i++){
        if(contains(macro, i)) continue;
        vector<int> temp_vector;
        temp_vector.push_back(i);
        if(!have_path(prf_order_vector, macro, temp_vector, prf_size) && !have_path(prf_order_vector, temp_vector, macro, prf_size))
            unordered_actions.push_back(i);
    }
    
    unordered_actions = difference_set(unordered_actions, redundant_actions);
    
    return unordered_actions;
}

int action_set_cost(vector<int> action_set){
    int cost = 0;
    for (vector<int>::iterator it = action_set.begin(); it != action_set.end(); it++)
        cost += instance.actions[theplan[*it-1]].cost.decimal();
    return cost;
}

int block_cost(vector<int> block){
    int cost = 0;
    for (vector<int>::iterator it = block.begin(); it != block.end(); it++)
        cost += instance.actions[theplan[*it]].cost.decimal();
    return cost;
}

int window_cost(vector<int> block_vector){
    int cost = 0;
    for (vector<int>::iterator it_b = block_vector.begin(); it_b != block_vector.end(); it_b++){
        cost += block_cost(mfb[*it_b]);
    }
    return cost;
}

int window_size(vector<int> block_vector){
    int size = 0;
    for (vector<int>::iterator it_b = block_vector.begin(); it_b != block_vector.end(); it_b++){
        size += mfb[*it_b].size();
    }
    return size;
}

int get_optimisation_pass(int wid, ofstream &fileout_stat){
    //    if(window[wid].get_cost_improve() > 0) return -1;
    //    
    //    vector<int> wrank = window[wid].get_rank();
    //    int wcost = wrank[1];
    //    int admh_cost = wrank[2];
    //
    //    if(wcost <= admh_cost) return false;
    //    if(window[wid].get_cost_improve() > 0) return -1;
    //    if(window[wid].get_exec_status() != 0) return -1;
    //    
    //    vector<int> current_window = window[wid].get_actions(); // retrieve_actions(wid);
    //    for(int r = 0; r < rid; r++){
    //        int w = window_rank[r];
    //        vector<int> prev_window = window[w].get_actions(); // retrieve_actions(w);
    //        if(have_subset(decrypt_action_sequence(current_window), decrypt_action_sequence(prev_window)) && window[w].get_cost_improve() > 0){             
    //            save_window_state(fileout_stat, wid, wcost, wcost, 0, 0, 0.0, 0.0, 0.0, 0.0);  
    //            return -2;
    //        }
    //    }
    return 1;
}

bool all_window_full_explored(){
    for (int vid = 0; vid < window.size(); vid++){   
        if(!window[vid].exhausted()) return false;
    }    
    return true;
}

int get_admissible_hcost(vector<int> *init_goal_atoms){
    HSPS::index_set opt_init, opt_goal;
    for (vector<int>::iterator itig = init_goal_atoms[0].begin(); itig != init_goal_atoms[0].end(); itig++) opt_init.insert(*itig);
    for (vector<int>::iterator itig = init_goal_atoms[1].begin(); itig != init_goal_atoms[1].end(); itig++) opt_goal.insert(*itig);
    HSPS::CostACF cost(instance);
    HSPS::ForwardLMCut h(instance, opt_goal, cost, stats);
    NTYPE value = h.eval(opt_init);

    return value.decimal();
}

int check_plan_validity(vector<int> plan_actions, char plan_type){
    int diff = 0;
    if(plan_type == 'o') diff = 1;
    int pcost = 0;
    vector<int> state_atoms = get_vector(instance.init_atoms);
    for (vector<int>::iterator it = plan_actions.begin(); it != plan_actions.end(); ++it){
        int aid;
        if(plan_type == 'o') aid = theplan[*it-1];
        else aid = *it;
        pcost += instance.actions[aid].cost.decimal();
        if(!have_subset(state_atoms, get_vector(instance.actions[aid].pre))){
            cout << "following precondition(s) are unsatisfied for the action: " << *it << " " << instance.actions[aid].name << endl;
            vector<int> temp = difference_set(get_vector(instance.actions[aid].pre), state_atoms);
            for (vector<int>::iterator itx = temp.begin(); itx != temp.end(); ++itx)
                cout << *itx << instance.atoms[*itx].name << endl;
            return -1;
        }
        state_atoms = difference_set( union_set(state_atoms, get_vector(instance.actions[aid].add)), get_vector(instance.actions[aid].del));
    }
    if(!have_subset(state_atoms, get_vector(instance.goal_atoms))){
        cout << "following precondition(s) are unsatisfied for the GOAL" << endl;
        vector<int> temp = difference_set(get_vector(instance.goal_atoms), state_atoms);
            for (vector<int>::iterator itx = temp.begin(); itx != temp.end(); ++itx)
                cout << *itx << instance.atoms[*itx].name << endl;
        return -1;
    }
    
    return pcost;
}

vector<int> get_current_n_admissible_cost(vector<int> current_window){
    vector<int> all_cost; // front: c_cost; back: h_cost; 
    
    int cost = window_cost(current_window);    
    
    vector<int> *init_goal_atoms = generate_init_goal_atoms(current_window);
    int adm_hcost = get_admissible_hcost(init_goal_atoms);
    
    if(cost <= adm_hcost) return all_cost;
    else{
        all_cost.push_back(cost);
        all_cost.push_back(adm_hcost);
        return all_cost;
    }
    
    for(int i = 0; i < 4; i++) init_goal_atoms[i].clear();
}

vector<int> reassemble_composite_window(vector<int> com_windows, vector<int> *macro, vector<int> sid_vector){
    for (vector<int>::iterator itm = sid_vector.begin(); itm != sid_vector.end(); ++itm){
        vector<int> p, w, q, m;
        m = macro[*itm];
        for (vector<int>::iterator it = com_windows.begin(); it != com_windows.end(); ++it){ 
            if(*it < 0) continue;
            if(contains(m, *it)) break;
            else p.push_back(*it);
        }        
        for (vector<int>::reverse_iterator rit = com_windows.rbegin(); rit != com_windows.rend(); ++rit){
            if(*rit < 0) continue;
            if(contains(m, *rit)) break;
            else q.push_back(*rit);
        }
        reverse(q.begin(), q.end());
        w = difference_set(difference_set(com_windows, p), q);

        // 2nd part        
        vector<int> p2, q2, temp_macro;
        for (vector<int>::iterator it = w.begin(); it != w.end(); ++it){            
            temp_macro.clear();
            
            if(*it < 0) temp_macro = macro[(*it+1)*(-1)];
            else if(contains(m, *it)) continue;            
            else temp_macro.push_back(*it);
            
            if(have_path(prf_order_vector, m, temp_macro, prf_size)) 
                q2.push_back(*it);
            else 
                p2.push_back(*it);
        }  
	//        cout << "p2: " << vector_to_string(p2) << endl;
	//        cout << "m: " << vector_to_string(m) << endl;
	//        cout << "q2: " << vector_to_string(q2) << endl;
        
        w.clear();
        w.insert(w.end(), p2.begin(), p2.end());
        p2.clear();
	//        w.insert(w.end(), m);
        w.push_back((*itm+1)*(-1));
        w.insert(w.end(), q2.begin(), q2.end());
        q2.clear();
        
        com_windows.clear();
        com_windows.insert(com_windows.end(), p.begin(), p.end());
        com_windows.insert(com_windows.end(), w.begin(), w.end());
        com_windows.insert(com_windows.end(), q.begin(), q.end());
        p.clear(); w.clear(); q.clear();
	// cout << "com_windows: " << vector_to_string(com_windows) << endl << endl;
    }
    return com_windows;
}

vector<int> ucb_bandit_planner(){
    ofstream fileout_pbandit;
    string filestr = results_dir + "/pbandit_details.log";
    fileout_pbandit.open(filestr.c_str(), ios_base::app);
    // vector<double> uk;
    double uk;
    int choice = 0;
    
    // new size arm
    vector<int> remain_planners; 
    for (int i=0; i< TOT_PLANNERS; i++) {
        // if(planner_on_off[i] == 0) continue; // switch_off
        if(!bandit_planner[i].has_played()) 
            remain_planners.push_back(i);
    }
    if(!remain_planners.empty()){
        std::random_shuffle ( remain_planners.begin(), remain_planners.end() );
	// remain_planners.insert(remain_planners.begin(), 1); // 1 indicate new size
        return remain_planners;  
    }
    
    vector<pair<double,size_t> > vp;
    vector<double> *terms_vector;
    terms_vector = new vector<double> [TOT_PLANNERS];
    
    // old size arm
    for(int i = 0; i < TOT_PLANNERS; i++){
        double term1 = bandit_planner[i].get_average_reward();
        double term2 = sqrt(2*log(bandit_planner[i].get_overall_no_of_plays(bandit_planner, TOT_PLANNERS))/(float)bandit_planner[i].get_total_plays());
	// fileout << "sid:" << i << " | term1:" << term1 << " | term2:" << term2 << endl;
        terms_vector[i].push_back(term1);
        terms_vector[i].push_back(term2);
        uk = term1 + term2;
        vp.push_back(make_pair(uk, i));
    }
    sort(vp.rbegin(), vp.rend());
    
    
    // return result
    // fileout << "# result of size_bandit ... " << endl;
    vector<int> result;
    // result.push_back(0);
    // fileout << "planner_score: ";
    for (size_t i = 0 ; i != vp.size() ; i++){ 
        result.push_back(vp[i].second); 
        fileout_pbandit << "#" << vp[i].second << " " << vp[i].first << " " <<  bandit_planner[vp[i].second].get_total_plays() << " ";
	// fileout << vp[i].second << ":" <<  vp[i].first << "(" <<  terms_vector[vp[i].second].front() << "," << terms_vector[vp[i].second].back() << ") ";
    }
    
    fileout_pbandit << total_tm+(get_wall_time()-swatch) << endl;
    fileout_pbandit.close();
    // fileout << endl;
    return result;
    
    // vector<double>::iterator biggest = std::max_element(uk.begin(), uk.end());
    // return std::distance(uk.begin(), biggest); 
} 

bool window_exist(vector<int> current_window, int limit){
    bool found = false;
    for (int i=0; i <= limit; i++){
        // if(equal_set(decrypt_action_sequence(window[i].get_actions_str(), " "), current_window) ) // ????
        return true; // ????
    }
    return found;
}

int get_new_cost_bound(int wid){
    // fileout << "old_subplan_cost: " << window[wid].get_cost() - window[wid].get_cost_improve() << endl;
    int cost_improve = window[wid].get_cost_improve();
    vector<int> current_window = string_to_vector(window[wid].get_actions_str(), "."); // retrieve_actions(wid);
    for (int i=0; i < window.size(); i++){
        if(i == wid || window[i].get_cost_improve() == 0) continue;
        vector<int> other_window = string_to_vector(window[i].get_actions_str(), "."); // retrieve_actions(i);
        if(have_subset(decrypt_action_sequence(current_window), decrypt_action_sequence(other_window)) &&  window[i].get_cost_improve() > cost_improve)
            cost_improve = window[i].get_cost_improve();
    }
    // fileout << "new_cost_bound: " << window[wid].get_cost() - cost_improve << endl;
    return (window[wid].get_cost() - cost_improve);
}

void write_run_planner(int time_bound){
    // remove(com_file.c_str());
    ofstream outf (com_file.c_str());
    outf << "#!/bin/bash" << endl;
    outf << "ulimit -t " << time_bound << endl;
    outf << "echo \"$@\" >> system.log" << endl;
    outf << "(time \"$@\") >& log.txt" << endl;
    outf << "echo $? >> system.log" << endl;
    outf.close();
    string com = "chmod 700 " + com_file;
    int sys = system(com.c_str());
}

void assign_reward(int sid, int pid, int old_cost, int new_cost, double time_1st_plan, double time_last_plan, int time_bound){
    float reward;
    
    // adding rewards to rules 
    float cost_if = (old_cost - new_cost)/(float)old_cost; // cost_improvement_factor
    float time_uf = ((float)time_bound - time_last_plan)/(float)time_bound; // time_utilization_factor
    float theta_1 = 1.0;
    float theta_2 = 0.0;
    // reward = ((cost_if * theta_1) + (time_uf * theta_2))/(theta_1 + theta_2);
    reward = 1;

    bandit_planner[pid].add_rewards(reward);
    bandit_planner[pid].increment_improved_plan();
    bandit_planner[pid].add_time_1st_plan(time_1st_plan);
    bandit_planner[pid].add_time_last_plan(time_last_plan);
    
    // adding rewards to size 
    // bandit_size[sid].add_rewards(reward);
    // fileout << "new_reward: " << reward << endl;
}

int get_plan_length(string plan_file_name){
    FILE *in;
    int plength;
    char buff[512];
    string com = "grep -c ^ " + plan_file_name;

    if(!(in = popen(com.c_str(), "r"))){
      return -1;
    }

    //	while(fgets(buff, sizeof(buff), in)!=NULL){
    //		cout << buff;
    //	}
        
    char* c = fgets(buff, sizeof(buff), in);
    stringstream ss;
    ss << buff;
    ss >> plength;
    pclose(in);
    return plength;
}

vector<int> get_plan_action_ids(vector<int> wactions){
    vector<int> plan_action_ids;
    for (vector<int>::iterator it = wactions.begin(); it != wactions.end(); ++it)
        plan_action_ids.push_back(theplan[*it-1]);
       
    return plan_action_ids;
}

vector<int> get_newplan_action_ids(vector<int> encoded_plan, vector<int> *impr_actions_ids){
    vector<int> newplan_action_ids;
    
    for (vector<int>::iterator it = encoded_plan.begin(); it != encoded_plan.end(); ++it){
        if(*it < 0){
            int id = (*it+1)*(-1);    
            newplan_action_ids.insert(newplan_action_ids.end(), impr_actions_ids[id].begin(), impr_actions_ids[id].end());
        }
        else newplan_action_ids.push_back(theplan[*it-1]);
    }
       
    return newplan_action_ids;
}

vector<int> get_newplan_action_ids(vector<int> *pwq, vector<int> cc_window, vector<int> *actions_ids){
    vector<int> newplan_action_ids;
    for (vector<int>::iterator it = pwq[0].begin(); it != pwq[0].end(); ++it)
        newplan_action_ids.push_back(theplan[*it-1]);
    
    for (vector<int>::iterator it = cc_window.begin(); it != cc_window.end(); ++it){
        if(*it < 0){
            int id = (*it+1)*(-1);            
//            temp_vector = actions_ids[id];
            newplan_action_ids.insert(newplan_action_ids.end(), actions_ids[id].begin(), actions_ids[id].end());
        }
        else newplan_action_ids.push_back(theplan[*it-1]);
    }
    
    for (vector<int>::iterator it = pwq[2].begin(); it != pwq[2].end(); ++it)
        newplan_action_ids.push_back(theplan[*it-1]);
       
    return newplan_action_ids;
}

vector<int> decode_composite_window(vector<int> cc_window, vector<int> *old_actions){
    vector<int> composite_window;
    for (vector<int>::iterator it = cc_window.begin(); it != cc_window.end(); ++it){
        if(*it < 0){
            int id = (*it+1)*(-1);            
	    // temp_vector = old_actions[id];
            composite_window.insert(composite_window.end(), old_actions[id].begin(), old_actions[id].end());
        }
        else composite_window.push_back(*it);
    }
    return composite_window;
}

void update_encoded_plan(vector<int> &encoded_plan, vector<int> *old_actions, int impr_id){
    // bool success = false;    
    vector<int> impr_actions = old_actions[impr_id];
    vector<int> encoded_plan_new;
    
    if(encoded_plan.empty()){
        vector<int> *pwq = formulate_window_pwq(impr_actions);
        if( !pwq[0].empty()) encoded_plan.insert(encoded_plan.end(), pwq[0].begin(),  pwq[0].end());
        encoded_plan.insert(encoded_plan.end(), (impr_id+1)*(-1));
        if( !pwq[2].empty()) encoded_plan.insert(encoded_plan.end(), pwq[2].begin(),  pwq[2].end());
        
        pwq[0].clear();
        pwq[1].clear();
        pwq[2].clear();
    }
    
    else{
        int st = 0;
        int en = 0;
        for (int i = 0; i < encoded_plan.size(); i++){  // find st_point   
            if(contains(impr_actions,encoded_plan[i])){
                st = i;
                break;
            }
        }
        
        for (int i = st; i < encoded_plan.size(); i++){ // find en_point       
            if(contains(impr_actions,encoded_plan[i])) en = i;                
        }
        
        vector<int> pred, succ;
        for (int i = st; i <= en; i++){ // squeeze between st~en      
            int act = encoded_plan[i];
            if(contains(impr_actions, act)) continue;
            if(act < 0){
                int iid = (act+1)*(-1); // prev improvement_id
                vector<int> old_impr_actions = old_actions[iid];
                if(have_path(prf_order_vector, impr_actions, old_impr_actions, prf_size)) succ.push_back(act);                    
                else pred.push_back(act);
                old_impr_actions.clear();
            }
            else{
                vector<int> old_action;
                old_action.push_back(act);
                if(have_path(prf_order_vector, impr_actions, old_action, prf_size)) succ.push_back(act);                    
                else pred.push_back(act);
                old_action.clear();
            }
        }
        
        // joining all parts
        for (int i = 0; i < st; i++) 
            encoded_plan_new.push_back(encoded_plan[i]);
        
        if(!pred.empty())
            encoded_plan_new.insert(encoded_plan_new.end(), pred.begin(), pred.end());
        
        encoded_plan_new.insert(encoded_plan_new.end(), (impr_id+1)*(-1));
        
        if(!succ.empty())
            encoded_plan_new.insert(encoded_plan_new.end(), succ.begin(), succ.end());
        
        for (int i = en+1; i < encoded_plan.size(); i++) 
            encoded_plan_new.push_back(encoded_plan[i]);
        
        pred.clear();
        succ.clear();
        encoded_plan.clear();
        encoded_plan = encoded_plan_new;
        encoded_plan_new.clear();
    }
}

void merge_improved_window(vector<int> &merge_result){
    string dom(arguments[1]);
    string prob(arguments[2]);
    string plan(arguments[3]);
    
    // vector<int> merge_result(3, 0);
    
    vector<pair<int,size_t> > vp;
    for(int i = 0; i < window.size(); i++)
        if(window[i].get_cost_improve() > 0)
	    vp.push_back(make_pair(window[i].get_cost_improve(), i));
    
    sort(vp.rbegin(), vp.rend());
    
    int improved_tot = vp.size();
    int merged_tot = 0;
    int new_plan_tot = 0;
    bool new_plan = false;
    // int merged_tot = 0;
    vector<int> *old_actions,*new_actions, *pred, *succ, new_cost; 
    
    old_actions = new vector<int> [improved_tot];
    new_actions = new vector<int> [improved_tot];
    // pred = new vector<int> [improved_tot];
    // succ = new vector<int> [improved_tot];
    new_cost.resize(improved_tot);

    fileout << endl << "Candidates for MERGING:" << endl;
    for (int i = 0; i < improved_tot; i++){        
        int wid = vp[i].second;
        old_actions[i] = string_to_vector(window[wid].get_actions_str(), "."); 
        new_actions[i] = string_to_vector(window[wid].get_actions_new_str(), ".");
	// pred[i] = string_to_vector(window[wid].get_pred_str(), " ");
	// succ[i] = string_to_vector(window[wid].get_succ_str(), " ");
        new_cost[i] = window[wid].get_cost_improve();      
        
        fileout << i << ": wid:" << wid << " improve:" << window[wid].get_cost_improve() << ": actions:" << window[wid].get_actions_str()  << endl;
	// cout << "pred: " << window[wid].get_pred_str() << endl;
	// cout << "succ: " << window[wid].get_succ_str() << endl;
	// cout << "actions_new: " << window[wid].get_actions_new_str() << endl;
    }
    
    fileout << endl;
    
    // int merged_tot = 0;
    
    vector<int> selected_wid, new_plan_actions, encoded_plan, valid_encoded_plan;
    // vector<int> *pwq;
    for (int ii = 0; ii < improved_tot; ii++){ // ii: improvement_index
        encoded_plan.clear();
        encoded_plan = valid_encoded_plan;
        
        update_encoded_plan(encoded_plan, old_actions, ii);
        
        fileout << ii << " wid:" << vp[ii].second;
        
        new_plan_actions =  get_newplan_action_ids(encoded_plan, new_actions);
//        fileout << "new_plan_actions: " << vector_to_string(new_plan_actions, ".") << endl;
        
        int new_plan_cost = check_plan_validity(new_plan_actions, 'n');
        
        if(new_plan_cost >= 0){ 
            fileout << " merged!! ";
            merged_tot++;
            valid_encoded_plan.clear();
            valid_encoded_plan = encoded_plan;    
        }
        else fileout << " cant_merge! ";
        
        fileout << " encoded_plan:" << vector_to_string(encoded_plan, ".");
        
        if(new_plan_cost >= 0 && new_plan_cost < plan_cost_last){
	    // valid_encoded_plan = encoded_plan;
            selected_wid.push_back(vp[ii].second);
        
            fileout << " cost:" << plan_cost_last << " -> " << new_plan_cost <<  endl << endl;
            bplan_isnum++;
            ostringstream max_oss;
            max_oss << bplan_isnum;
	    // string plan_file_name = temp_dir + "/bplan." + max_oss.str();
            string plan_file_name = results_dir + "/bplan." + max_oss.str();

            ofstream outfile (plan_file_name.c_str());

            for (vector<int>::iterator it = new_plan_actions.begin(); it != new_plan_actions.end(); ++it)
                outfile << instance.actions[*it].name << endl;  
            
	    // fileout << "#Merged (wid): " << vector_to_string(selected_wid, ".") << endl;
            
	    // string com = "cp " + plan_file_name + " " + plan_store_name; 
	    // int comout = system(com.c_str());            
            
            double total_tm_loc = total_tm + (get_wall_time()-swatch);            
	    // fileout << "## " << plan_file_name << ": #cost: " << plan_cost_last << " -> " << new_plan_cost << " #impr_tm_at: " << total_tm_loc << " ";
	    // fileout << "#loop: " << iteration << endl; 
            plan_cost_last = new_plan_cost;
            plan_length_last = get_plan_length(plan_file_name);
            
            new_plan = true;
            new_plan_tot++;
            
            // record in 
            ofstream fileout_bp; 
            string filestr = results_dir + "/better_plans.log";
            fileout_bp.open(filestr.c_str(), ios_base::app);
            if(!fileout_bp) cout << "unable to open: " << filestr << endl;
            fileout_bp << bplan_isnum << " " << new_plan_cost << " " << total_tm_loc << endl;
            fileout_bp.close();
            
        }
        else{
	    fileout << " #not_better_plan (" << new_plan_cost
		    << ", " << plan_cost_last << ")" << endl;
        }
    }
    
    merge_result[0] = improved_tot;
    merge_result[1] = merged_tot;
    merge_result[1] = new_plan_tot;
    
    // return merge_result;
    
    // if(new_plan) return 1;
    // else return -1;     
}

int get_group_id(int wid){
    // int alength = window[wid].get_action_length();
    //// cout << "alength: " << alength << endl;
    // for(int j = 0; j < MAX_BANDIT_SIZE; j++){
    //   if(alength >= size_range[j].front() && alength <= size_range[j].back())
    //   return j;
    // }
    return -1;
}

void file_out_statistics(int pid, int wid, double time_bound){
    // store bandit settings
    
    ofstream file_out_planner, file_out_window;     
    ifstream file_in_planner;
    
    string str = results_dir + "/bandit_planner_all.txt";
    file_in_planner.open(str.c_str(), ios::in);
    
    if(file_in_planner.fail()){
        
        file_in_planner.close();        
	// str = results_dir + "/bandit_size_all.txt";
	// file_out_size.open(str.c_str(), ios_base::app);
        str = results_dir + "/bandit_planner_all.txt";
        file_out_planner.open(str.c_str(), ios_base::app);
        str = results_dir + "/window_all.txt";
        file_out_window.open(str.c_str(), ios_base::app);
        
        
	// file_out_size << "iteration|size_id|overall_played|self_played|improvement_coverage|trial_coverage|rewards" << endl;        
        file_out_planner << "iteration|planner_id|overall_played|self_played|tot_improve|1st_plan_time|last_plan_time|rewards" << endl;
        file_out_window << "overall_id|tot_window|window_id|total_attempt|group_id|init_cost|cost_improve|action_length|exe_status|time_1st_plan|time_last_plan|time_bound" << endl;
    }
    else{
        file_in_planner.close();     
	// str = results_dir + "/bandit_size_all.txt";
	// file_out_size.open(str.c_str(), ios_base::app);
        str = results_dir + "/bandit_planner_all.txt";
        file_out_planner.open(str.c_str(), ios_base::app);       
        str = results_dir + "/window_all.txt";
        file_out_window.open(str.c_str(), ios_base::app);
    }

    // store planners
   
    file_out_planner << iteration << "|";
    file_out_planner << pid << "|" ;
    file_out_planner << bandit_planner[pid].get_overall_no_of_plays(bandit_planner, TOT_PLANNERS) << "|" ; // part-0

    

    file_out_planner << bandit_planner[pid].get_total_plays() << "|" ;

    file_out_planner << bandit_planner[pid].get_total_improved_plan() << "|";

    if(bandit_planner[pid].get_total_improved_plan() > 0){
        vector<double> time_vector = bandit_planner[pid].get_time_1st_plan();
        for (vector<double>::iterator itr = time_vector.begin(); itr != time_vector.end(); itr++){
            file_out_planner << *itr << " ";
        }
        file_out_planner << "|";
        time_vector.clear();

	// time_vector = bandit_planner[pid].get_time_last_plan();
        for (vector<double>::iterator itr = time_vector.begin(); itr != time_vector.end(); itr++){
            file_out_planner << *itr << " ";
        }
        file_out_planner << "|";
        time_vector.clear();
    }
    else{
        file_out_planner << "-1" << "|" << "-1" << "|";
    }

    vector<float> brewards = bandit_planner[pid].get_rewards();
    for (vector<float>::iterator itr = brewards.begin(); itr != brewards.end(); itr++){
        file_out_planner << *itr << " ";
    }
    
    brewards.clear();
    file_out_planner << endl;
    
    // store sizes
    // file_out_size << iteration << "|";
    // file_out_size << sid << "|" ; // part-0
    // file_out_size << bandit_size[sid].get_overall_no_of_plays(bandit_size, MAX_BANDIT_SIZE, size_on_off) << "|" ; // overall_played    
    // file_out_size << bandit_size[sid].get_total_plays() << "|" ; // part-0
    // file_out_size << (float)improvement_coverage.size()/fob_length << "|"; // improvement_coverage_ratio
    // file_out_size << (float)trial_coverage.size()/fob_length << "|"; // trial_coverage_ratio    
    // brewards = bandit_size[sid].get_rewards();
    // for (vector<float>::iterator itr = brewards.begin(); itr != brewards.end(); itr++){
    //     file_out_size << *itr << " "; // part-1
    // }
    // file_out_size << endl;
    
    // store window
    // int p1 = bandit_size[3].get_size_range().front();
    // int p2 = bandit_size[4].get_size_range().back();   
    
    // file_out_window << iteration << "|"; //iteration
    // file_out_window << plan_cost_last << "|"; //plan_cost_last
    file_out_window << bandit_planner[pid].get_overall_no_of_plays(bandit_planner, TOT_PLANNERS) << "|" ; // overall_id
    // file_out_window << sid << "|"; // size_id
    // file_out_window << bplanners[pid].get_planner_id() << "|"; // planner_id
    file_out_window << window.size() << "|"; // total_window
    file_out_window << wid << "|"; // window_id
    file_out_window << window[wid].get_trial_count_combined() << "|"; // get_total_attempt
    file_out_window << get_group_id(wid) << "|"; // get_group_id
    file_out_window << window[wid].get_cost() << "|"; // get_cost
    file_out_window << window[wid].get_cost_improve() << "|"; // get_cost_improve
    file_out_window << window[wid].get_new_length() << "|"; // get_new_length
    file_out_window << window[wid].exhausted() << "|"; // get_exec_status
    file_out_window << window[wid].get_time_1st_plan() << "|"; // get_time_1st_plan
    // file_out_window << window[wid].get_time_last_plan() << "|"; // get_time_last_plan   
    file_out_window << time_bound << "|"; // get_time_last_plan 
    file_out_window << endl;
        
    // file_out_size.close();
    file_out_planner.close();
    
    file_out_window.close();
}


void backup_new_subplan(){
    string dir = results_dir;
    vector<string> files = vector<string>();
    getdir(dir,files, "subplan_new");            
    int max = files.size();
    max++;
    ostringstream max_oss;
    max_oss << max;

    string subprob_fname = dir + "/subprob." + max_oss.str() + ".pddl";
    string subplan_old_fname = dir + "/subplan_old." + max_oss.str();
    string subplan_new_fname = dir + "/subplan_new." + max_oss.str();

    string com = "cp " + temp_dir + "/sub_problem.pddl " + subprob_fname; 
    int comout = system(com.c_str());

    com = "cp " + temp_dir + "/subplan_new.txt " + subplan_new_fname; 
    comout = system(com.c_str());

    com = "cp " + temp_dir + "/subplan_old.txt " + subplan_old_fname; 
    comout = system(com.c_str());   
    
    com = "rm " + temp_dir + "/subplan_*" ; 
    comout = system(com.c_str());   
}

void switch_off_unproductive_arms(){
    float avg_reward, eta, min_tolerance_reward;
    std::vector<float> average_reward_vector;
    vector<pair<float,size_t> > vp;
    
    for(int i = 0; i < TOT_PLANNERS; i++){
        if(planner_on_off[i] == 0) continue; 
        else if(!bandit_planner[i].has_played()) return; 
        average_reward_vector.push_back(bandit_planner[i].get_average_reward());
        vp.push_back(make_pair(bandit_planner[i].get_average_reward(), i));
    }
    sort(vp.begin(), vp.end());
    avg_reward = accumulate(average_reward_vector.begin(),average_reward_vector.end(),0.0)/(float)average_reward_vector.size();
    
    min_tolerance_reward = avg_reward /(float)average_reward_vector.size();
    for(int i = 0; i < vp.size(); i++){
         if(vp[i].first < min_tolerance_reward)
            planner_on_off[vp[i].second] = 0;
    }   
    
}

void save_temp(){
    stringstream ss;
    ss << iteration;
    
    string newdir = results_dir + "/" + ss.str();
    int mkd = mkdir(newdir.c_str(), S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
    string com = "cp -a " + temp_dir +"/* " + newdir;
    int comout = system(com.c_str()); 
}

void save_temp_2(){
    // stringstream ss;
    // ss << iteration;
    // 
    // string newdir = results_dir + "/" + ss.str();
    // int mkd = mkdir(newdir.c_str(), S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);
    string com = "cp -a " + temp_dir +"/* " + results_dir;
    int comout = system(com.c_str()); 
}

void save_current_state(){
    string str = temp_dir + "/time.txt";
    ofstream out_file(str.c_str());
    
    out_file << "iteration " << iteration  << endl;
    out_file << "total_tm " << total_tm+(get_wall_time()-swatch)  << endl;
    out_file << "results_dir " + results_dir  << endl;

    //    out_file << "size_on_off "; 
    //    for(int i = 0; i < MAX_BANDIT_SIZE; i++) out_file << size_on_off[i] << " ";
    //    out_file << endl;

    //    out_file << "planner_on_off "; 
    //    for(int i = 0; i < TOT_PLANNERS; i++) out_file << planner_on_off[i] << " ";
    //    out_file << endl;

    out_file.close();
    
    // store bandit settings
    
    
    //    str = temp_dir + "/bandit_size.txt";
    //    ofstream file_out_size(str.c_str());
    str = temp_dir + "/bandit_planner.txt";
    ofstream file_out_planner(str.c_str());
    //    str = temp_dir + "/bandit_rule.txt";
    //    ofstream file_out_rule(str.c_str());
    //    str = temp_dir + "/bandit_size_range.txt";
    //    ofstream file_out_srange(str.c_str());
    //    str = temp_dir + "/bandit_time_bound.txt";
    //    ofstream file_out_tbound(str.c_str());
    
    // store sizes
    //    for(int j = 0; j < MAX_BANDIT_SIZE; j++){
    //        if(size_on_off[j] == 0 || !bandit_size[j].has_played()) continue; // switch_off         
    //        
    //        file_out_size << j << "|" ; // part-0
    //        vector<float> brewards = bandit_size[j].get_rewards();
    //        for (vector<float>::iterator itr = brewards.begin(); itr != brewards.end(); itr++){
    //            file_out_size << *itr << " "; // part-1
    //        }
    //        
    //        file_out_size << endl;
    //    }
    
    // store planner
    for(int j = 0; j < TOT_PLANNERS; j++){
        
        if(planner_on_off[j] == 0 || !bandit_planner[j].has_played()) continue; // switch_off         
        
        file_out_planner << j << "|" ;

        vector<float> brewards = bandit_planner[j].get_rewards();
        for (vector<float>::iterator itr = brewards.begin(); itr != brewards.end(); itr++){
            file_out_planner << *itr << " ";
        }
        file_out_planner << "|";
        brewards.clear();

        file_out_planner << bandit_planner[j].get_total_improved_plan() << "|";

        if(bandit_planner[j].get_total_improved_plan() > 0){
            vector<double> time_vector = bandit_planner[j].get_time_1st_plan();
            for (vector<double>::iterator itr = time_vector.begin(); itr != time_vector.end(); itr++){
                file_out_planner << *itr << " ";
            }
            file_out_planner << "|";
            time_vector.clear();

	    // time_vector = bandit_planner[j].get_time_last_plan();
            for (vector<double>::iterator itr = time_vector.begin(); itr != time_vector.end(); itr++){
                file_out_planner << *itr << " ";
            }
            time_vector.clear();
        }
        else{
            file_out_planner << "-1" << "|" << "-1";
        }


        file_out_planner << endl;
    
    }
    // ======================
    
    //    for(int j = 0; j < MAX_BANDIT_SIZE; j++){
    //        file_out_srange << j << "|";
    //        vector<int> bsrange = bandit_size[j].get_size_range();
    //        for (vector<int>::iterator itr = bsrange.begin(); itr != bsrange.end(); itr++)
    //            file_out_srange << *itr << " ";
    //        file_out_srange << endl;
    //    }
    
    //    for(int j = 0; j < 3; j++){
    //        file_out_tbound << current_time_bound[j] << " ";
    //    }
    
    // temp
    //    fileout << "total plays before restart: " << endl; 
    //    for(int i = 0; i < MAX_BANDIT_SIZE; i++)
    //        fileout << i << " | size_id: " << bandit_size[i].get_size_id() << " | tot_plays: " << bandit_size[i].get_total_plays() << endl;

    //    file_out_size.close();
    file_out_planner.close();
    //    file_out_rule.close();
    //    file_out_srange.close();
    //    file_out_tbound.close();
    save_temp();
}

void file_out_overall_statistics(int episode, int rand_block_vector_index, int rand_block_vector_size){
    ofstream file_stat_out; 
    string filestr = results_dir + "/statistics.log";
    file_stat_out.open(filestr.c_str(), ios_base::app);
    if(!file_stat_out){
        cout << "unable to file_stat_out" << endl;
    }
    
    if(iteration == 1){
      // file_stat_out << "size_ranges ..." << endl; 
      // for(int i = 0; i < 7; i++)        
      //     file_stat_out << bandit_size[i].get_size_id() << ": " << vector_to_string(bandit_size[i].get_size_range()) << endl;
        
        file_stat_out << "participating planners ..." << endl; 
        for(int i = 0; i < TOT_PLANNERS; i++)
                file_stat_out << i << ": " << planners_desc_short[i] << endl;
    }
    
    file_stat_out << endl;
    file_stat_out << "==========================================================" << endl;
    file_stat_out << "current_iteration: " << iteration << endl;
    file_stat_out << "input_plan_cost: " << plan_cost_init << endl;
    file_stat_out << "episode: " << episode << endl;
    file_stat_out << "total_blocks_processed: " << rand_block_vector_index << " (out of " << rand_block_vector_size << ")" << endl;
    file_stat_out << "current_wall_time: " << total_tm+(get_wall_time()-swatch) << endl << endl;
    
    file_stat_out << "bandit statistics (overall):" << endl;
    // file_stat_out << "overall played (excluding inactive arms): " << bandit_size[0].get_overall_no_of_plays(bandit_size, MAX_BANDIT_SIZE, size_on_off) << " times" << endl;    
    // file_stat_out << "result of bandit sizes (sorted by achieved reward);  formation: <size_id, reward, total_played>:" << endl;   
    vector<pair<float,size_t> > vp;
    file_stat_out << endl << "Bandit Planner Overall Result ..." << endl;
    vp.clear();        
    std::vector<double> avg_time_1st_plan_vector;
    std::vector<double> avg_time_last_plan_vector;
    std::vector<int> total_improved_plan;

    for(int j = 0; j < TOT_PLANNERS; j++){
        if(planner_on_off[j] == 0 ) continue; // switch_off

        vp.push_back(make_pair(bandit_planner[j].get_average_reward(), j));

        total_improved_plan.push_back(bandit_planner[j].get_total_improved_plan());

        if(bandit_planner[j].get_total_improved_plan() > 0){
            std::vector<double> time_vector = bandit_planner[j].get_time_1st_plan();
            double tot_ptime = 0.0;
            for (vector<double>::iterator itr = time_vector.begin(); itr != time_vector.end(); ++itr) tot_ptime += *itr;
            avg_time_1st_plan_vector.push_back(tot_ptime/time_vector.size());
            time_vector.clear();

//            time_vector = bandit_planner[j].get_time_last_plan();
            tot_ptime = 0.0;
            for (vector<double>::iterator itr = time_vector.begin(); itr != time_vector.end(); ++itr) tot_ptime += *itr;
            avg_time_last_plan_vector.push_back(tot_ptime/time_vector.size());
        }
        else{
            avg_time_1st_plan_vector.push_back(-1.0);
            avg_time_last_plan_vector.push_back(-1.0);
        }
    }
    
    sort(vp.rbegin(), vp.rend());
    
    file_stat_out << "total: " << vp.size() << endl;
    for(int i = 0; i < vp.size(); i++){
        file_stat_out << "# planner_id: " << vp[i].second << endl;
        file_stat_out << "average_reward: " << vp[i].first << endl;
        file_stat_out << "played: " << bandit_planner[vp[i].second].get_total_plays() << " times" << endl;
        file_stat_out << "total_improved_plan: " << total_improved_plan[vp[i].second] << endl;
        file_stat_out << "average_time_to_get_1st_plan: " << avg_time_1st_plan_vector[vp[i].second] << endl;
        file_stat_out << "average_time_to_get_last_plan: " << avg_time_last_plan_vector[vp[i].second] << endl;            
    }
    vp.clear();
    
    file_stat_out << endl;
    
    // ######################################################
    
    file_stat_out << "## Window Statistics ..." << endl;
    file_stat_out << "Total processed windows: " << window.size() << endl;
    file_stat_out << "plan_coverage_ratio: " <<  (float)improvement_coverage.size()/fob_length << endl;
    
    int yet_to_explore = 0;
    int completely_explored = 0;
    int reach_max_attempt = 0;
    int total_improved_window = 0;
    double average_1st_plan_generate_time = 0.0;
    
    double average_last_plan_generate_time = 0.0;
    int average_attempt = 0;
    
    for (int i=0; i < window.size(); i++){
        //  if(window[i].get_exec_status() == 0) yet_to_explore++;
        if(window[i].exhausted()) completely_explored++;
	// else if(window[i].get_exec_status() == 2) reach_max_attempt++;
        
        if(window[i].get_cost_improve() > 0){
            total_improved_window++;
            average_1st_plan_generate_time += window[i].get_time_1st_plan();
	    // average_last_plan_generate_time += window[i].get_time_last_plan();
        }
    }
    
    file_stat_out << "yet_to_explore: " << yet_to_explore << " (" << ((float)yet_to_explore/window.size())*100 << "%)" << endl;
    file_stat_out << "completely_explored: " << completely_explored << " (" << ((float)completely_explored/window.size())*100 << "%)" << endl;
    file_stat_out << "reach_max_attempt: " << reach_max_attempt << " (" << ((float)reach_max_attempt/window.size())*100 << "%)" << endl;
    file_stat_out << "total_improved_window: " << total_improved_window << " (" << ((float)total_improved_window/window.size())*100 << "%)" << endl;
    
    if(total_improved_window > 0){
        file_stat_out << "average_1st_plan_generate_time: " << average_1st_plan_generate_time/total_improved_window << endl;
	// file_stat_out << "average_last_plan_generate_time: " << average_last_plan_generate_time/total_improved_window << endl;
    }
    
    // file_stat_out << endl << "## SwitchOnOff status ..." << endl;
    // file_stat_out << "size_on_off_status: ";
    // for(int j = 0; j < MAX_BANDIT_SIZE; j++) file_stat_out << size_on_off[j];
    // file_stat_out << endl << "planner_on_off_ status: ";
    // for(int j = 0; j < TOT_PLANNERS; j++) file_stat_out << size_on_off[j];
    
    file_stat_out << endl << "improved_plan_cost: " << plan_cost_last << endl;
    file_stat_out << endl;    
    file_stat_out.close();
}

string get_restart_ingredients(){
    size_t ulimit = ceil((alloted_tm-(total_tm+(get_wall_time()-swatch))));
    
    string dom(arguments[1]);
    string prob(arguments[2]);
    
    ofstream outf ("./planner.sh");
    outf << "#!/bin/bash" << endl;
    outf << "ulimit -t " << ulimit << endl;
    outf << "\"$@\" " << endl;
    outf.close();
    int sysr = system("chmod 700 ./planner.sh");
      
    ostringstream oss;
    oss << bplan_isnum;
    string new_plan = results_dir + "/bplan." + oss.str();
    
    oss.clear();
    oss << ulimit;
    
    string param = "./planner.sh  " + planner_location + "/test_prf " + dom + " " + prob + " " + new_plan; 
    return param;
}


int get_plan_cost(string dom, string prob, string plan){
    
    string param = com_file + " " + validator_location + "/validate " + dom + " " + prob + " " + plan; 
    // cout << endl << param << endl;
    int output = system(param.c_str());
    if (output != 0) {
      cout << "error running validator: " << param
	   << endl << "- consult log.txt" <<endl;
      exit(1);
    }
    int cost = -1;
    
    string init_cost_str;
    string result = file_get_next_token_from_1st_match("log.txt", "Successful");
    if(result.compare("plans:") != 0){
        // cout << "bad plan: "<< plan << endl;
        // exit(1);
        return cost;
    }
    
    init_cost_str = file_get_next_token_from_1st_match("log.txt", "Value:");
    istringstream convert(init_cost_str);
    convert >> cost;
    return cost;
}

int get_plan_cost_last(string dom, string prob){
    if(bplan_isnum == 0) return -1;
    ostringstream max_oss;
    max_oss << bplan_isnum;
    string plan = results_dir + "/bplan." + max_oss.str();
    
    return get_plan_cost(dom, prob, plan);
}

int get_total_lines(string filename){
    int tot_lines = 0;
    string param = com_file + " grep -c ^ " + filename; 
    int output = system(param.c_str());
    
    ifstream infile;
    infile.open("log.txt", ios::in);
    
    if(infile.fail())
        return -1;
    
    string tot_lines_str;
    infile >> tot_lines_str; 
    infile.close();
    
    istringstream convert(tot_lines_str);
    convert >> tot_lines;
    
    return tot_lines;    
}

int get_plan_length_last(){
    string dir = string(results_dir);
    vector<string> files = vector<string>();
    getdir(dir,files, "bplan");            
    int max = files.size();      
    if(max == 0) return -1;
    ostringstream max_oss;
    max_oss << max;
    string plan = results_dir + "/bplan." + max_oss.str();
    
    return get_total_lines(plan);
}

vector<int> get_min_max_window_size(){
    vector<int> min_max;
    int min = prf_size-2;
    int max = 0;
    for(int x = 0; x < window.size(); x++){
        int temp_size = window[x].get_rank().front();
        if(temp_size < min) min = temp_size;
        if(temp_size > max) max = temp_size;
    }
    min_max.push_back(min);
    min_max.push_back(max);
    return min_max;
}

float yet_to_explore_ratio(){
    int yet_to_explore = 0;
    for (int i=0; i < window.size(); i++){
        if(!window[i].exhausted()) yet_to_explore++;
    }
    return (float)yet_to_explore/window.size();
}

float completely_explore_ratio(){
    int completely_explore = 0;
    for (int i=0; i < window.size(); i++){
        if(window[i].exhausted()) completely_explore++;
    }
    return (float)completely_explore/window.size();
}

void save_window_state(ofstream &fileout_stat, int wid, int old_cost, int upper_cost_bound, double time_bound, int pid, double translation_time, double preprocess_time, double time_1st_plan, double time_last_plan){    
            
    double ctime = total_tm+(get_wall_time()-swatch);                
    fileout_stat << fixed << setprecision(3) << ctime << "\t"; // wall_time
    // fileout_stat << iteration << " "; // iteration
    // fileout_stat << plan_cost_last << " "; // plan_cost_last
    
    float improvement_coverage_ratio = (float)improvement_coverage.size()/(theplan.size()-redundant_actions.size());
    fileout_stat << fixed << setprecision(3) << improvement_coverage_ratio << "\t"; // improvement_coverage_ratio
    fileout_stat << wid << "\t"; // wid
    // fileout_stat << cid << " "; // cid
    fileout_stat << window[wid].get_trial_count_combined() << "\t"; // window[wid].get_total_attempt()
    fileout_stat << window[wid].exhausted() << "\t"; // window[wid].get_exec_status()
    // fileout_stat << get_group_id(wid) << "\t"; // gid
    
    fileout_stat << window[wid].get_rank()[0] << "\t"; // wsize  
    if(window[wid].get_cost_improve() > 0)
        fileout_stat << retrieve_new_actions(wid).size() << "\t"; // wsize_new
    else
        fileout_stat << "-1" << "\t"; // wsize  
    
    fileout_stat << old_cost << "\t"; // wcost     
    // fileout_stat << fixed << setprecision(3) << upper_cost_bound << " "; // wcost      
    fileout_stat << window[wid].get_cost_improve() << "\t"; // wcost
    fileout_stat << fixed << setprecision(3) << time_bound << "\t"; // time_bound
    // fileout_stat << pid << " "; // pid
    fileout_stat << fixed << setprecision(3) << translation_time << "\t"; // translation_time
    fileout_stat << fixed << setprecision(3) << preprocess_time << "\t"; // translation_time
    // if(bandit_planner[pid].get_rewards().back() > 0){
    //     fileout_stat << fixed << setprecision(3) << time_1st_plan << " "; // time_1st_plan
    //     fileout_stat << fixed << setprecision(3) << time_last_plan << " "; // time_last_plan
    // }
    // if(new_cost > 0){
    fileout_stat << fixed << setprecision(3) << time_1st_plan << "\t"; // time_1st_plan
    fileout_stat << fixed << setprecision(3) << time_last_plan << "\t"; // time_last_plan
    // }
    // else fileout_stat << "-1" << " " << "-1" << " "; // no improvement
    // fileout_stat << actions_string;
    fileout_stat << endl;
    
    // wall_time | improvement_coverage_ratio | wid | total_attempt | exec_status | gid | old_action_length | new_action_length | old_cost | cost_improve | tbound | translation_time | preprocess_time | time_1st_plan | time_last_plan
}

int update_translator(int wid, vector<int> init_atoms, vector<int> goal_atoms){
  // vector<int> init_atoms = init_goal[0];
  // vector<int> goal_atoms = init_goal[1];
    
  // fileout << "I: "  << init_atoms.size() << ": " << vector_to_string(init_atoms) << endl;
  // fileout << "G: " << goal_atoms.size()  << ": " << vector_to_string(goal_atoms) << endl;
    
    string infile_name = "output.sas";
    ifstream infile(infile_name.c_str());    
    if(infile.fail()) return -1;
    
    string outfile_name = "output.sas.tmp";
    ofstream outfile(outfile_name.c_str());
    if(outfile.fail()) return -1;
    
    vector<string> iatoms_str, gatoms_str;
    vector<int> initf, goalf;
    
    // fileout << endl << "init:" << endl;
    for (vector<int>::iterator it = init_atoms.begin(); it != init_atoms.end(); ++it){ 
        string st = instance.atoms[*it].name->to_string();
        st = split_string_2(st, "(,)");
	// fileout << st << endl;
        iatoms_str.push_back(st);
    }
    
    // fileout << endl  << "goal:" << endl;
    for (vector<int>::iterator it = goal_atoms.begin(); it != goal_atoms.end(); ++it){ 
        string st = instance.atoms[*it].name->to_string();
        st = split_string_2(st, "(,)");
	// fileout << st << endl;
        gatoms_str.push_back(st);
    }
    
    string line, line_backup, pline;
    int var_no = -1;
    while( getline(infile,line) ){    
        if( line.find("begin_mutex_group")!=std::string::npos ) break;
        if( line.find("begin_variable")==std::string::npos ) continue;
        var_no++;
        
        int atom_no = -1;
        bool icheck = false;
        bool gcheck = false;
        while( getline(infile,line) ){
            if( line.find("end_variable")!=std::string::npos ) break;
            if( line.find("Atom")==std::string::npos ){ 
                line_backup = line;
                continue;
            }
            atom_no++;
            line.erase(line.find("Atom"), 4);
            string atom_str = split_string_2(line, "(,)");
            
            for(int i = 0; i < iatoms_str.size(); i++){
                if(icheck) break;
                if(atom_str.compare(iatoms_str[i]) == 0){ 
                    initf.push_back(atom_no);
                    icheck = true;
                    break;
                }
            }
            
            for(int i = 0; i < gatoms_str.size(); i++){
                if(gcheck) break;
                if(atom_str.compare(gatoms_str[i]) == 0){ 
                    goalf.push_back(var_no);
                    goalf.push_back(atom_no);
                    gcheck = true;
                    break;
                }
            }
            
            if(icheck && gcheck) break;
        } // end while
        if(!icheck){ 
            initf.push_back(atom_no+1);
            if( line_backup.find("<none of those>")==std::string::npos ){ 
                fileout << "using translator for init_difference of the window " << wid << endl;
		return -1;
            }
        }
    } // end while
    
    if(goal_atoms.size() != goalf.size()/2){
        fileout << "not using translator for goal_difference of the window " << wid << endl;
    }
    
    infile.clear();
    infile.seekg(0, ios::beg);

    vector<string> new_sas_str;
    while( getline(infile,line) ){
        if( line.find("begin_state")==std::string::npos ){ 
            outfile << line << endl;
            continue;
        }
        
        outfile << "begin_state" << endl;
        for(int i = 0; i < initf.size(); i++)
            outfile << initf[i] << endl;        
        outfile << "end_state" << endl;
        
        outfile << "begin_goal" << endl;      
        
        outfile << goal_atoms.size() << endl;
        
        for(int i = 0; i < goalf.size(); i+=2)
            outfile << goalf[i] << " " << goalf[i+1] << endl;
        
        outfile << "end_goal" << endl; 
        break;
    }
    
     while( getline(infile,line) )
        if( line.find("end_goal") != std::string::npos ) break;
     
     while( getline(infile,line) )
        outfile << line << endl;
     
     infile.close();
     outfile.close();
     
     string com = "mv " + outfile_name + " " + infile_name;
     int sys_out = system(com.c_str());
     
     return 0;
}

void reset_window_rank(){
    window_rank.clear();
    // size - cost - adh - icp - icl - ocp - ocl
    vector<pair<pair<pair<float, int>, int>, int> > vp;
    
    for(int x = 0; x < window.size(); x++){       
        if(window[x].exhausted()) continue;
        vector<int> wrank = window[x].get_rank();
        vp.push_back(make_pair(make_pair(make_pair((-1.0)*wrank[6]/wrank[0], (wrank[1]-wrank[2])), wrank[1]), x));  
    }
    
    sort(vp.rbegin(), vp.rend());
    
    
    for(int x = 0; x < vp.size(); x++)
        window_rank.push_back(vp[x].second);
    
    // fileout << "ranking (rid : wid):" << endl;
    // for(int r = 0; r < vp.size(); r++){
    //     int w = window_rank[r];
    //     vector<int> wrank = window[w].get_rank();
    //     fileout << "(" << r << " " << w << "): " << (1.0)*wrank[6]/wrank[0] << " " << (1.0)*wrank[4]/wrank[0] << " " << wrank[1]-wrank[2] << " " << wrank[1] << " : "  << vector_to_string(wrank) << " : " << vector_to_string(window[w].get_actions()) << endl;
    // }
    // fileout << endl;
    // return w_choice;
}

void set_window_rank(int pid, int policy_id, vector<int>& window_rank){
    window_rank.clear();
    // size - cost - adh - icp - icl - ocp - ocl
    vector< pair<pair<float, int>, int> > vp;
    
    // if(policy_id == 0){
    for(int x = 0; x < window.size(); x++){       
        if(window[x].exhausted() || contains(frozen_wids, x) || window[x].get_cost_improve() > 0 || window[x].get_trial_count(pid) >= bandit_planner[pid].get_trial_limit()) continue;
        vector<int> wrank = window[x].get_rank();
	// if(policy_id == 0) vp.push_back(make_pair(make_pair((-1.0)*wrank[0], wrank[1]), x));  
        if(policy_id == 0) vp.push_back(make_pair(make_pair((-1.0)*wrank[6]/wrank[0], wrank[1]), x));  
        else if(policy_id == 1) vp.push_back(make_pair(make_pair((1.0)*(wrank[1]-wrank[2]), wrank[1]), x));  
        else if(policy_id == 2) vp.push_back(make_pair(make_pair((-1.0)*wrank[4]/wrank[0], wrank[1]), x)); 

    }
    // }
    
    sort(vp.begin(), vp.end());
    
    // srand ( unsigned ( time(0) ) );
    // random_shuffle ( vp.begin(), vp.end() );
    
    for(int x = 0; x < vp.size(); x++)
        window_rank.push_back(vp[x].second);
}

vector<int> prioritize_windows(vector<int> *c_length, vector<double> *c_cost, vector<int> *improved_block_window_c, int improved_tot_c, int lowindex, int highindex){
    vector<int> sorted_length; 
    vector<int> priority_index, same_length_wi;
    vector<double> wcost;
    for(int i = lowindex; i <= highindex; i++){
        if(c_length[i].empty() ) continue;
        sorted_length.push_back(c_length[i].front());
    }
    sort(sorted_length.begin(), sorted_length.end());
    unique_sorted_vec(sorted_length);
    
    //    sorted_length.unique();
    //    sorted_length.reverse();
    //    cout << "sorted_cost: " << vector_to_string(sorted_cost) << endl;
    
   
    for (vector<int>::iterator sc = sorted_length.begin(); sc != sorted_length.end(); sc++){
        
        wcost.clear();
        same_length_wi.clear();
        
        for(int i = lowindex; i <= highindex; i++){
            if(c_length[i].empty() || c_cost[i].empty()) continue;
            if(c_length[i].front() == *sc){
                same_length_wi.push_back(i);
                wcost.push_back(c_cost[i].front());
            }
        }
        
        sort(wcost.begin(), wcost.end());
        unique_sorted_vec(wcost);
	//        wcost.sort();
	//        wcost.unique();
	//        wcost.reverse();
        
        for (vector<double>::iterator itw = wcost.begin(); itw != wcost.end(); itw++){
            
            for (vector<int>::iterator scw = same_length_wi.begin(); scw != same_length_wi.end(); scw++){
                if(!c_cost[*scw].empty() && c_cost[*scw].front() == *itw && !contains(priority_index, *scw)) priority_index.push_back(*scw);
            
            }
            
        }     

    }
    
    return priority_index;
}

vector<int> window_locs_in_prf(int iba[], int size){
    vector<int> wlocs;
    for(int i = 0; i < size; i++){
        if(iba[i] < 0) wlocs.push_back(i);
    }
    return wlocs;
}

vector<int> accepted_improvement(vector<int>* improved_block_window, vector<double>* improved_block_cost, int improved_tot, vector<int> block_vector, double improvement){
    vector<int> overlapped_index;
    if(improved_tot == 0){
        overlapped_index.push_back(0);
        return overlapped_index;
    }
    bool reject = false;
    for(int i = 0; i < improved_tot; i++){
        if(have_common(improved_block_window[i], block_vector)){
            if(improved_block_cost[i].empty()) continue;
            if(improvement == improved_block_cost[i].front()){
                if(block_vector.size() < improved_block_window[i].size()){
                    overlapped_index.push_back(i);
		    //  return i;                
                }
                else {
                    reject = true;
                    overlapped_index.clear();
                    break;
                }                
            }
            else if(improvement > improved_block_cost[i].front()){
                overlapped_index.push_back(i);
		// return i;
            }
            else if(improvement < improved_block_cost[i].front()){
                reject = true;
                overlapped_index.clear();
                break;
            }
        }
        
    }
    if(!reject && overlapped_index.empty()) overlapped_index.push_back(improved_tot);
    return overlapped_index;
}

bool is_valid_plan(vector<int> plan_steps){
    string outfile_name = temp_dir + "/new_plan.txt";
    ofstream outfile (outfile_name.c_str());        
    
    for (vector<int>::iterator it = plan_steps.begin(); it != plan_steps.end(); ++it){
        outfile << instance.actions[theplan[*it-1]].name << endl;
    }
    outfile.close();   
    
    string domain_name(arguments[1]);
    string prob_name(arguments[2]);
    string param = com_file + " " + validator_location + "/validate "+ domain_name + " " + prob_name + " " + outfile_name; 
    int output = system(param.c_str());
    
    string result = file_get_next_token_from_1st_match("log.txt", "Successful");
    if(result.compare("plans:") != 0){
        cout << "bad plan: "<< vector_to_string(plan_steps, ".") << endl;
        return false;
    }
    else return true;    
}

vector<int> retrieve_new_actions(int wid){
    ifstream filein_iws; 
    string filestr = results_dir + "/improved_windows.log";
    filein_iws.open(filestr.c_str(), ios::in);
    if(!filein_iws) cout << "unable to open: " << filestr << endl;
    
    vector<int> actions;
    
    string line;
    vector<string> token_vector;
    stringstream ss;
    while( getline(filein_iws, line) ){
        token_vector.clear();
        token_vector = split_string(line, "|");
        int w;            
        ss << token_vector[0];
        ss >> w;
        ss.clear();
        
        if(w != wid) continue;
        
        if(!token_vector[1].empty()){
            int act;
            ss << token_vector[1];
            while(ss >> act)
                actions.push_back(act);
            ss.clear();
        }
        break;
    }
    
    filein_iws.close();
    return actions;  
}

vector<int> retrieve_actions(int wid){
    ifstream filein_cws; 
    string filestr = results_dir + "/cwindow_selected.log";
    filein_cws.open(filestr.c_str(), ios::in);
    if(!filein_cws) cout << "unable to open: " << filestr << endl;
    
    vector<int> actions;
    
    string line;
    vector<string> token_vector;
    stringstream ss;
    while( getline(filein_cws, line) ){
        token_vector.clear();
        token_vector = split_string(line, "|");
        int w;            
        ss << token_vector[0];
        ss >> w;
        ss.clear();
        
        if(w != wid) continue;
        
        if(!token_vector[3].empty()){
            int act;
            ss << token_vector[3];
            while(ss >> act)
                actions.push_back(act);
            ss.clear();
        }
        break;
    }
    
    filein_cws.close();
    return actions;  
}

vector<int>* generate_init_goal_atoms(vector<int> pred_actions, vector<int> succ_actions){
    vector<int> *init_goal;
    init_goal = new vector<int> [2];
    
    init_goal[0] = get_vector(instance.init_atoms);
    init_goal[1] = get_vector(instance.goal_atoms);
    
    
    if(!pred_actions.empty()){
        for (vector<int>::iterator it = pred_actions.begin(); it != pred_actions.end(); ++it)
            init_goal[0] = difference_set( union_set(init_goal[0], add_vector[*it]), del_vector[*it]);
    }
    
    if(!succ_actions.empty()){
        for (vector<int>::reverse_iterator it = succ_actions.rbegin(); it != succ_actions.rend(); ++it)
                init_goal[1] = union_set( difference_set(init_goal[1], add_vector[*it]), pre_vector[*it]);
    }
    
    return init_goal;
    
}
vector<int>* generate_init_goal_atoms(vector<int> window_actions){
    // cout << "A: " << vector_to_string(window_actions) << endl;
    // cout << "B: " << vector_to_string(formulate_window_w(window_actions)) << endl << endl;
    // swatch_temp2 = get_wall_time();
    vector<int> *pwq = formulate_window_pwq(window_actions);
    vector<int> pred_actions, succ_actions;
    pred_actions.insert(pred_actions.end(), pwq[0].begin(), pwq[0].end()); pwq[0].clear();
    succ_actions.insert(succ_actions.end(), pwq[2].begin(), pwq[2].end()); pwq[2].clear();
    pwq[1].clear(); // freeing memory
    
    remove_val(pred_actions, 0); 
    remove_val(pred_actions, prf_size-1);    
    remove_val(succ_actions, 0); 
    remove_val(succ_actions, prf_size-1);     
    
    // NEW_CHECK ============================
    
    vector<int> full_plan_steps, temp;
    //    temp = pred_actions;
    full_plan_steps.insert(full_plan_steps.end(), pred_actions.begin(), pred_actions.end());
    //    temp = window_actions;
    full_plan_steps.insert(full_plan_steps.end(), window_actions.begin(), window_actions.end());
    //    temp = succ_actions;
    full_plan_steps.insert(full_plan_steps.end(), succ_actions.begin(), succ_actions.end());    

    if(check_plan_validity(full_plan_steps, 'o') < 0){ 
        cout << "INVALID PLAN STEPS for the sequence:" << endl;
        cout << "pred: " << vector_to_string(pred_actions, ".") << endl;
        cout << "wind: " << vector_to_string(window_actions, ".") << endl;
        cout << "succ: " << vector_to_string(succ_actions, ".") << endl;
        exit(1);
    }
    else full_plan_steps.clear();
    
    // END_NEW_CHECK ============================
    
    //    fileout << "generate_init_goal_atoms:" << endl;
    //    fileout << "window_new: " << vector_to_string(window_new) << endl;
    //    fileout << "succ_blocks: " << vector_to_string(succ_blocks) << endl;
    //    fileout << "pred_blocks: " << vector_to_string(pred_blocks) << endl;
    //    fileout << "unor_blocks: " << vector_to_string(unor_blocks) << endl;
    
    vector<int> *init_goal;
    init_goal = new vector<int> [4];
    
    init_goal[0] = get_vector(instance.init_atoms);
    init_goal[1] = get_vector(instance.goal_atoms);
    
    if(!pred_actions.empty()){
        for (vector<int>::iterator it = pred_actions.begin(); it != pred_actions.end(); ++it)
            init_goal[0] = difference_set( union_set(init_goal[0], add_vector[*it]), del_vector[*it]);
    }
    
    if(!succ_actions.empty()){
        for (vector<int>::reverse_iterator it = succ_actions.rbegin(); it != succ_actions.rend(); ++it)
                init_goal[1] = union_set( difference_set(init_goal[1], add_vector[*it]), pre_vector[*it]);
    }
    
    // init_goal[1] = difference_set(init_goal[1], init_goal[0]);
    // init_goal[0].sort();
    // init_goal[1].sort();
     
     init_goal[2] = pred_actions;
     init_goal[3] = succ_actions;
     
     // fileout << "END: " << get_wall_time()-swatch_temp2 << endl;
    
    return init_goal;
}

int store_new_sub_plan(int wid, int pid){
    stringstream ss;
    ss << wid;
    string outfile_name = temp_dir + "/splan." + ss.str();
    ss.clear();
    
    string terminate_string = "no solution!";
    
    ifstream infile;
    infile.open("./log_3.txt", ifstream::in);
    
    // string input;
    if(!infile.is_open())
    {
        cerr << "Error opening file - store_new_sub_plan()";
        exit(EXIT_FAILURE);
    }
    
    if(pid == 0){
        string dir = string(results_dir);
        vector<string> files = vector<string>();
        getdir(dir,files, "sas_plan");            
        int max = files.size();
        ostringstream max_oss;
        max_oss << max;

        string arasfile_name = results_dir + "/sas_plan." + max_oss.str();
        string com = "cp " + arasfile_name + " " + outfile_name; 
        int comout = system(com.c_str());        
        com = "rm " + results_dir + "/sas_plan.*" ; 
        comout = system(com.c_str());  

    }
    
    if(pid == 1){
        string dir = string(results_dir);
        vector<string> files = vector<string>();
        getdir(dir,files, "aplan");            
        int max = files.size();
        ostringstream max_oss;
        max_oss << max;

        string arasfile_name = results_dir + "/aplan." + max_oss.str();
        string com = "cp " + arasfile_name + " " + outfile_name; 
        int comout = system(com.c_str());        
        com = "rm " + results_dir + "/aplan.*" ; 
        comout = system(com.c_str());  

    }
    
    if(file_keyword_exist("./log_3.txt", "Plan length: 0 step")) return 0;
    
    infile.close();
    
    // #######################################################################
    
    // save_action_names_from_file
    vector<int> action_ids;
    string tok, temp; 
    
    infile.open(outfile_name.c_str(), ifstream::in);
    
    // string input;
    if(!infile.is_open())
    {
        cerr << "Error opening file - get_action_names_from_file()";
        exit(EXIT_FAILURE);
    }
    
    string token; 
    while(getline(infile, token))
    {
	size_t a_start = token.find_first_of("(");
	size_t a_end = token.find_first_of(")");
	if ((a_start == std::string::npos) ||
	    (a_end == std::string::npos) ||
	    (a_end < a_start)) {
	  cout << "note: skipping line " << token
	       << " from plan file " << outfile_name << endl;
	  continue;
	}
	temp = token.substr(a_start, (a_end + 1) - a_start);

        // token.insert(token.find_last_of(")"),";");
        // vector<string> vs = split_string(token, ";");
	// token.clear();
        // token = vs[0];
	// vs.clear();
        // token.push_back(')');
	
	bool found = false;
        for (int i = 0; (i < instance.n_actions()) && !found; i++) {
            tok = instance.actions[i].name->to_string(); 
            if(tok.compare(temp) == 0){ 
                action_ids.push_back(i);
		found = true;
            }
        }
	if (!found) {
	    cout << "error: action name " << temp
		 << " in plan file " << outfile_name
		 << " does not match any action" << endl;
	    assert(false);
	}
    }
    infile.close();
    
    window[wid].set_actions_new_str(vector_to_string(action_ids, "."));
    
    // cout << "N: " << window[wid].get_actions_new_str() << endl;
    
    return 1;
}

void write_file_sub_problem(const char *problem_name, vector<int> init_atoms, vector<int> goal_atoms, int wid){
    ifstream infile;
    infile.open(problem_name, ifstream::in);
    
    stringstream ss;
    ss << wid;
    string outfile_name = temp_dir + "/sprob." + ss.str();
    ss.clear();
    
    ofstream outfile (outfile_name.c_str());
    string input;
    if(!infile.is_open())
    {
        cerr << "Error opening file - write_file_sub_problem()";
        exit(EXIT_FAILURE);
    }

    bool flag = false;
    while(!infile.eof())
    {
        infile >> input;
        
        if(input.compare("(DEFINE") == 0 || input.compare("(define") == 0){
            flag = true;
        }
        if(!flag){
            continue;
        }
        
        if(input.compare("(:INIT") == 0 || input.compare("(:init") == 0){
            break;
        }
        
        outfile << input;
        outfile << " ";
    }
    
    infile.close(); // ??
    
    // inserting init_atoms
    outfile << endl << "(:INIT " << endl;

    for (vector<int>::iterator it = init_atoms.begin(); it != init_atoms.end(); it++){
      HSPS::PDDL_Name* atom_name = (HSPS::PDDL_Name*)instance.atoms[*it].name->cast_to("PDDL_Name");
      if (atom_name != NULL) {
	if (!atom_name->is_neg())
	  outfile << instance.atoms[*it].name << endl;
      }
      else {
	outfile << instance.atoms[*it].name << endl;
      }
    }

    //=================================
    string str = temp_dir + "/static_atom.txt";
    ifstream token_file(str.c_str());
    string token;
    string static_tokens;
    while(getline(token_file, token))
    {
        token.erase(token.begin(), token.begin()+7);
        token.erase(token.end()-1, token.end());
        outfile << token << endl;   
    }    
    
    token_file.close();
    //============================================= 
    ifstream my_file(problem_name);
    string tok;  
    while(getline(my_file, tok))
    {
        // new
        if(tok.find("(= (TOTAL-COST) 0)") !=string::npos || tok.find("(= (total-cost) 0)") !=string::npos)
            continue;
        // end-new
        
        size_t found;
        found = tok.find("(=");
        if (found!=string::npos){ 
            outfile << tok << endl;
        }

    }
    my_file.close();   
    // outfile << "(= (TOTAL-COST) 0)) " << endl;
    //============================================
    outfile << endl << "(= (TOTAL-COST) 0))" << endl;
    
    // inserting goal_atoms
    outfile << "(:GOAL (AND " << endl;
    for (vector<int>::iterator it = goal_atoms.begin(); it != goal_atoms.end(); it++){ 
        outfile << instance.atoms[*it].name << endl;
    }    
    outfile << "))  (:METRIC MINIMIZE (TOTAL-COST))) " << endl;
    
    // infile.close();
    outfile.close();
    
    
    // new =============================================
    
    if(wid != -1 && window[wid].get_cost_improve() == 0){
        vector<int> cwindow = string_to_vector(window[wid].get_actions_str(), ".");
        stringstream ss;
        ss << wid;
        string temp_str = temp_dir + "/splan." + ss.str();
        ss.clear();
        ofstream outfile_splan (temp_str.c_str());

        for (vector<int>::iterator it = cwindow.begin(); it != cwindow.end(); ++it)
            outfile_splan << instance.actions[theplan[*it-1]].name << endl;
        outfile_splan.close();
    }
    // new-end =========================================
}

string exec(const char* cmd) {
    char buffer[128];
    string result = "";    

    return result;
}

vector<int> get_leaves(vector<int> macro){
    vector<int> leaves = macro;
    vector<int> from_macro;
    vector<int> to_macro;
    
    for (vector<int>::iterator it = macro.begin(); it != macro.end(); ++it){ 
        int to_action = *it;
        from_macro.clear();
        to_macro.clear();
        from_macro = macro;
        remove_val(from_macro, to_action);
        to_macro.push_back(to_action);
        if(have_path(prf_order_vector, from_macro, to_macro, prf_size)){
            remove_val(leaves, to_action);            
            continue;
        }
        
        // further possibility // temporary_off
        
	// for(int j = mfb_tot-1; j >= 0; j--){
	//     if(!contains(mfb[j], to_action)) continue;
	//     from_macro.clear();
	//     to_macro.clear();
	//     
	//     to_macro = intersection_set(mfb[j], macro);
	//     from_macro = difference_set(macro, to_macro);
	//     if(from_macro.empty()) continue;
	//     if(have_path(prf_order_vector, from_macro, to_macro, prf_size)){
	//         leaves.remove(to_action);            
	//         break;
	//     }
	// } // inner for
    } // outer-for
    
    return leaves;
}

vector<int> get_linearized_steps_noblock(vector<int> macro){
    if(macro.empty() || macro.size() == 1) return macro;
    vector<int> vls;
    
    int top = 0;
    int front = macro[top++];
    vls.push_back(front);
    
    while(top < macro.size() ){
        front = macro[top++];
        int pos = 0;
        for(int j = 0; j < vls.size(); j++){
            if(have_path(prf_order_vector, vls[j], front, prf_size)) pos = j+1;
        }
        vls.insert(vls.begin()+pos, front);
    }
    
    return vls;
}

vector<int> insert_lin_block(vector<int> lin_blocks, int b){
    if(lin_blocks.empty()){
        lin_blocks.push_back(b);
        return lin_blocks;
    }
    // vector<int> vlb = vector_to_vector(lin_blocks);
    int pos = 0;
    for(int j = 0; j < lin_blocks.size(); j++){        
        if(have_path(prf_order_vector, mfb[lin_blocks[j]], mfb[b], prf_size)) pos = j+1;
    }
    lin_blocks.insert(lin_blocks.begin()+pos, b);
    return lin_blocks;
}

vector<int> get_linearized_blocks(int bid){
    if((int)mfb[bid].size() <= 1) return mfb[bid];
    
    vector<int> macro = mfb[bid];
    vector<int> noblock = macro;
    vector<int> linearized_steps, lin_blocks; 
    for (vector<int>::iterator it = block_tree[bid].begin(); it != block_tree[bid].end(); ++it){
        noblock = difference_set(noblock, mfb[*it]);
        lin_blocks = insert_lin_block(lin_blocks, *it);
    }
    
    
    for (vector<int>::iterator it = lin_blocks.begin(); it != lin_blocks.end(); ++it){ 
       if(block_tree[*it].empty()){ 
           vector<int> ls = get_linearized_steps_noblock(mfb[*it]);
           linearized_steps.insert(linearized_steps.end(), ls.begin(), ls.end()); ls.clear();
       }
       else{
           vector<int> lb = get_linearized_blocks(*it);
           linearized_steps.insert(linearized_steps.end(), lb.begin(), lb.end()); lb.clear();
       }
    }
    
    int top = 0;    
    while(top < noblock.size()){
        int front = noblock[top++];
        int pos = 0;
        for(int j = 0; j < linearized_steps.size(); j++){
            if(have_path(prf_order_vector, linearized_steps[j], front, prf_size)) pos = j+1;
        }
        linearized_steps.insert(linearized_steps.begin()+pos, front);
    }
    
    return linearized_steps;
}

vector<int> get_linearized_steps(vector<int> macro){
    // cout << "macro: " << vector_to_string(macro) << endl;
    // if(macro.size() == 1) return macro;
    
    vector<int> linearized_steps, lin_blocks; 
    vector<int> macro_temp = macro;
    
    while(!macro_temp.empty()){
        int front = macro_temp.front();
        for(int j = 0; j <= mfb_tot-1; j++){
            if( !contains(mfb[j],front)) continue;
            macro_temp = difference_set(macro_temp, mfb[j]);
            lin_blocks = insert_lin_block(lin_blocks, j);
            break;
        }        
    }
    
    // cout << "lin_blocks: " << vector_to_string(lin_blocks) << endl;
    
    for (vector<int>::iterator it = lin_blocks.begin(); it != lin_blocks.end(); ++it){
        vector<int> lb = mfb[*it];
        linearized_steps.insert(linearized_steps.end(), lb.begin(), lb.end()); lb.clear();
    }
    
    // cout << "linearized_steps_1: " << vector_to_string(linearized_steps) << endl;
    
    linearized_steps = intersection_set(linearized_steps, macro);
    
    // cout << "linearized_steps_2: " << vector_to_string(linearized_steps) << endl;
    
    return linearized_steps;
}

vector<int>* formulate_window_pwq(vector<int> macro, vector<int> boundary){
    vector<int> *pwq;
    pwq = new vector<int> [3];
    pwq[1] = macro;
    // fileout << "1: " << get_wall_time()-swatch_temp2 << endl;
    for(int j = 0; j < mfb_tot; j++){
        if(!have_strict_subset(boundary, mfb[j])) continue;
        if(have_subset(pwq[0], mfb[j]) || have_subset(macro, mfb[j]) || have_subset(pwq[2], mfb[j]))
            continue;        
        else if(have_subset(mfb[j], macro)){ 
            macro = mfb[j];
        }
        else if(have_path(prf_order_vector, macro, mfb[j], prf_size))
            pwq[2] = union_set(pwq[2], mfb[j]);
        else 
            pwq[0] = union_set(pwq[0], mfb[j]);
    }
        
    // addition
    vector<int> remaining_actions = boundary;
    remaining_actions = difference_set(remaining_actions, pwq[0]);
    remaining_actions = difference_set(remaining_actions, macro);
    remaining_actions = difference_set(remaining_actions, pwq[2]);
    vector<int> temp_macro;
    for (vector<int>::iterator it = remaining_actions.begin(); it != remaining_actions.end(); ++it){ 
        temp_macro.clear();
        temp_macro.push_back(*it);
        if(have_path(prf_order_vector, macro, temp_macro, prf_size))
            pwq[2] = union_set(pwq[2], temp_macro);
        else 
            pwq[0] = union_set(pwq[0], temp_macro);
    }
    
    // fileout << "3: " << get_wall_time()-swatch_temp2 << endl;
    
    pwq[0] = get_linearized_steps(pwq[0]);
    macro = get_linearized_steps(macro);
    
    // cout << "bl: " << vector_to_string(pwq[2]) << endl;
    pwq[2] = get_linearized_steps(pwq[2]);
    // cout << "al: " << vector_to_string(pwq[2]) << endl;
    
    // fileout << "4: " << get_wall_time()-swatch_temp2 << endl;
    
    if(equal_set(macro, pwq[1]))
        return pwq;
    else{
        vector<int> *pwq_rec = formulate_window_pwq(pwq[1], macro);
        pwq[0].insert(pwq[0].end(), pwq_rec[0].begin(), pwq_rec[0].end()); pwq_rec[0].clear();
        pwq[2].insert(pwq[2].begin(), pwq_rec[2].begin(), pwq_rec[2].end()); pwq_rec[2].clear();
        pwq_rec[1].clear(); // clear memory
        return pwq;
    }
}

vector<int>* formulate_window_pwq(vector<int> macro){
    vector<int> boundary;
    for (int j = 1; j < prf_size-1; j++) boundary.push_back(j);
    boundary = difference_set(boundary, redundant_actions);
    
    vector<int> *pwq = formulate_window_pwq(macro, boundary);
        
    return pwq;
}

vector<int> get_leaf(vector<int> *order_vector, vector<int> macro){
     vector<int> leaf;
     for (vector<int>::iterator it = macro.begin(); it != macro.end(); ++it){    
         vector<int> l = order_vector[*it];
         if(!l.empty() && (int)l.front() == -1) continue;
         l = intersection_set(l, macro);
         if(l.empty()) leaf.push_back(*it);
     }
     return leaf;
}
 
vector<int> formulate_window_w(vector<int> macro){
    // swatch_temp2 = get_wall_time();
    vector<int> intm_nodes = get_intermediate_nodes(prf_order_vector, prf_size, macro);
    // fileout << vector_to_string(macro) << ":" << endl;
    
    // cout << vector_to_string(intm_nodes) << ":" << endl;
    // fileout << get_wall_time()-swatch_temp2 << endl;
    // cout << macro.size() << ": [gin2]: " << get_wall_time()-swatch_temp2 << endl;
    macro = union_set(macro, intm_nodes);
    
    for(int j = 0; j < mfb_tot; j++){
        if(have_common(mfb[j], macro) && !have_subset(mfb[j], macro))
            macro = union_set(macro, mfb[j]);        
    }
    
    macro = get_linearized_steps(macro);
    
    // if(macro.size() > 400) exit(1);
    
    return macro;
}

vector<int>* formulate_window_all(vector<int> macro){
    vector<int> *pwq;
    pwq = new vector<int> [3];
    vector<int> intm_nodes = get_intermediate_nodes(prf_order_vector, prf_size, macro);
    macro = union_set(macro, intm_nodes);
    // cout << "intm_nodes: " << vector_to_string(intm_nodes) << endl;
    
    for(int j = 0; j < mfb_tot; j++){
        if(have_common(mfb[j], macro) && !have_subset(mfb[j], macro))
            macro = union_set(macro, mfb[j]);        
    }
    
    macro = get_linearized_steps(macro);
    pwq[1] = macro;
    
    for(int j = 0; j < mfb_tot; j++){
        if(have_subset(pwq[0], mfb[j]) || have_subset(macro, mfb[j]) || have_subset(pwq[2], mfb[j]))
            continue;        
        else if(have_subset(mfb[j], macro)){ 
            macro = mfb[j];
        }
        else if(have_path(prf_order_vector, macro, mfb[j], prf_size))
            pwq[2] = union_set(pwq[2], mfb[j]);
        else 
            pwq[0] = union_set(pwq[0], mfb[j]);
    }
    
    pwq[0] = get_linearized_steps(pwq[0]);
    macro = get_linearized_steps(macro);
    pwq[2] = get_linearized_steps(pwq[2]);
    
    vector<int> pred, succ;
    
    // int count = 0;
    // int max_count = pwq[1].size();
    // for (vector<int>::iterator it = macro.begin(); it != macro.end(); ++it){ 
    //     if(count >= max_count){
    //         succ.push_back(*it);
    //     } 
    //     else if(contains(pwq[1], *it)){
    //         count++;
    //     }
    //     else
    //         pred.push_back(*it);
    // }
    
    vector<int> temp;
    for (vector<int>::iterator it = macro.begin(); it != macro.end(); ++it){ 
        if(contains(pwq[1], *it)) continue;
        temp.clear();
        temp.push_back(*it);
        if(have_path(prf_order_vector, pwq[1], temp, prf_size))
            succ.push_back(*it);
        else
            pred.push_back(*it);
    }
    
    
    pwq[0].insert(pwq[0].end(), pred.begin(), pred.end()); pred.clear();
    pwq[2].insert(pwq[2].begin(), succ.begin(), succ.end()); succ.clear();
    
    return pwq;
}

vector<int>* get_block_tree(vector<int> *kblocks, int tot){
    vector<int> *bhr;
    bhr = new vector<int> [tot];
    
    for(int i = 0; i < tot-1; i++){
        vector<int> elem = kblocks[i];
        vector<int> picked;
        for(int j = i+1; j < tot; j++){
            if(have_subset(kblocks[i], kblocks[j]) && !have_common(picked, kblocks[j])){
                bhr[i].push_back(j);
		// temp = kblocks[j];
                picked.insert(picked.end(), kblocks[j].begin(), kblocks[j].end());
            }
        }
    }
    
    return bhr;
}

void modify_actions_orderings_based_on_blocks(){
    for (int b1 = 0; b1 < mfb_tot; b1++){
        for (int b2 = 0; b2 < mfb_tot; b2++){
            if(b1 == b2) continue;
            if(have_common(mfb[b1], mfb[b2])) continue;
            if(have_path(prf_order_vector, mfb[b1], mfb[b2], prf_size)){
                for (vector<int>::iterator it1 = mfb[b1].begin(); it1 != mfb[b1].end(); ++it1){ 
                    for (vector<int>::iterator it2 = mfb[b2].begin(); it2 != mfb[b2].end(); ++it2){
                        if(!contains(prf_full[*it1], *it2))
                            prf_full[*it1].push_back(*it2);
                    }
                    
                }
            }
        }
    }

    for (int j = 0; j < prf_size; j++) {
        prf_order_vector[j].clear();
	// prf_order_vector_r[j].clear(); // new
    }
    prf_order_vector = delete_transitive_order(prf_full, prf_size);
    // prf_order_vector_r = reverse_order_vector(prf_order_vector); // new
    
    set_action_path();
}

void print_block_file(int btype){
    ofstream blockout; 
    string appfilestr = temp_dir + "/bdp.txt";
    blockout.open(appfilestr.c_str(), ios_base::app);
    if(!blockout){
        cout << "unable to fileout" << endl;
    }
    
    if(btype == 2){
        blockout << endl << "# extended_blocks:" << endl;
        for (int i = 0; i < mfb_tot; i++){
            if(mfb[i].empty()) continue;
            if(mfb[i].front() == 0 || mfb[i].front() == prf_size-1) continue;
            blockout << "b_" << i << ": { " << vector_to_string(mfb[i], " ") << " }" << endl;
        }
        
        if(!block_tree[0].empty()){
            blockout << endl << "# extended_block_hierarchy:" << endl;
            for (int i = 0; i < mfb_tot; i++){
                if(block_tree[i].empty()) break;
                blockout << "b_" << i << ": b_{ " << vector_to_string(block_tree[i], " ") << " }" << endl; 
            }
        }
    
        blockout.close();
        return;
    }
    
    vector<int> *prf_temp;
    prf_temp = new vector<int> [prf_size];
    for (int i = 0; i < prf_size; i++)
        prf_temp[i] = prf_order_vector[i];
    
    blockout << "# input_plan:" << endl;
    blockout << "0 : INIT" << endl;
    for (int i = 1; i <= prf_size-2; i++)
        blockout << i << " : " << instance.actions[theplan[i-1]].name << endl;
    blockout << prf_size-1 << " : GOAL" << endl;

    blockout << endl << "# necessary_orderings_among_steps:" << endl;
    for (int i = 1; i <= prf_size-2; i++){
        remove_val(prf_temp[i], prf_size-1);
        if(!prf_temp[i].empty() && prf_temp[i].front() == -1) continue;
        blockout << i << " : "<< vector_to_string(prf_temp[i], " ") << endl;
    }

    blockout << endl << "# basic_blocks:" << endl;
    for (int i = 0; i < mfb_tot; i++){
        if(mfb[i].empty()) continue;
        if(mfb[i].front() == 0 || mfb[i].front() == prf_size-1) continue;
        blockout << "b_" << i << ": { " << vector_to_string(mfb[i], " ") << " }" << endl;
    }
  
    if(!block_tree[0].empty()){
        blockout << endl << "# basic_block_hierarchy:" << endl;
        for (int i = 0; i < mfb_tot; i++){
            if(block_tree[i].empty()) break;
            blockout << "b_" << i << ": b_{ " << vector_to_string(block_tree[i], " ") << " }" << endl; 
        }
    }

    if(!redundant_actions.empty()){
      blockout << endl << "# redundant_steps:" << endl;
      blockout << vector_to_string(redundant_actions, " ") << endl;
    }  
    
    blockout << endl;
    
    delete [] prf_temp;
    
    blockout.close();
}

void formulate_extended_blocks(){
    vector<int> *mfb_temp, *block_tree_temp;
    mfb_temp = new vector<int> [mfb_tot];
    block_tree_temp = new vector<int> [mfb_tot];
    
    vector<int> *bu_prf;
    bu_prf = reverse_order_vector(prf_order_vector);
    
    for(int j = 0; j < mfb_tot; j++){
        mfb_temp[j] = mfb[j];
        block_tree_temp[j] = block_tree[j];
        
        mfb[j].clear();
        block_tree[j].clear();
    }
    
    // find the last node with multi children
    int last_node = -1;
    for(int j = 0; j < mfb_tot; j++){
        if(block_tree_temp[j].size() > 1)
            last_node = j;
        else break;
    }
    
    for(int j = last_node; j >= 0; j--){
        vector<int> steps = mfb_temp[j];
        vector<int> steps_temp = steps;
        
        vector<int> blocks = block_tree_temp[j];
        while(!steps.empty()){
            int front, pblock, cblock;   
            
            front = steps.front();            
            for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
                if(contains(mfb_temp[*it], front)){
                    pblock = *it;
                    break;
                }
            }
                        
            steps = difference_set(steps, mfb_temp[pblock]); // excluding steps from producer block
            
            // succ
            vector<int> succ_steps = nearest_cluster_neighbors(prf_order_vector, mfb_temp[pblock]);
            succ_steps = intersection_set(succ_steps, steps_temp);
            remove_val(succ_steps, prf_size-1);
            
            vector<int> succ_blocks;
            for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
                if(have_common(mfb_temp[*it], succ_steps)){
                    succ_blocks.push_back(*it);
                }
            }
            
            if(succ_blocks.empty()) continue;
            if(succ_blocks.size() > 1) continue; // can not be extended
            cblock = succ_blocks.front();
            
            //pred
            vector<int> pred_steps = nearest_cluster_neighbors(bu_prf, mfb_temp[cblock]);
            pred_steps = intersection_set(pred_steps, steps_temp);
            remove_val(pred_steps, 0);
            
            vector<int> pred_blocks;
            for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
                if(have_common(mfb_temp[*it], pred_steps)){
                    pred_blocks.push_back(*it);
                }
            }
            
	    // if(pred_blocks.empty()) continue;
            if(pred_blocks.size() > 1) continue; // can not be extended
            
            // merge cblock into pblock
            mfb_temp[pblock].insert(mfb_temp[pblock].end(), mfb_temp[cblock].begin(), mfb_temp[cblock].end()); mfb_temp[cblock].clear();
	    // mfb_temp[pblock].sort();
            remove_val(blocks, cblock);
            
            // remove cblock existence
            block_tree_temp[cblock].clear();
            block_tree_temp[cblock].push_back(-1);
            
            for(int j = last_node; j >= 0; j--){
                if(contains(block_tree_temp[j], cblock)){
                    remove_val(block_tree_temp[j], cblock);
                    if(block_tree_temp[j].size() == 1){ // all intermediate blocks are merged
                        block_tree_temp[pblock].clear();
                        block_tree_temp[pblock].push_back(-1);
                        remove_val(block_tree_temp[j], pblock);
                        mfb_temp[pblock].clear();     
                        steps.clear();
                        blocks.clear();
                    }
                    break;
                }
            }
             
            
        }
    }
    
    // outer blocks merge ============================================
    vector<int> steps, blocks;
    // taking outer blocks
    for(int j = 0; j < mfb_tot; j++){        
        if(!block_tree_temp[j].empty() && block_tree_temp[j].front() == -1) continue;
        bool sub_block = false;
        for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
            if(contains(block_tree_temp[*it], j)){
                sub_block = true;
                break;
            }
        }
        if(!sub_block)
            blocks.push_back(j);
    }
        
    for(int j = 1; j < prf_size-1; j++)
        steps.push_back(j);
    steps = difference_set(steps, redundant_actions);
    vector<int> steps_temp = steps;
    
    while(!steps.empty()){
        int front, pblock, cblock;
        vector<int> psteps, csteps;
        
        front = steps.front();            
        // get pblock
        for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
            if(contains(mfb_temp[*it], front) ){
                pblock = *it;
                break;
            }
        }

        psteps = mfb_temp[pblock];
        steps = difference_set(steps, psteps); // excluding steps from producer block
        
        // succ
        vector<int> succ_steps = nearest_cluster_neighbors(prf_order_vector, psteps);
        succ_steps = intersection_set(succ_steps, steps_temp); // ???
        remove_val(succ_steps, prf_size-1);

        vector<int> succ_blocks;
        
        for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
            if(have_common(mfb_temp[*it], succ_steps)){
                succ_blocks.push_back(*it);
            }
        }
        
        

        if(succ_blocks.empty()) continue;
        if(succ_blocks.size() > 1) continue; // can not be extended
        cblock = succ_blocks.front();
        
        //pred
        vector<int> pred_steps = nearest_cluster_neighbors(bu_prf, mfb_temp[cblock]);
        pred_steps = intersection_set(pred_steps, steps_temp);
        remove_val(pred_steps, 0);

        vector<int> pred_blocks;
        for (vector<int>::iterator it = blocks.begin(); it != blocks.end(); ++it){ 
            if(have_common(mfb_temp[*it], pred_steps)){
                pred_blocks.push_back(*it);
            }
        }
        
        if(pred_blocks.size() > 1) continue; // can not be extended
                
        mfb_temp[pblock].insert(mfb_temp[pblock].end(), mfb_temp[cblock].begin(), mfb_temp[cblock].end()); mfb_temp[cblock].clear();
	// mfb_temp[pblock].sort();
        block_tree_temp[pblock].insert(block_tree_temp[pblock].end(), block_tree_temp[cblock].begin(), block_tree_temp[cblock].end()); block_tree_temp[cblock].clear();
        block_tree_temp[cblock].push_back(-1);
	// block_tree_temp[pblock].sort();        
        remove_val(blocks, cblock);
        
    }
    
    // cout << "go" << endl;

    // regenerating mfb
    vector<pair<int,size_t> > vp;
    for(int i = 0; i < mfb_tot; i++){
        mfb[i].clear();
        block_tree[i].clear();
        
        if(mfb_temp[i].empty()) continue;
        vp.push_back(make_pair(mfb_temp[i].size(), i));
    }
    sort(vp.rbegin(), vp.rend());
    
    mfb_tot = vp.size();
    for (size_t i = 0 ; i != vp.size() ; i++)
        mfb[i] = mfb_temp[vp[i].second];
    
    block_tree = get_block_tree(mfb, mfb_tot);
    
    for(int i = 0; i < mfb_tot; i++){
        mfb_temp[i].clear();
        block_tree_temp[i].clear();    
    }
    delete [] mfb_temp;
    delete [] block_tree_temp;
    delete [] bu_prf;
    // write_file(temp_dir + "/BDP_extended.dot", prf_order_vector, flex, "");
    
    // ofstream blockout; 
    // string appfilestr = temp_dir + "/block_vector";
    // blockout.open(appfilestr.c_str(), ios_base::app);
    // if(!blockout){
    //     cout << "unable to fileout" << endl;
    // }
    // 
    // fileout << "blocks_extended:" << endl;
    // blockout << "blocks_extended:" << endl;
    // print_2d_vector_to_file(mfb, mfb_tot, ":", fileout);
    // print_2d_vector_to_file(mfb, mfb_tot, ":", blockout);
    // 
    // fileout << "block_tree_extended:" << endl;
    // print_2d_vector_to_file(block_tree, mfb_tot, ":", fileout);
    // blockout.close();
}

void formulate_blocks(){
    vector<int> *mfb_temp;
    int mfb_temp_tot = 0;
    bool found = false;
    mfb_temp = new vector<int> [prf_size*10];
    
    // printing the final block vector to file
    // ofstream fileout; 
    // string appfilestr = "./record/" + logfile;
    // fileout.open(appfilestr.c_str(), ios_base::app);
    // if(!fileout){
    //     cout << "unable to fileout" << endl;
    // }
      
    // creating unique blocks
    for(int i = 0; i < mac_tot; i++){
        if(macro_clusters[i].size() < 2) continue;
        found = false;
        for(int j = 0; j < mfb_temp_tot; j++){
            if(equal_set(mfb_temp[j], macro_clusters[i])){
                found = true;
                break;
            }
        }
        if(!found){
            for (vector<int>::iterator it = macro_clusters[i].begin(); it != macro_clusters[i].end(); ++it){ 
                mfb_temp[mfb_temp_tot].push_back(*it);
            }
            mfb_temp_tot++;
        }
    }
    
    // adding unit blocks
    for(int j = 0; j < prf_size; j++){
        if(!prf_order_vector[j].empty() && prf_order_vector[j].front() == -1){
            continue;
        }
        found = false;
        for(int k = 0; k < mfb_temp_tot; k++){
            if(mfb_temp[k].size() == 1 && mfb_temp[k].front() == j){
	        // if(contains(mfb_temp[k], j)){
                found = true;
                break;
            }
        }
        if(!found){
	    // mfb_temp[obt].clear();
            mfb_temp[mfb_temp_tot++].push_back(j);
        }
    }
    
    vector<pair<int,size_t> > vp;
    for(int i = 0; i < mfb_temp_tot; i++){
        vp.push_back(make_pair(mfb_temp[i].size(), i));
    }
    sort(vp.rbegin(), vp.rend());
    
    mfb_tot = mfb_temp_tot;
    mfb = new vector<int> [mfb_tot];
    for (size_t i = 0 ; i != vp.size() ; i++)
        mfb[i] = mfb_temp[vp[i].second];
    
    
    block_tree = get_block_tree(mfb, mfb_tot);
    // fileout << "block_tree:" << endl;
    // print_2d_vector_to_file(block_tree, mfb_tot, ":", fileout);
    write_file(temp_dir + "/BDP_main.dot", prf_order_vector, flex, "");
}

void remove_inactive_actions(){
    for (int j = prf_size-2; j >= 0 ; j--){
        if(!straight_dependent_vector[j].empty()) continue;
	// prf_order_vector[j].clear();
	// prf_order_vector[j].push_back(-1);

        prf_full[j].clear();
        prf_full[j].push_back(-1);
        redundant_actions.push_back(j);

	// for (int c = 0; c < prf_size; c++){
	//     action_path_bit.reset((j*prf_size)+c);
	// }

        for (int k = 0; k < prf_size-1; k++){
  	    // prf_order_vector[k].remove(j);  
            remove_val(prf_full[k], j);  
            remove_val(straight_dependent_vector[k], j);
	    // action_path_bit.reset((k*prf_size)+j);
        } 
        
    }
    
    for (int j = 0; j < prf_size; j++) prf_order_vector[j].clear();
    prf_order_vector = delete_transitive_order(prf_full, prf_size); 
    set_action_path();
    // set_tot_inout_edges();
}

vector<int> resolve_ap_dependency(vector<int> macro1, vector<int> macro2){
    vector<int> *bu_prf;
    vector<int> ap, res_actions, add_pre;
    // m1 = macro_vector(macro1);
    // m2 = macro_vector(macro2);
    // add_pre = intersection_set(m1[1], m2[0]);
    add_pre = get_producer_consumer_atoms(macro1, macro2);
    int action_up;
    
    bu_prf = reverse_order_vector(prf_order_vector);
    // cout << "add_pre: " ; print_vector(add_pre); cout << endl; 
    
    for (vector<int>::iterator atom = add_pre.begin(); atom != add_pre.end(); ++atom){    
      // int atm = *atom;
        res_actions = responsible_actions_for_add(macro1, macro2, *atom);
	// cout << "responsible_actions_for_adding atom (" << *atom << ") for AP in macro (";  print_vector(macro1); cout << ") is: "; print_vector(res_actions); cout << endl; 
        vector<int> ap_tmp;
        for (vector<int>::iterator action_r = res_actions.begin(); action_r != res_actions.end(); action_r++){
            action_up = nearest_action(bu_prf, macro1, *action_r, *atom, "pre", "bu");
            if(action_up == -1){
                ap_tmp.clear();
                continue;
		// ap.push_front(-1);
		// delete [] bu_prf;
		// return ap;
            }
	    // if(contains(ap, action_up)){
	    //     continue;
	    // }
            // inserting all intermediate actions
            ap_tmp.push_back(action_up);
            for (vector<int>::iterator mac_element = macro1.begin(); mac_element != macro1.end(); mac_element++){
                if(!have_path(prf_order_vector, action_up, *mac_element, prf_size)){
                    continue;
                }
                vector<int> inodes = difference_set(
                                        get_intermediate_nodes(
                                                prf_order_vector, prf_size, action_up, *mac_element
                                        ), macro1                                        
                                   );
                ap_tmp.insert(ap_tmp.end(), inodes.begin(), inodes.end());
                inodes.clear();
            }
            break;
        } // end-action-for
        if(action_up == -1){
            ap.clear();
            ap.push_back(-1);
            delete [] bu_prf;
            return ap;
        }
        else{
            ap.insert(ap.end(), ap_tmp.begin(), ap_tmp.end());
            ap_tmp.clear();
        }
    } // end-atom-for
    delete [] bu_prf;
    // ap.sort();    
    unique_vec(ap); //.unique();
    return ap;
}

vector<int> resolve_dk_dependency(vector<int> macro1, vector<int> macro2){
    vector<int> deleter_knight, deleted_atoms, dk;
    deleted_atoms = get_deleted_atoms(macro1);
    
    if(deleted_atoms.empty()) return deleter_knight;
    
    
    for(vector<int>::iterator it = macro2.begin(); it != macro2.end(); ++it)
        deleter_knight = union_set(deleter_knight, add_vector[*it]);
    
    deleter_knight = difference_set(deleter_knight, get_causally_produced_atoms(macro2));
    if(deleter_knight.empty()) return deleter_knight;
    deleter_knight = difference_set(deleter_knight, get_consumed_atoms(macro2));
    if(deleter_knight.empty()) return deleter_knight;
    deleter_knight = difference_set(deleter_knight, get_deleted_atoms(macro2)); 
    if(deleter_knight.empty()) return deleter_knight;
    deleter_knight = intersection_set(deleted_atoms, deleter_knight);
    if(deleter_knight.empty()) return deleter_knight;
    
    vector<int> consumer_vector, consumer_vector_temp; 
    for(int i = 1; i < prf_size-1; i++) consumer_vector.push_back(i);
    consumer_vector = difference_set(consumer_vector, macro1);
    consumer_vector = difference_set(consumer_vector, macro2);
    consumer_vector = difference_set(consumer_vector, redundant_actions);
    
    consumer_vector_temp = consumer_vector;
    vector<int> temp_vector;
    for (vector<int>::iterator it = consumer_vector_temp.begin(); it != consumer_vector_temp.end(); ++it){
        if(!have_common(pre_vector[*it], deleter_knight)){ 
            remove_val(consumer_vector, *it);
            continue;
        }
        temp_vector.clear();
        temp_vector.push_back(*it);
        if(have_path(prf_order_vector, temp_vector, macro1, prf_size) || have_path(prf_order_vector, temp_vector, macro2, prf_size)){
            remove_val(consumer_vector, *it);
            continue;
        }
    }  
    
    vector<int> *bu_sd;
    bu_sd = reverse_order_vector(straight_dependent_vector);
    
    vector<int> deleter_knight_temp = deleter_knight;
    
    for (vector<int>::iterator it1 = deleter_knight_temp.begin(); it1 != deleter_knight_temp.end(); ++it1){
        int dk_atom = *it1;
	//        bool dk_guard = false;
        for (vector<int>::iterator it2 = consumer_vector.begin(); it2 != consumer_vector.end(); ++it2){             
            int consumer = *it2;
            if(contains(dk, consumer)) continue;
            vector<int> producer_vector = bu_sd[consumer];
            vector<int> pro_con;
            for (vector<int>::iterator it3 = producer_vector.begin(); it3 != producer_vector.end(); ++it3){
                int producer = *it3;
                if(!contains(sd_atoms[producer][consumer],dk_atom)) continue;
                pro_con.clear();
                pro_con.push_back(producer);
                if(have_path(prf_order_vector, macro1, pro_con, prf_size)) continue;
                
                pro_con.push_back(consumer);
                
                bool auto_guard = false;
                for(int i = 0; i < mac_tot; i++){
                    if(have_subset(macro_clusters[i], pro_con) && !have_common(macro_clusters[i], macro1) ){ 
                        auto_guard = true;     
                        break;
                    }
                }
                if(!auto_guard){
		  //                    dk_guard = true;
                    dk.push_back(consumer); // new !!!!!!!!!!!!!!
                    break;
                }
            }
            
	    //            if(dk_guard) break;
        
        }
	//        if(!dk_guard) 
	//            deleter_knight.remove(dk_atom);
    }
    
    // inserting all intermediate actions
    vector<int> inodes = get_intermediate_nodes(prf_order_vector, prf_size, macro2, dk);
    dk.insert(dk.end(), inodes.begin(), inodes.end());
    inodes.clear();
    unique_vec(dk);
    return dk;    
}

vector<int> resolve_da_dependency(vector<int> macro1, vector<int> macro2){
    //    vector<int> *m1, *m2;
    vector<int> da, res_actions, del_add;
    //    m1 = macro_vector(macro1);
    //    m2 = macro_vector(macro2);
    //    del_add = intersection_set(m1[2], m2[1]);
    
    del_add = get_deleter_producer_atoms(macro1, macro2);
    
    for (vector<int>::iterator atom = del_add.begin(); atom != del_add.end(); atom++){
        for (vector<int>::iterator it2 = macro2.begin(); it2 != macro2.end(); it2++){
            int adder = *it2;
            if(!contains(add_vector[adder], *atom))
                continue;
            for (vector<int>::iterator it3 = straight_dependent_vector[adder].begin(); it3 != straight_dependent_vector[adder].end(); it3++){
                int consumer = *it3;
                if(contains(sd_atoms[adder][consumer], *atom) && !contains(macro2, consumer))
                    da.push_back(consumer);
            }
        }
    }
    
    // inserting all intermediate actions
    vector<int> inodes = get_intermediate_nodes(prf_order_vector, prf_size, macro2, da);
    da.insert(da.end(), inodes.begin(), inodes.end());
    inodes.clear();
    unique_vec(da);
    return da;
}


vector<int>* resolve_pd_dependency(vector<int> macro1, vector<int> macro2){
    vector<int> *pd, *m1, *m2, *bu_prf;
    vector<int> res_actions, pre_del, atom_unresolved;
    //    m1 = macro_vector(macro1);
    //    m2 = macro_vector(macro2);
    //    pre_del = intersection_set(m1[0], m2[2]);
    pre_del = get_consumer_deleter_atoms(macro1, macro2);
    int action_low, action_up;
    //    cout << "macro1: " ; print_vector(macro1); cout << endl << endl; 
    //    cout << "macro2: " ; print_vector(macro2); cout << endl << endl; 
    pd = new vector<int> [2];
    
    
    // lower part macro2
    for (vector<int>::iterator atom = pre_del.begin(); atom != pre_del.end(); atom++){
        res_actions = responsible_actions_for_del(macro2, *atom);
	// cout << "responsible_actions_for_deleting atom (" << *atom << ") for PD in macro (";  print_vector(macro2); cout << ") is: "; print_vector(res_actions); cout << endl; 
        for (vector<int>::iterator action_r = res_actions.begin(); action_r != res_actions.end(); action_r++){
            action_low = nearest_action(prf_order_vector, macro2, *action_r, *atom, "add", "td");
	    // cout << " return from nearest_action: " << action_low;
            if(action_low == -1){
                atom_unresolved.push_back(*atom);
                continue;
            }
            if(contains(pd[0], action_low)){
                continue;
            }
            // inserting all intermediate actions
            pd[0].push_back(action_low);
            vector<int> inodes = get_intermediate_nodes(prf_order_vector, prf_size, macro2, pd[0]);
            pd[0].insert(pd[0].end(), inodes.begin(), inodes.end());
            inodes.clear();
        }
        
    }
    
    // pd[0].sort();
    
    // upper part macro-1
    vector<int> res_producers = incoming_causal_producers(macro1, atom_unresolved);
    pd[1] = res_producers;
    
    if(contains(res_producers, 0)){
        pd[0].clear();
        pd[1].clear();
        pd[0].push_back(-1);
        pd[1].push_back(-1);
        return pd;
    }
    else{
        vector<int> inodes = get_intermediate_nodes(prf_order_vector, prf_size, pd[1], macro1);
        pd[1].insert(pd[1].end(), inodes.begin(), inodes.end());
        inodes.clear();
	// pd[1].sort();
    }
    return pd;
}

int nearest_action(vector<int> *ol, vector<int> macro, int root, int atom, string pad, string direction){

  // if(root == 0 ){
  //     cout << "atom......................... " << atom;  cout << endl; 
  //     cout << "pad......................... " << pad;  cout << endl; 
  //     cout << "macro........................."; print_vector(macro); cout << endl; 
  // }
    
    bool found = false;
  
    if(ol[root].empty()){
        return -1;
    }

    if( (pad.compare("pre") == 0) ){

        if(direction.compare("td") == 0){
            found = false;
            for (int i = root+1; i < prf_size; i++){
                if(!prf_order_vector[i].empty() && prf_order_vector[i].front() == -1){
                    continue;
                }
                if( contains(pre_vector[i], atom) && !contains(macro, i) && have_path(prf_order_vector, root, i, prf_size)){
                    found = true;
                    return i;
                }
            }
            if(!found){
                return -1;
            }
        }
        else if(direction.compare("bu") == 0){
            found = false;
            for (int i = root-1; i >= 1; i--){
                if(!prf_order_vector[i].empty() && prf_order_vector[i].front() == -1){
                    continue;
                }
                if( contains(pre_vector[i], atom) && !contains(macro, i) && have_path(prf_order_vector, i, root, prf_size)){
                    found = true;
                    return i;
                }
            }
            if(!found){
                return -1;
            }
        }

    }
    
    

    else if( (pad.compare("add") == 0) ){

        if(direction.compare("td") == 0){
            found = false;
            for (int i = root+1; i < prf_size; i++){
                if(!prf_order_vector[i].empty() && prf_order_vector[i].front() == -1){
                    continue;
                }
                if( contains(add_vector[i], atom) && !contains(macro, i) && have_path(prf_order_vector, root, i, prf_size)){
                    found = true;
                    return i;
                }
            }
            if(!found){
                return -1;
            }
        }
        else if(direction.compare("bu") == 0){
            found = false;
            for (int i = root-1; i >= 1; i--){
                if(!prf_order_vector[i].empty() && prf_order_vector[i].front() == -1){
                    continue;
                }
                if( contains(add_vector[i], atom) && !contains(macro, i) && have_path(prf_order_vector, i, root, prf_size)){
                    found = true;
                    return i;
                }
            }
            if(!found){
                return -1;
            }
        }
    }
    
   

    else if( (pad.compare("del") == 0) ){

        if(direction.compare("td") == 0){
            found = false;
            for (int i = root+1; i < prf_size; i++){
                if( contains(del_vector[i], atom) && !contains(macro, i) && have_path(prf_order_vector, root, i, prf_size)){
                    found = true;
                    return i;
                }
            }
            if(!found){
                return -1;
            }
        }
        else if(direction.compare("bu") == 0){
            found = false;
            for (int i = root-1; i >= 1; i--){
                if( contains(del_vector[i], atom) && !contains(macro, i) && have_path(prf_order_vector, i, root, prf_size)){
                    found = true;
                    return i;
                }
            }
            if(!found){
                return -1;
            }
        }

    }

    
}

void update_prf_order(vector<int> cluster1, vector<int> cluster2, vector<int> *free_edges){
    int id = 0, back;
    vector<int> *bu_prf;
    vector<int> cndt_vector, queue_vector, temp_cluster, free_actions_1, free_actions_2;
    vector<int> neighbors_cluster1, neighbors_cluster2;
    // bu_prf = reverse_order_vector(prf_order_vector);
    
    while(!free_edges[id].empty() && free_edges[id].front() != -1){
        remove_val(prf_order_vector[free_edges[id].front()], free_edges[id].back());
        
        if(!contains(free_actions_1, free_edges[id].front())){
            free_actions_1.push_back(free_edges[id].front());
        }
        if(!contains(free_actions_2, free_edges[id].back())){
            free_actions_2.push_back(free_edges[id].back());
        }
        id++;
    }
    
    //================================================================
    //    setting free actions 1 & 2
    //    neighbors_cluster1 = nearest_cluster_neighbors(prf_order_vector, cluster1);
    //===============================================================
    
    // upper connection setup
    bu_prf = reverse_order_vector(prf_order_vector);
    
        
    
    for (vector<int>::iterator it = cluster1.begin(); it != cluster1.end(); it++){
        if(bu_prf[*it].empty()){
            continue;
        }
        cndt_vector.clear();
        cndt_vector = difference_set( bu_prf[*it], cluster1);
        if(cndt_vector.empty()){
            continue;
        }
        queue_vector.insert(queue_vector.end(), cndt_vector.begin(), cndt_vector.end());
        cndt_vector.clear();
        
        do{
            back = queue_vector.back();
            queue_vector.pop_back();
            temp_cluster.clear();
            temp_cluster.push_back(back);
            if(have_po_macro_dependency(temp_cluster, cluster2)){
                for (vector<int>::iterator it2 = free_actions_2.begin(); it2 != free_actions_2.end(); it2++){
		  // if(!contains(prf_order_vector[front], *it2) && !have_path(prf_order_vector, front, *it2)){
                    if(!have_path(prf_order_vector, back, *it2, prf_size)){
                        prf_order_vector[back].push_back(*it2); 
                    }                                       
                }
		// prf_order_vector[back].sort();
            }
            else{
                cndt_vector.clear();
                cndt_vector = difference_set( bu_prf[back], cluster1);
                if(!cndt_vector.empty()){
                    queue_vector.insert(queue_vector.end(), cndt_vector.begin(), cndt_vector.end());
                    cndt_vector.clear();
		    // queue_vector.sort();
		    // queue_vector.unique();                    
                    unique_vec(queue_vector);
                }
            }

        }while(!queue_vector.empty());
        
    } // End For
    
    // Lower Connection Setup
    for (vector<int>::iterator it = cluster2.begin(); it != cluster2.end(); it++){
        if(prf_order_vector[*it].empty()){
            continue;
        }
        cndt_vector.clear();
        cndt_vector = difference_set( prf_order_vector[*it], cluster2);
        if(cndt_vector.empty()){
            continue;
        }
        queue_vector.insert(queue_vector.end(), cndt_vector.begin(), cndt_vector.end());
        cndt_vector.clear();
        
        
        
        do{
            back = queue_vector.back();
            queue_vector.pop_back();
            temp_cluster.clear();
            temp_cluster.push_back(back);
            if(have_po_macro_dependency(cluster1, temp_cluster)){
                for (vector<int>::iterator it1 = free_actions_1.begin(); it1 != free_actions_1.end(); it1++){
		  // if(!contains(prf_order_vector[*it1], back) && !have_path(prf_order_vector, *it1, back, prf_size)){
                    if(!have_path(prf_order_vector, *it1, back, prf_size)){
                        prf_order_vector[*it1].push_back(back);    
			// prf_order_vector[*it1].sort();
                    }
                    
                }
            }
            else{
                cndt_vector.clear();
                cndt_vector = difference_set( prf_order_vector[back], cluster2);
                if(!cndt_vector.empty()){
                    queue_vector.insert(queue_vector.end(), cndt_vector.begin(), cndt_vector.end());
		    // queue_vector.sort();
		    // queue_vector.unique();
                    unique_vec(queue_vector);
                }
            }

        }while(!queue_vector.empty());
        
    } // End For

    set_action_path();
}

void update_prf_order(vector<int> cluster1, vector<int> cluster2){
    // cout << "update_prf_order on: " << vector_to_string(cluster1) << " & " << vector_to_string(cluster2) << endl;
    int id = 0, front;
    vector<int> *bu_prf;
    vector<int> cndt_vector, queue_vector, temp_cluster, free_actions_1, free_actions_2;
    vector<int> neighbors_cluster1, neighbors_cluster2;
    bu_prf = reverse_order_vector(prf_order_vector);
    
    // listing the causal producers whose consumers are in cluster1
    vector<int> pred_causal_producers;
    for(int i = 0; i < prf_size-1; i++){
        if(contains(cluster1, i) || contains(cluster2, i)) continue;
        if(have_common(straight_dependent_vector[i], cluster1))
            pred_causal_producers.push_back(i);
    }
    
    //free connections
    for (vector<int>::iterator it1 = cluster1.begin(); it1 != cluster1.end(); ++it1){
        for (vector<int>::iterator it2 = cluster2.begin(); it2 != cluster2.end(); ++it2){
            if(contains(prf_full[*it1], *it2))
                remove_val(prf_full[*it1], *it2);
            
	    // if(cluster1.front() == 47 && cluster2.front() == 48){ 
	    //     cout << *it1 << " - " << *it2 << endl;
	    // }
            
            if(contains(straight_dependent_vector[*it1], *it2)){
                // setup new causal links
                for (vector<int>::iterator ita = sd_atoms[*it1][*it2].begin(); ita != sd_atoms[*it1][*it2].end(); ++ita){
		    // if(cluster1.front() == 47 && cluster2.front() == 48) cout << "sd_atoms[*it1][*it2]: " << vector_to_string(sd_atoms[*it1][*it2], " ") << endl;
                                
                    for (vector<int>::iterator itp = pred_causal_producers.begin(); itp!= pred_causal_producers.end(); ++itp){
                        
		        // if(cluster1.front() == 47 && cluster2.front() == 48) cout << "pred_causal_producers: " << vector_to_string(pred_causal_producers, " ") << endl;
                        
                        vector<int> tempvec;
                        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); ++itc){
                            
			    // if(cluster1.front() == 47 && cluster2.front() == 48){ 
			    //     cout << "straight_dependent_vector[*itp]: " << vector_to_string(straight_dependent_vector[*itp], " ") << endl;
			    //     xx++;
			    //     cout << *ita << " - " << *itp << " - " << *itc << endl;
			    //     if(xx > 50) exit(1);
			    // }
                            
                            if(contains(cluster1, *itc) && contains(sd_atoms[*itp][*itc], *ita) ){
                                if(!contains(sd_atoms[*itp][*it2], *ita))
                                    sd_atoms[*itp][*it2].push_back(*ita);
                                if(!contains(straight_dependent_vector[*itp], *it2)){
				    // straight_dependent_vector[*itp].push_back(*it2);
				    // straight_dependent_vector[*itp].sort();
                                    tempvec.push_back(*it2);
                                }
                                if(!contains(prf_full[*itp], *it2)){
                                    prf_full[*itp].push_back(*it2);
				    // prf_full[*itp].sort();
                                }
                            }
                        }
                        straight_dependent_vector[*itp].insert(straight_dependent_vector[*itp].end(), tempvec.begin(), tempvec.end());
                        tempvec.clear();
                    }
                }
                
                // remove causal links
                remove_val(straight_dependent_vector[*it1], *it2);
                sd_atoms[*it1][*it2].clear();
            }
        }
    }
    
    // if(cluster1.front() == 47 && cluster2.front() == 48) exit(1);
    
    for (int j = 0; j < prf_size; j++) prf_order_vector[j].clear();
    prf_order_vector = delete_transitive_order(prf_full, prf_size); 
    set_action_path();
    // set_tot_inout_edges();
}

//neighbors of the internal nodes
vector<int> nearest_cluster_neighbors_2(vector<int> *ol, vector<int> macro){
    vector<int> cndt_vector, neighbors;
    
    for (vector<int>::iterator it = macro.begin(); it != macro.end(); it++){
        if(!ol[*it].empty() && ol[*it].front() == -1){
            neighbors.clear();
            return neighbors;
        }
        if(ol[*it].empty()){
            continue;
        }
        cndt_vector.clear();
        
        if(intersection_set(ol[*it], macro).empty()){
            continue;
        }
        
        cndt_vector = difference_set( ol[*it], macro);
        if(cndt_vector.empty()){
            continue;
        }
        neighbors.insert(neighbors.end(), cndt_vector.begin(), cndt_vector.end());
        cndt_vector.clear();
        unique_vec(neighbors);
	// neighbors.sort();
	// neighbors.unique();
    }
    
    return neighbors;
}

vector<int> nearest_cluster_neighbors(vector<int> *ol, vector<int> macro){
    vector<int> cndt_vector, neighbors;
    
    for (vector<int>::iterator it = macro.begin(); it != macro.end(); ++it){
        if(!ol[*it].empty() && ol[*it].front() == -1){
            
            cout << "!! check the module: nearest_cluster_neighbors() !!" << endl;
            neighbors.clear();
            return neighbors;
        }
        if(ol[*it].empty()){
            continue;
        }
        cndt_vector.clear();
        cndt_vector = difference_set( ol[*it], macro);
        if(cndt_vector.empty()){
            continue;
        }
        neighbors.insert(neighbors.end(), cndt_vector.begin(), cndt_vector.end());
        cndt_vector.clear();
        unique_vec(neighbors);
	// neighbors.sort();
	// neighbors.unique();
    }
    
    return neighbors;
}

void set_pad(){
    vector<int> temp;
    
    add_vector[0] = get_vector(instance.init_atoms);
    pre_vector[theplan.size()+1] = get_vector(instance.goal_atoms);
    
    for (int i = 1; i <= theplan.size(); i++) {
        // temp = get_vector(instance.actions[theplan[i-1]].pre);
        pre_vector[i].insert(pre_vector[i].end(), instance.actions[theplan[i-1]].pre.begin(), instance.actions[theplan[i-1]].pre.end());
        temp = difference_set( get_vector(instance.actions[theplan[i-1]].add), get_vector(instance.actions[theplan[i-1]].pre) );
        add_vector[i].insert(add_vector[i].end(), temp.begin(), temp.end());
	// temp = get_vector(instance.actions[theplan[i-1]].del);
        del_vector[i].insert(del_vector[i].end(), instance.actions[theplan[i-1]].del.begin(), instance.actions[theplan[i-1]].del.end());
        temp.clear();
    }
}

vector<int>* reverse_order_vector(vector<int>* order_vector){
    // bottom up prf
    vector<int> *reverse_vector;
    reverse_vector = new vector<int> [prf_size];
    
    for (int i = 0; i < prf_size; i++){
        // cout << i << ": "; 
        // print_vector(order_vector[i]); cout << endl;
        if(!order_vector[i].empty() && order_vector[i].front() == -1){
            reverse_vector[i].push_back(-1);
            continue;
        }
        for(vector<int>::iterator it = order_vector[i].begin(); it != order_vector[i].end(); it++){
            reverse_vector[*it].push_back(i);
        }
    }
    
    return reverse_vector;
}

vector<int> get_outermost_mac_cluster(vector<int> cluster1, vector<int> cluster2){
    vector<int> temp_cluster;
    for(int i = 0; i < mac_tot; i++){
        if(have_subset(macro_clusters[i], cluster1) && macro_clusters[i].size() > temp_cluster.size() &&  intersection_set(macro_clusters[i], cluster2).empty() ){
            temp_cluster.clear();
            temp_cluster = macro_clusters[i];
        }
    }
    
    if(temp_cluster.empty()) temp_cluster = cluster1;
    
    return temp_cluster;
}

vector<int> include_intermediate_n_overlapping_mac_cluster(vector<int> cluster1, vector<int> cluster2){
    vector<int> temp_cluster = cluster1;
    for(int i = 0; i < mac_tot; i++){
        if(have_common(macro_clusters[i], cluster2)) continue;
        if(have_overlap(macro_clusters[i], temp_cluster))
            temp_cluster = union_set(temp_cluster, macro_clusters[i]);
        else if(have_path(prf_order_vector, macro_clusters[i], temp_cluster, prf_size) && have_path(prf_order_vector, temp_cluster, macro_clusters[i], prf_size)) 
            temp_cluster = union_set(temp_cluster, macro_clusters[i]);
    }
    
    temp_cluster = union_set(temp_cluster, get_intermediate_nodes(prf_order_vector, prf_size, temp_cluster));
    
    if(have_common(temp_cluster, cluster2)){
        temp_cluster.clear();
        return temp_cluster;
    }     
    else if(equal_set(temp_cluster, cluster1)) return cluster1;
    else return include_intermediate_n_overlapping_mac_cluster(temp_cluster, cluster2);
}


vector<int>* resolve_dependency_of_pop(int rear_action, int front_action){
    vector<int> *pom;
    //    vector<int> *m1; 
    //    vector<int> *m2; 
    vector<int> ap, da, dk, pd, temp_vector;
    vector<int> tap, tda, tdk;
    vector<int> *tpd; 
    
    pom = new vector<int> [2];
    tpd = new vector<int> [2];
    
    pom[0].push_back(rear_action);
    pom[1].push_back(front_action);
    
    //    m1 = macro_vector(pom[0]);
    //    m2 = macro_vector(pom[1]);    
    //    ap = intersection_set(m1[1], m2[0]);  
    ap = get_producer_consumer_atoms(pom[0], pom[1]);
    //    da = intersection_set(m1[2], m2[1]);
    da = get_deleter_producer_atoms(pom[0], pom[1]);
    //    dk = get_deleter_knight_atoms(pom[0], pom[1]);
    //    pd = intersection_set(m1[0], m2[2]);  
    pd = intersection_set(get_consumed_atoms(pom[0]), get_deleted_atoms(pom[1]));  
    
    //    delete [] m1;
    //    delete [] m2;
    
    Timer *rd_tm = new Timer();

    //    if(ap.empty() && da.empty() && pd.empty() && dk.empty()){
    if(ap.empty() && da.empty() && pd.empty()){
        delete rd_tm;
        return pom;
    }
    
    while(true){
        
        if((total_tm + get_wall_time()-swatch) > do_tm_bound ){
            return pom;
        }
        
        if(!ap.empty()){
	    // cout << "flag - 1" << endl;
	    // cout << "ap............: " ; print_vector(ap); cout << endl; 
            tap = resolve_ap_dependency(pom[0], pom[1]);
	    // if(rear_action == 11 && front_action == 12){
	    //     cout << "tap: " ; print_vector(tap); cout << endl; 
	    // }
	    // cout << "flag - 2" << endl;
        }
        
        if(!da.empty()){
	    // cout << "flag - 3" << endl;
            tda = resolve_da_dependency(pom[0], pom[1]);
	    // cout << "flag - 4" << endl;
        }
	// if(!dk.empty()){
	//     tdk = resolve_dk_dependency(pom[0], pom[1]);
	// }
        if(!pd.empty()){
	    // cout << "flag - 5" << endl;
            tpd = resolve_pd_dependency(pom[0], pom[1]);
	    // cout << "flag - 6" << endl;
        }
        //do_tm_bound/5
	// if(tap.front() == -1 || tda.front() == -1 || tdk.front() == -1 || tpd[0].front() == -1){ // 
        if((!tap.empty() && tap.front() == -1) || (!tda.empty() && tda.front() == -1) || (!tpd[0].empty() && tpd[0].front() == -1) ){ 
            pom[0].clear();
            pom[1].clear();
            delete rd_tm;
            return pom;
        }
        else{
            temp_vector = union_set(
                                union_set(
                                        pom[0], tap
                                ), tpd[1]
                        );
            pom[0].clear();
            pom[0].insert(pom[0].end(), temp_vector.begin(), temp_vector.end());
            temp_vector.clear();
            
            
            temp_vector = union_set(pom[1], tda);
	    // temp_vector = union_set(temp_vector, tdk);
            temp_vector = union_set(temp_vector, tpd[0]);            
            pom[1].clear();
            pom[1].insert( pom[1].end(), temp_vector.begin(), temp_vector.end());
            temp_vector.clear();
            
	    // if(rear_action == 41 && front_action == 42){
	    //     pom[0].sort(); pom[1].sort();
	    //     cout << "b-pom-0: " << vector_to_string(pom[0]) << endl;
	    //     cout << "b-pom-1: " << vector_to_string(pom[1]) << endl;
	    // }
            
            // new 
            pom[0] = include_intermediate_n_overlapping_mac_cluster(pom[0], pom[1]);
            if(pom[0].empty()){
                pom[1].clear();
                delete rd_tm;
                return pom;
            }
            pom[1] = include_intermediate_n_overlapping_mac_cluster(pom[1], pom[0]);
            if(pom[1].empty()){
                pom[0].clear();
                delete rd_tm;
                return pom;
            }
        }
        
        //============
        
	//        m1 = macro_vector(pom[0]);
	//        m2 = macro_vector(pom[1]);    
	//        ap = intersection_set(m1[1], m2[0]);   
        ap = get_producer_consumer_atoms(pom[0], pom[1]);
	//        da = intersection_set(m1[2], m2[1]);
        da = get_deleter_producer_atoms(pom[0], pom[1]);
	//        dk = get_deleter_knight_atoms(pom[0], pom[1]);
	//        pd = intersection_set(m1[0], m2[2]);  
        pd = get_consumer_deleter_atoms(pom[0], pom[1]);
        
	// cout << "initial dependency between: ("; print_vector(pom[0]); cout << ") and (" ; print_vector(pom[1]); cout << ")" << endl; 
	// cout << "ap: " ; print_vector(ap); cout << endl; 
	// cout << "da: " ; print_vector(da); cout << endl; 
	// cout << "pd: " ; print_vector(pd); cout << endl << endl; 
        
	// if(ap.empty() && da.empty() && pd.empty() && dk.empty()){
        if(ap.empty() && da.empty() && pd.empty()){
            delete rd_tm;
            return pom;
        }
        
    }// end WHILE
    
    delete rd_tm;
    return pom;    
}

vector<int> get_causal_consumers(vector<int> macro){
    vector<int> causal_consumers, temp;
    for (vector<int>::iterator it = macro.begin(); it != macro.end(); it++){ 
        if(straight_dependent_vector[*it].empty()) continue;
	// temp = straight_dependent_vector[*it];
        causal_consumers.insert(causal_consumers.end(), straight_dependent_vector[*it].begin(), straight_dependent_vector[*it].end());
    }
    
    // causal_consumers.sort();
    unique_vec(causal_consumers); //.unique();
    return causal_consumers;
}

bool have_no_add_effects(){
    bool flag, flaga, flagb;
    flag = flaga = flagb = false;
    
    vector<int> m1 = get_causally_produced_atoms(macro_clusters[mac_tot-2]);
    vector<int> m2;
    if(contains(macro_clusters[mac_tot-1], prf_size-1))
        m2.push_back(-1);
    else m2 = get_causally_produced_atoms(macro_clusters[mac_tot-1]);

    vector<int> macro;

    if(m1.empty() || m2.empty()){
        
        string details = "deordering blocks: ( " + vector_to_string(macro_clusters[mac_tot-2], " ") + ") & ( " + vector_to_string(macro_clusters[mac_tot-1], " ") + ")";
        fileout << tot_deorder << ": "  << details << endl; // extra
	// fileout << "#unordered_block_1: " << vector_to_string(macro_clusters[mac_tot-2]) << endl;
	// fileout << "#unordered_block_2: " << vector_to_string(macro_clusters[mac_tot-1]) << endl;
    }

    if(m1.empty()){
        redundant_actions = union_set(redundant_actions, macro_clusters[mac_tot-2]);
        fileout << "#block: " << vector_to_string(macro_clusters[mac_tot-2], " ") << " removed." << endl;
        flaga = true; flag = true;
        macro = macro_clusters[mac_tot-2];
        
        // setup new causal links
        vector<int> pred_causal_producers;
        for(int i = 0; i < prf_size-1; i++){
            if(contains(macro, i) ) continue;
            if(have_common(straight_dependent_vector[i], macro))
                pred_causal_producers.push_back(i);
        }
        
        for (vector<int>::iterator it = macro.begin(); it != macro.end(); it++){   // it = macro
            
            vector<int> consumers = difference_set(straight_dependent_vector[*it], macro);
            for (vector<int>::iterator it2 = consumers.begin(); it2 != consumers.end(); it2++){ // it2 = successors 
                
                for (vector<int>::iterator ita = sd_atoms[*it][*it2].begin(); ita != sd_atoms[*it][*it2].end(); ita++){ // ita = atoms
                    
                    for (vector<int>::iterator itp = pred_causal_producers.begin(); itp!= pred_causal_producers.end(); itp++){ // itp = predecessors
                        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){ 
                            if(contains(macro, *itc) && contains(sd_atoms[*itp][*itc], *ita)){ // itc = consumers in macro 
                                if(!contains(sd_atoms[*itp][*it2], *ita))
                                    sd_atoms[*itp][*it2].push_back(*ita);
                                if(!contains(straight_dependent_vector[*itp], *it2)){
                                    straight_dependent_vector[*itp].push_back(*it2);
				    // straight_dependent_vector[*itp].sort();
                                }
                                if(!contains(prf_full[*itp], *it2)){
                                    prf_full[*itp].push_back(*it2);
				    // prf_full[*itp].sort();
                                }
                            }
                        }
                    }
                    
                }
                
            }
        }
       
        pred_causal_producers.clear();
        // removing macro contents
        for (vector<int>::iterator it = macro.begin(); it != macro.end(); it++){   // it = macro
            prf_full[*it].clear();
            prf_full[*it].push_back(-1); // added !!
            
            straight_dependent_vector[*it].clear();

            for (int k = 0; k < prf_size; k++){
                remove_val(prf_full[k], *it); 
                remove_val(straight_dependent_vector[k], *it); 
                
                sd_atoms[*it][k].clear();
                sd_atoms[k][*it].clear();
            }
            
            for (int m = 0; m < mac_tot; m++){
                remove_val(macro_clusters[m], *it);
            }
        }


    }

    

    if(m2.empty()){
        redundant_actions = union_set(redundant_actions, macro_clusters[mac_tot-1]);
        fileout << "#block: " << vector_to_string(macro_clusters[mac_tot-1], " ") << " removed." << endl;
        flagb = true; flag = true;
        macro.clear();
        macro = macro_clusters[mac_tot-1];
        
        // setup new causal links
        vector<int> pred_causal_producers;
        for(int i = 0; i < prf_size-1; i++){
            if(contains(macro, i) ) continue;
            if(have_common(straight_dependent_vector[i], macro))
                pred_causal_producers.push_back(i);
        }
        
        for (vector<int>::iterator it = macro.begin(); it != macro.end(); it++){   // it = macro
            
            vector<int> consumers = difference_set(straight_dependent_vector[*it], macro);
            for (vector<int>::iterator it2 = consumers.begin(); it2 != consumers.end(); it2++){ // it2 = successors 
                
                for (vector<int>::iterator ita = sd_atoms[*it][*it2].begin(); ita != sd_atoms[*it][*it2].end(); ita++){ // ita = atoms
                    
                    for (vector<int>::iterator itp = pred_causal_producers.begin(); itp!= pred_causal_producers.end(); itp++){ // itp = predecessors
                        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){ 
                            if(contains(macro, *itc) && contains(sd_atoms[*itp][*itc], *ita)){ // itc = consumers in macro 
                                if(!contains(sd_atoms[*itp][*it2], *ita))
                                    sd_atoms[*itp][*it2].push_back(*ita);
                                if(!contains(straight_dependent_vector[*itp], *it2)){
                                    straight_dependent_vector[*itp].push_back(*it2);
				    // straight_dependent_vector[*itp].sort();
                                }
                                if(!contains(prf_full[*itp], *it2)){
                                    prf_full[*itp].push_back(*it2);
				    // prf_full[*itp].sort();
                                }
                            }
                        }
                    }
                }
            }
        }
        
        pred_causal_producers.clear();
        // removing macro contents
        for (vector<int>::iterator it = macro.begin(); it != macro.end(); it++){   // it = macro
            prf_full[*it].clear();
            prf_full[*it].push_back(-1); // added !!
            
            straight_dependent_vector[*it].clear();

            for (int k = 0; k < prf_size; k++){
                remove_val(prf_full[k], *it); 
                remove_val(straight_dependent_vector[k], *it); 
                
                sd_atoms[*it][k].clear();
                sd_atoms[k][*it].clear();
            }
            
            for (int m = 0; m < mac_tot; m++){
                remove_val(macro_clusters[m], *it);
            }
        }

    }
    
    if(flaga || flagb){
        for (int j = 0; j < prf_size; j++) prf_order_vector[j].clear();
        prf_order_vector = delete_transitive_order(prf_full, prf_size); 
        set_action_path();
	// set_tot_inout_edges();
    }

    if(flaga && flagb){
        macro_clusters[mac_tot-2].clear();
        macro_clusters[mac_tot-1].clear();
        mac_tot = mac_tot-2;
        
    }
    else if(flaga){
        macro_clusters[mac_tot-2].clear();
        macro_clusters[mac_tot-2].insert(macro_clusters[mac_tot-2].end(), macro_clusters[mac_tot-1].begin(), macro_clusters[mac_tot-1].end());
        macro_clusters[mac_tot-1].clear();
        mac_tot = mac_tot-1;
        
    }
    else if(flagb){
        macro_clusters[mac_tot-1].clear();
        mac_tot = mac_tot-1;
        
    }

    return flag;

    // end major ============================================
}

void create_deordered_macros_of_pop(vector<int> *ol){
    vector<int> **primary_cluster;
    vector<int> *temp_clusters;

    temp_clusters = new vector<int> [2];
    
    vector<int>::iterator it;
    //    vector<int> *free_edges;
    vector<int> dj, tj;
    //    free_edges = new vector<int> [prf_size/2];
    int fe_count = 0;
    //    float do_tm_bound = 150;
    int init_tot; 
    //    while(t.Lapse() < do_tm_bound){
    //        init_tot = tot_deorder;
    int dloop = 0;
    bool successful_do;
    float delta;
    
    //    ofstream fileout; 
    //    string appfilestr = "./record/" + logfile;
    //    fileout.open(appfilestr.c_str(), ios_base::app);
    //    if(!fileout){
    //        cout << "unable to fileout" << endl;
    //    }
    
    while(true){
        
        successful_do = false;
	//        for (int i = prf_size-2; i >=0; i--){
        for (int i = 1; i < prf_size-1;i++){
            if(prf_order_vector[i].empty() || prf_order_vector[i].front() == -1) continue;
	    // cout << " i:" << i << endl;
	    // if(total_tm+(get_wall_time()-swatch) > alloted_tm ) break;
            if((total_tm + get_wall_time()-swatch) > do_tm_bound || tot_deorder > max_deorder || mac_tot > (prf_size * 99)){
                break;
            }

            primary_cluster = new vector<int>* [prf_order_vector[i].size()]; 
            int s = 0;

            for (it = prf_order_vector[i].begin(); it != prf_order_vector[i].end(); it++){
	      // if(*it == -1){
	      //     break;
	      // }
	      // cout << "flag - A: " << *it << endl;

                primary_cluster[s++] = resolve_dependency_of_pop(i, *it); 
                if((total_tm + get_wall_time()-swatch) > do_tm_bound)
                   return; 
            }

            if(*it == -1){
                continue;
            }

            if((total_tm + get_wall_time()-swatch) > do_tm_bound || tot_deorder > max_deorder){
                break;
            }

            vector<int> tc1, tc2;
            temp_clusters[0].clear();
            temp_clusters[1].clear();



            for(int x = 0; x < s; x++){
                if(!primary_cluster[x][0].empty()){

                    if(!temp_clusters[0].empty()){
                        if(intersection_set(temp_clusters[1], primary_cluster[x][1]).empty() ){
                            continue;
                        }
                    }



                    tc1.clear();
                    tc2.clear();
                    tc1 = union_set(temp_clusters[0], primary_cluster[x][0]);
                    tc2 = union_set(temp_clusters[1], primary_cluster[x][1]);

                    temp_clusters[0].insert(temp_clusters[0].end(), tc1.begin(), tc1.end());
		    // temp_clusters[0].sort();
		    // temp_clusters[0].unique();
                    unique_vec(temp_clusters[0]);
                    
                    temp_clusters[1].insert(temp_clusters[1].end(), tc2.begin(), tc2.end());
		    // temp_clusters[1].sort();
		    // temp_clusters[1].unique();
                    unique_vec(temp_clusters[1]);
                    
                    tc1.clear();
                    tc2.clear();
                }
            }

            if(temp_clusters[0].empty()){
                delete [] primary_cluster;
                continue;
            }

            bool insertion = false;

            //================
            temp_clusters[0] = get_outermost_mac_cluster(temp_clusters[0], temp_clusters[1]);
            temp_clusters[1] = get_outermost_mac_cluster(temp_clusters[1], temp_clusters[0]);        
            //================
            
	    // cout << "flag - gin-s" << endl;
            
            vector<int> intm_nodes = get_intermediate_nodes(prf_order_vector, prf_size, temp_clusters[0], temp_clusters[1]);
            if((total_tm + get_wall_time()-swatch) > do_tm_bound) return;
           
	    // cout << "flag - gin-e" << endl;

            if(!have_po_macro_dependency(temp_clusters[0], temp_clusters[1]) && intm_nodes.empty()){ // go for multi edge

	      // cout << "flag - IP-S" << endl;
                if(have_insert_permission(temp_clusters) != 0){
                    insertion = true;
		    //                break;
                }
		// cout << "flag - IP-E" << endl;
            }
	    // cout << "flag - have_po_macro_dependency-e" << endl;
	    // cout << "flag - D" << endl;

            if(!insertion){ // go for single edge

                vector<int>::iterator itt = tj.begin();
                for(int x = 0; x < s; x++){
                    temp_clusters[0].clear();
                    temp_clusters[1].clear();
                    if(!primary_cluster[x][0].empty()){
                        temp_clusters[0].insert(temp_clusters[0].end(), primary_cluster[x][0].begin(), primary_cluster[x][0].end());
                        primary_cluster[x][0].clear();
                        temp_clusters[1].insert(temp_clusters[1].end(), primary_cluster[x][1].begin(), primary_cluster[x][1].end());
                        primary_cluster[x][1].clear();
                        
                       

                        //================
                        temp_clusters[0] = get_outermost_mac_cluster(temp_clusters[0], temp_clusters[1]);
                        temp_clusters[1] = get_outermost_mac_cluster(temp_clusters[1], temp_clusters[0]);       
                        
                        
                        //================
			// cout << "flag - GIN-S" << endl;
                        intm_nodes.clear();
                        intm_nodes = get_intermediate_nodes(prf_order_vector, prf_size, temp_clusters[0], temp_clusters[1]);
                        if((total_tm + get_wall_time()-swatch) > do_tm_bound) return;
			// cout << "flag - GIN-E" << endl;
                        
                        

			// cout << "flag - IP-S" << endl;
                        if(!have_po_macro_dependency(temp_clusters[0], temp_clusters[1]) && intm_nodes.empty() && have_insert_permission(temp_clusters) != 0){
                            insertion = true;
                            break;

                        }
			// cout << "flag - IP-E" << endl;
                        
                        
                        
                        itt++;

			// break;
                    }
                }
                if(!insertion){
                    delete [] primary_cluster;
                    continue;
                }
            }

	    //  cout << "flag - E" << endl;
            
            delete [] primary_cluster;

            tot_deorder++;
            successful_do = true;
            

	    //  cout << "flag - update_prf_order-S" << endl;
            update_prf_order(macro_clusters[mac_tot-2], macro_clusters[mac_tot-1]);
	    // cout << "flag - update_prf_order-E" << endl;

	    // cout << "flag - F" << endl;
	    // flex = calculate_flex();
	    // fileout << "deordering # " <<  tot_deorder << " completed with the flex: " << flex << " at " << total_tm+(get_wall_time()-swatch) << endl;
	    // fileout << "deordering:" <<  tot_deorder << " completed at " << total_tm+(get_wall_time()-swatch) << endl;
            
	    // stringstream ssi;
	    // ssi << tot_deorder;
	    // string filename = temp_dir + "/DPOP_"+ssi.str()+".dot";
            
            string details;
            details = "deordering blocks: ( " + vector_to_string(macro_clusters[mac_tot-2], " ") + ") & ( " + vector_to_string(macro_clusters[mac_tot-1], " ") + ")";
            fileout << tot_deorder << ": "  << details << endl; // extra
            
	    // write_file(filename, prf_order_vector, flex, details);
            
            
	    // print_2d_vector_to_file(prf_order_vector, prf_size, ">", fileout);
	    // fileout << endl;
        } // END-FOR
        
	// delta = ((float)tot_deorder/prf_size)*100;
        
	//        cout << "#dloop:" << dloop ;
	//        cout << " #flex:" << flex ;
	//        cout << " #prf_size:" << prf_size;
	//        cout << " #tot_deorder:" << tot_deorder;
	//        cout << " #delta:" << delta;
	//        cout << " #time:" << t.Lapse() << endl;
                
        if(!successful_do || (get_wall_time()-swatch) > do_tm_bound){
            break;
        }
        
        dloop++;
    } // END-while

    //        if(init_tot == tot_deorder)
    //            break;
    //        
    //    } // End While
    
    fileout << "#tot_deorder: " << tot_deorder << " #dloop: " << dloop << " #plan_length: " << prf_size-2 << endl;
    //    fileout << " #delta:" << delta;
    //    fileout << " #time:" << (get_wall_time()-swatch) << endl;
    //    fileout.close();
        
    //    cout << endl << "Macro Clusters:" << endl;
    //    for(int i = 0; i < mac_tot; i++){
    //        cout << i << ": " ;
    //        print_vector(macro_clusters[i]);
    //        cout << endl;
    //    }
}

float calculate_flex(){
    float action_flex[prf_size];
    float total_flex = 0;
    float average_flex;
    for (int i = 0; i < prf_size; i++) {
        action_flex[i] = 0.0;
    }

    for (int i = 0; i < prf_size; i++) {
        for (int j = i+1; j < prf_size; j++) {
            if(i == j){
                continue;
            }
            if(!have_path(prf_order_vector, i, j, prf_size)){
                action_flex[i] = action_flex[i] + 1.0;
                action_flex[j] = action_flex[j] + 1.0;
            }
        }
        action_flex[i] = action_flex[i] / (prf_size-1);        
    }
    for (int i = 0; i < prf_size; i++) {
        total_flex += action_flex[i];
    }
    average_flex = total_flex / prf_size;
    return average_flex;
}

int have_insert_permission(vector<int> *temp_clusters){
    int t1_loc, t2_loc;
    string temp1, temp2;
    vector<int> neighbors;
    vector<int> *bu_prf;
    temp1 = "new";
    temp2 = "new"; // new.add
    bu_prf = reverse_order_vector(prf_order_vector);
    
    //    neighbors = difference_set(nearest_cluster_neighbors_2(bu_prf, temp_clusters[1]), temp_clusters[0]);
    //    if(!neighbors.empty()) return 0;
    //    neighbors.clear();
    //    neighbors = difference_set(nearest_cluster_neighbors_2(prf_order_vector, temp_clusters[1]), temp_clusters[0]);
    //    if(!neighbors.empty()) return 0;
    //    neighbors.clear();
    //
    //    neighbors = difference_set(nearest_cluster_neighbors_2(prf_order_vector, temp_clusters[0]), temp_clusters[1]);
    //    if(!neighbors.empty()) return 0;
    //    neighbors.clear();
    //    neighbors = difference_set(nearest_cluster_neighbors_2(bu_prf, temp_clusters[0]), temp_clusters[1]);
    //    if(!neighbors.empty()) return 0;
    //    neighbors.clear();
    
    if(mac_tot == 0){
        macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[0].begin(), temp_clusters[0].end());
        temp_clusters[0].clear();
        mac_tot++;
        macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[1].begin(), temp_clusters[1].end());
        temp_clusters[1].clear();
        mac_tot++;
        
        return 1;
    }

    //  Overlapping Checking
    for(int i = 0; i < mac_tot; i++){
        if(have_overlap(macro_clusters[i], temp_clusters[0])){
            return 0;
        }
        if(have_overlap(macro_clusters[i], temp_clusters[1])){
            return 0;
        }
    }

    //  Subset checking
    for(int i = 0; i < mac_tot; i++){
        if(!equal_set(macro_clusters[i], temp_clusters[0]) && have_subset(macro_clusters[i], temp_clusters[0])){
            if(have_subset(macro_clusters[i], temp_clusters[1])){
                
                macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[0].begin(), temp_clusters[0].end());
                temp_clusters[0].clear();
                mac_tot++;
                macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[1].begin(), temp_clusters[1].end());
                temp_clusters[1].clear();
                mac_tot++;
                return 1;
            }
            else{
	      //  continue;
                return 0;
            }
        }
        if(!equal_set(macro_clusters[i], temp_clusters[1]) && have_subset(macro_clusters[i], temp_clusters[1])){
            if(have_subset(macro_clusters[i], temp_clusters[0])){
                macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[0].begin(), temp_clusters[0].end());
                temp_clusters[0].clear();
                mac_tot++;
                macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[1].begin(), temp_clusters[1].end());
                temp_clusters[1].clear();
                mac_tot++;
                return 1;
            }
            else{
	      // continue;
                return 0;
            }
        }
    }
    
    macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[0].begin(), temp_clusters[0].end());
    temp_clusters[0].clear();
    mac_tot++;
    macro_clusters[mac_tot].insert(macro_clusters[mac_tot].end(), temp_clusters[1].begin(), temp_clusters[1].end());
    temp_clusters[1].clear();
    mac_tot++;
    
    return 1;
}

vector<int> get_window_actions(vector<int> block_vector){
    vector<int> action_vector;
    //    block_vector.sort();
    unique_vec(block_vector); //.unique();
    
    for (vector<int>::iterator ln = block_vector.begin(); ln != block_vector.end(); ln++)
        action_vector = union_set(action_vector, mfb[*ln]);
    
    return action_vector;
}

int get_block(int action){
    for(int j = mfb_tot-1; j >=0  ; j--){
        if(contains(mfb[j], action)) 
            return j; 
    }
    return -1;
}

vector<int> get_block(vector<int> actions){
    //    actions.sort();
    
    unique_vec(actions); //.unique();
    vector<int> blocks;
    for (vector<int>::iterator it = actions.begin(); it != actions.end(); ++it)
        blocks.push_back(get_block(*it));
    
    //    blocks.sort();
    unique_vec(blocks); //.unique();
    return blocks;
}

vector<int> get_intermediate_nodes(vector<int> *order_vector, int size, int from_action, int to_action){
    vector<int> in_nodes;
    if(from_action == to_action) return in_nodes;
    if(!have_path(order_vector, from_action, to_action, size)) return in_nodes;
    for(int i = 1; i < size-1; i++){
        if(!order_vector[i].empty() && order_vector[i].front() == -1) continue;
        if(i == from_action || i == to_action) continue;
        if(have_path(order_vector, from_action, i, size) && have_path(order_vector, i, to_action, size)) in_nodes.push_back(i);
    }
    return in_nodes;
}

vector<int> get_intermediate_nodes(vector<int> *order_vector, int size, vector<int> actions){
    vector<bool> order_all_r;
    order_all_r.reserve(size);
    
    vector<bool> vb_macro(size, false); 
    for (vector<int>::iterator it = actions.begin(); it != actions.end(); ++it)
        vb_macro[*it] = true;
    
     
    vector<int> in_nodes, candidate_nodes;
    for(int i = 1; i < size-1; i++){ 
        if(!vb_macro[i])
                candidate_nodes.push_back(i);
    }
    
    vector<bool> vb;
    vb.reserve(size);
    for (vector<int>::iterator itc = candidate_nodes.begin(); itc != candidate_nodes.end(); ++itc){
        for(int i = 0; i < size; i++)
            order_all_r[i] = order_all[i][*itc];
        vb.clear();
        transform (vb_macro.begin(), vb_macro.end(), order_all_r.begin(), vb.begin(), std::logical_and<bool>());
        bool found = false;
        for(int i = 1; i < size-1; i++){ 
            if(vb[i]){
                found = true;
                break;
            }
        }
        
        if(!found) continue;
        
        vb.clear();
        transform (vb_macro.begin(), vb_macro.end(), order_all[*itc].begin(), vb.begin(), std::logical_and<bool>());
        found = false;
        for(int i = 1; i < size-1; i++){ 
            if(vb[i]){
                found = true;
                break;
            }
        }
        
        if(!found) continue;
        
        in_nodes.push_back(*itc);
        
    }
    return in_nodes;
}

vector<int> get_intermediate_nodes(vector<int> *order_vector, int size, vector<int> from_actions, vector<int> to_actions){
    vector<bool> order_all_r;
    order_all_r.reserve(size);
    
    vector<bool> vb_from(size, false); 
    for (vector<int>::iterator it = from_actions.begin(); it != from_actions.end(); ++it)
        vb_from[*it] = true;
    
    vector<bool> vb_to(size, false); 
    for (vector<int>::iterator it = to_actions.begin(); it != to_actions.end(); ++it)
        vb_to[*it] = true;
    
     
    vector<int> in_nodes, candidate_nodes;
    for(int i = 1; i < size-1; i++){ 
        if(!vb_from[i] && !vb_to[i])
                candidate_nodes.push_back(i);
    }
    
    vector<bool> vb;
    vb.reserve(size);
    for (vector<int>::iterator itc = candidate_nodes.begin(); itc != candidate_nodes.end(); ++itc){
        for(int i = 0; i < size; i++)
            order_all_r[i] = order_all[i][*itc];
        vb.clear();
        transform (vb_from.begin(), vb_from.end(), order_all_r.begin(), vb.begin(), std::logical_and<bool>());
        bool found = false;
        for(int i = 1; i < size-1; i++){ 
            if(vb[i]){
                found = true;
                break;
            }
        }
        
        if(!found) continue;
        
        vb.clear();
        transform (vb_to.begin(), vb_to.end(), order_all[*itc].begin(), vb.begin(), std::logical_and<bool>());
        found = false;
        for(int i = 1; i < size-1; i++){ 
            if(vb[i]){
                found = true;
                break;
            }
        }
        
        if(!found) continue;
        
        in_nodes.push_back(*itc);
        
    }
    return in_nodes;
}

vector<int> include_intermediate_blocks(vector<int> block_vector_1){
    vector<int> action_vector_1, action_vector_2, action_vector_all, block_vector_2;
    
    action_vector_1 = get_window_actions(block_vector_1);
    action_vector_2 = get_intermediate_nodes(prf_order_vector, prf_size, action_vector_1);
    action_vector_all = union_set(action_vector_1, action_vector_2);
    
    for(int j = 0; j < mfb_tot; j++){
        if(have_common(mfb[j], action_vector_all) && !have_subset(mfb[j], action_vector_all))
            action_vector_all = union_set(action_vector_all, mfb[j]);        
    }

    if(equal_set(action_vector_1, action_vector_all)) return block_vector_1;

    block_vector_2 = get_block(action_vector_all);
    if(equal_set(block_vector_1, block_vector_2)) return block_vector_1;
    else return include_intermediate_blocks(block_vector_2);
}




void print_init_goal_atoms(){
    //    HSPS::index_set is = instance.init_atoms;
    //    unsigned int *k;
    //    is.count(k);
    cout << "Init atoms: " << instance.init_atoms << "\n";
    cout << "Goal atoms: " << instance.goal_atoms << "\n";
}

double plan_cost(){
    double cost = 0;
    for (int i = 0; i < prf_size; i++) {
        cost += instance.actions[theplan[i]].cost.decimal(); 
    }
    return cost;
}

void print_all_actions(){
    double cost = 0;
    for (int i = 0; i < prf_size; i++) {
        std::cout << i << ". action " << theplan[i] << " = "
                << instance.actions[theplan[i]].name << std::endl;
        std::cout << " cost = " << instance.actions[theplan[i]].cost << std::endl;
        std::cout << " pre = " << instance.actions[theplan[i]].pre << std::endl;      
        std::cout << " add = " << instance.actions[theplan[i]].add << std::endl;        
        std::cout << " del = " << instance.actions[theplan[i]].del << std::endl;

        cost += instance.actions[theplan[i]].cost.decimal();        
    }
    
    std::cout << endl << " Total Cost = " << cost << std::endl;
}

void print_all_actions(ofstream *myoutput){
    for (int i = 0; i < prf_size; i++) {
        std::cout << i << ". action " << theplan[i] << " = "
                << instance.actions[theplan[i]].name << std::endl;
        std::cout << " pre = " << instance.actions[theplan[i]].pre << std::endl;
        //std::cout << " pre_length = " << instance.actions[theplan[i]].pre.length() << std::endl;        
        std::cout << " add = " << instance.actions[theplan[i]].add << std::endl;        
        std::cout << " del = " << instance.actions[theplan[i]].del << std::endl;

        // file output    
        *myoutput << i << ". action " << theplan[i] << " = " << instance.actions[theplan[i]].name << "\n";
        *myoutput << " pre = " << instance.actions[theplan[i]].pre << "\n";
        //std::cout << " pre_length = " << instance.actions[theplan[i]].pre.length() << std::endl;        
        *myoutput << " add = " << instance.actions[theplan[i]].add << "\n";        
        *myoutput << " del = " << instance.actions[theplan[i]].del << "\n";        
  }
} 

void print_responsible_actions(){
    string line, token;
    int temp, atom;
    vector<int> pom1, pom2, ra;
    char pad;
    
    cout << "print macro elements (-1 to finish): "; //<< flush;
    cin.ignore();
    getline(cin,line);

    istringstream iss1(line);
    
    while(1){
        getline( iss1, token, ' ' );        
        
        size_t pos = token.find("~");
        if(pos != string::npos){
            int t1, t2;
            string tok1 = token.substr(0, pos);
            string tok2 = token.substr(pos+1, token.size()-pos);
            stringstream(tok1) >> t1;
            stringstream(tok2) >> t2;
            for(int i = t1; i <= t2; i++){
                pom1.push_back(i);
            } 
            continue;
        }        
        
        stringstream(token) >> temp;
        if(temp == -1){
            break;
        }
        pom1.push_back(temp);
    }
    
    for (int i = 0; i < prf_size; i++) {
        if(!contains(pom1, i))
            pom2.push_back(i);
    }
    
    cout << "print atom: " << endl; 
    cin >> atom;
    
    cout << endl << "p/a/d: " << endl; 
    cin >> pad;
    
    if(pad == 'p'){
        ra = responsible_actions_for_pre(pom1, atom);
    }
    else if(pad == 'a'){
        ra = responsible_actions_for_add(pom1, pom2, atom);
    }
    else if(pad == 'd'){
        ra = responsible_actions_for_del(pom1, atom);
    }
    
    for (vector<int>::iterator it = ra.begin(); it != ra.end(); it++){
      cout << "responsible action(s): " << *it;
    }
    cout << endl;
    ra.clear();
}

string get_any_dependency(int i, int j){
    string dep_str("");
    stringstream ssi, ssj, atoms;
          
    ssi << i;
    ssj << j;
    dep_str +=  ssi.str() + "-" + ssj.str() + ":";
          
    if(contains(straight_dependent_vector[i], j)){
      dep_str += " SD ";
    }
          
          
    if(instance.actions[theplan[i]].add.have_common_element(instance.actions[theplan[j]].pre)){              
      dep_str += " AP " ;
      dep_str +=    vector_to_string( 
                                intersection_set(
						 get_vector(instance.actions[theplan[i]].add), 
                                    get_vector(instance.actions[theplan[j]].pre)
                                ), " "
                            ); 
          }
          
    if(instance.actions[theplan[i]].del.have_common_element(instance.actions[theplan[j]].add)){  
              
      //================================
              
      vector<int> del_vector = get_vector(instance.actions[theplan[i]].del);
      vector<int> add_vector = difference_set( get_vector(instance.actions[theplan[j]].add), get_vector(instance.actions[theplan[j]].pre) );
      vector<int> common_da = intersection_set(del_vector, add_vector);
      bool found = false;
      for(vector<int>::iterator it = straight_dependent_vector[j].begin(); it != straight_dependent_vector[j].end(); it++){
	  vector<int> pre_vector = get_vector(instance.actions[theplan[*it]].pre);
	  vector<int> common_ap = intersection_set(add_vector, pre_vector);
	  if(have_common(common_da, common_ap)){
	    found = true;
	    break;
	  }
	  pre_vector.clear();
	  common_ap.clear();
      } 
              
      if(found){
	dep_str += " DA " ;
	dep_str +=    vector_to_string( common_da, " " );
      }
              
      //================================
              
    }
          
    if(instance.actions[theplan[i]].pre.have_common_element(instance.actions[theplan[j]].del)){              
      dep_str += " PD " ;
      dep_str +=    vector_to_string( 
                                intersection_set(
                                    get_vector(instance.actions[theplan[i]].pre), 
                                    get_vector(instance.actions[theplan[j]].del)
                                ), " "
                            ); 
    }
         
    return dep_str;
}

bool have_any_dependency(int i, int j){
          if(contains(straight_dependent_vector[i], j))
                return true;
          
          
          vector<int> dp = get_deleter_producer_atoms(i, j);
          if(!dp.empty()) 
              return true;
          
          vector<int> pd = intersection_set(pre_vector[i], del_vector[j]);
          if(!pd.empty()) return true;

          
          return false;;
}

bool have_straight_goal_dependency(int i){
              bool straight_goal_dependency = false;
              if(instance.actions[theplan[i]].add.have_common_element(instance.goal_atoms)){
                            
                    vector<int> l3 = intersection_set(
                                get_vector(instance.actions[theplan[i]].add), get_vector(instance.goal_atoms)
                    );

                    int lp = -1;

                    for(vector<int>::iterator it = l3.begin(); it != l3.end(); it++){
                        lp = last_producer(*it, i, prf_size-1);   
                        if(lp == -1) {
                            straight_goal_dependency = true;                         
                        }

                    }               
                    l3.clear();
             }
             return straight_goal_dependency;
}

bool have_straight_dependency(int i, int j){
    bool straight_dependency = false;

    if(have_common(add_vector[i], pre_vector[j])){
          vector<int> l3 = intersection_set(add_vector[i], pre_vector[j]);
          int lp = -1;
          for(vector<int>::iterator it = l3.begin(); it != l3.end(); ++it){
              lp = earliest_producer(*it, i, j);                         
              if(lp == i) {
                  straight_dependency = true; 
                  sd_atoms[i][j].push_back(*it);
              }
          }  
   }
   return straight_dependency;
}



//==============old==================old=====================================

    

vector<int>*  macro_dependency(vector<int> pom1, vector<int> pom2){
    //string dep_str;
    vector<int> *m1 = macro_vector(pom1);
    vector<int> *m2 = macro_vector(pom2);
    
    vector<int> *mda; // macro_dependent_atoms 
    mda = new vector<int> [6];
    
    mda[0] = intersection_set(m1[1], m2[0]); //AP
    mda[1] = intersection_set(m1[1], m2[2]); //AD
    mda[2] = intersection_set(m1[0], m2[2]); //PD
    mda[3] = intersection_set(m1[0], m2[1]); //PA
    mda[4] = intersection_set(m1[2], m2[1]); //DA
    mda[5] = intersection_set(m1[2], m2[0]); //DP
    
    return mda;
}   


bool have_po_macro_dependency(vector<int> pom1, vector<int> pom2){
    
 
    vector<int> pc, dp, cd, dk;
    
    pc = get_producer_consumer_atoms(pom1, pom2);
    
    vector<int> c_atoms = get_consumed_atoms(pom1);
    vector<int> d_atoms = get_deleted_atoms(pom2);
    cd = intersection_set(c_atoms, d_atoms);  
    
    dp = get_deleter_producer_atoms(pom1, pom2);
    
    dk = get_deleter_knight_atoms(pom1, pom2);
       
    if(pc.empty() && cd.empty() && dp.empty() && dk.empty() ){
        //    if(pc.empty() && cd.empty() && dp.empty()){
        return false;
    }
    else{
        return true;
    }    
}

vector<int> outgoing_causal_producers(vector<int> macro){
    vector<int> out_causal_producers;    
    for (vector<int>::iterator itp = macro.begin(); itp!= macro.end(); itp++){
        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){
            if(!contains(macro, *itc)){
                out_causal_producers.push_back((*itp));
                break;
            }
        }
    }
    return out_causal_producers;
}

vector<int> incoming_causal_producers(vector<int> macro){
    vector<int> in_causal_producers;    
    for(int i = 0; i < prf_size-1; i++){
        if(contains(macro, i) ) continue;
        if(have_common(straight_dependent_vector[i], macro))
            in_causal_producers.push_back(i);
    }
    return in_causal_producers;
}

vector<int> incoming_causal_producers(vector<int> macro, vector<int> atoms){
    vector<int> res;
    vector<int> consumed_atoms, causal_producers;    
    for(int i = 0; i < prf_size-1; i++){
        if(contains(macro, i) ) continue;
        if(have_common(straight_dependent_vector[i], macro))
            causal_producers.push_back(i);
    }
    
    for (vector<int>::iterator itp = causal_producers.begin(); itp!= causal_producers.end(); itp++){
        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){
            if(contains(macro, *itc) && have_common(sd_atoms[*itp][*itc], atoms)) {
                res.push_back((*itp));
                break;
            }
        }
    }
    //    res.sort();
    return res;
}

vector<int> responsible_actions_for_pre(vector<int> macro, int atom){
    vector<int> res;
    vector<int> consumed_atoms, causal_producers;    
    for(int i = 0; i < prf_size-1; i++){
        if(contains(macro, i) ) continue;
        if(have_common(straight_dependent_vector[i], macro))
            causal_producers.push_back(i);
    }
     
    for (vector<int>::iterator itp = causal_producers.begin(); itp!= causal_producers.end(); itp++){
        for (vector<int>::iterator itc = straight_dependent_vector[*itp].begin(); itc!= straight_dependent_vector[*itp].end(); itc++){
            if(contains(macro, *itc) && contains(sd_atoms[*itp][*itc], atom)) 
                res.push_back((*itc));
        }
    }
    
    //    res.sort();
    return res;
}

vector<int> responsible_actions_for_add(vector<int> macro1, vector<int> macro2, int atom){
    vector<int> responsible_producer_actions;
    // vector<int> consumed_atoms = get_consumed_atoms(macro1);
    for (vector<int>::iterator it1 = macro1.begin(); it1 != macro1.end(); it1++){
        int producer = *it1;
        if(straight_dependent_vector[producer].empty() || !contains(add_vector[producer], atom)) continue;
        vector<int> consumer_vector = intersection_set(straight_dependent_vector[producer], macro2);
        if(consumer_vector.empty()) continue;
        for (vector<int>::iterator it2 = consumer_vector.begin(); it2 != consumer_vector.end(); it2++){
            int consumer = *it2;
            if(contains(sd_atoms[producer][consumer], atom))
                responsible_producer_actions.push_back(producer);
        }                
    }    
    return responsible_producer_actions;
}

vector<int> responsible_actions_for_del(vector<int> pol, int atom){
    vector<int> res;
    //    vector<int> inodes;
    for (vector<int>::iterator action = pol.begin(); action != pol.end(); action++){
        if(!contains(del_vector[*action], atom)){
            continue;
        }
        bool candidate = true;
        for (vector<int>::iterator other_action = pol.begin(); other_action != pol.end(); other_action++){
            if(*other_action == *action){
                continue;
            }
            if(!have_path(prf_order_vector, *action, *other_action, prf_size)){
                continue;
            }
            if(contains(add_vector[*other_action],atom)){
                candidate = false;
                break;
            }


        } // other_action 

        if(candidate){
            res.push_back(*action);
        }
    } // action

    //    res.sort();
    return res;
}

vector<int>* macro_vector(vector<int> pol){
    vector<int> *ml;
    ml = new vector<int> [3];
    
    ml[0] = get_consumed_atoms(pol);
    ml[1] = get_causally_produced_atoms(pol);
    ml[2] = get_deleted_atoms(pol);
    
    return ml;
}

vector<int>* macro_vector_2(vector<int> pol){
//    for (vector<int>::iterator action = pol.begin(); action != pol.end(); action++){
//        cout << endl << "Individual action info............... " << endl;
//        cout << "Action: " << *action << endl;
//        cout << "pre: "; print_vector(pre_vector[*action]); cout << endl;
//        cout << "add: "; print_vector(add_vector[*action]); cout << endl;
//        cout << "del: "; print_vector(del_vector[*action]); cout << endl;
//    }
    
    vector<int> *ml;
    ml = new vector<int> [3];
    
    // vector<int> found, unfound;
   
    // assigning pre ml[0]    
    for (vector<int>::iterator pre_action = pol.begin(); pre_action != pol.end(); pre_action++){  
        for (vector<int>::iterator atom = pre_vector[*pre_action].begin(); atom != pre_vector[*pre_action].end(); atom++){
            bool candidate = true;
            if(contains(ml[0], *atom))
                continue;
            for (vector<int>::iterator add_action = pol.begin(); add_action != pol.end(); add_action++){
                if(*add_action == *pre_action)
                    continue;                
                if(!contains(add_vector[*add_action], *atom))                   
                    continue;
		// if(!have_path(prf_order_vector, *add_action, *pre_action, prf_size))
		//     continue;
                if(!contains(straight_dependent_vector[*add_action], *pre_action))
                    continue;
                bool threatflag = false; 
                for (vector<int>::iterator threat_action = pol.begin(); threat_action != pol.end(); threat_action++){
                    
                    if(*threat_action == *add_action || *threat_action == *pre_action) continue;
                    if(!contains(del_vector[*threat_action],*atom)) continue;
                    if(have_path(prf_order_vector, *threat_action, *add_action, prf_size)) continue;
                    if(have_path(prf_order_vector, *pre_action, *threat_action, prf_size)) continue;
                    threatflag = true;
                    break;
                }
                if(!threatflag){
                    candidate = false;
                    break;
                }
               
            }
            if(candidate){
                ml[0].push_back(*atom);
            }
        } // atom_for
    } // action_for
    
    // assigning add ml[1]
    
    for (vector<int>::iterator action = pol.begin(); action != pol.end(); action++){
        for (vector<int>::iterator atom = add_vector[*action].begin(); atom != add_vector[*action].end(); atom++){
            bool candidate = true;
            if(contains(ml[1], *atom)){
                continue;
            }
            if(contains(ml[0], *atom)){
                continue;
            }
            for (vector<int>::iterator other_action = pol.begin(); other_action != pol.end(); other_action++){
                if(*other_action == *action){
                    continue;
                }
                if(have_path(prf_order_vector, *other_action, *action, prf_size)){
                    continue;
                }
                // deleted few lines.... if needed get back to early code
                if(contains(del_vector[*other_action],*atom)){
                    candidate = false;
                    break;
                }
                
            } // other_action            
            if(candidate){
                ml[1].push_back(*atom);
            }
            
        } // atom
    } // action

    // assigning del ml[2]
    //    
    for (vector<int>::iterator action = pol.begin(); action != pol.end(); action++){
        for (vector<int>::iterator atom = del_vector[*action].begin(); atom != del_vector[*action].end(); atom++){
            bool candidate = true;
            if(contains(ml[2], *atom)){
                continue;
            }
            for (vector<int>::iterator other_action = pol.begin(); other_action != pol.end(); other_action++){
                if(*other_action == *action){
                    continue;
                }
                if(!have_path(prf_order_vector, *action, *other_action, prf_size)){
                    continue;
                }
                if(contains(add_vector[*other_action],*atom)){
                    candidate = false;
                    break;
                }
                
            } // other_action 
            
            if(candidate){
                ml[2].push_back(*atom);
            }
            
        } // atom
    } // action
    //    ml[0].sort();
    //    ml[1].sort();
    //    ml[2].sort();
    
    return ml;    
}

bool have_path(vector<int> *prfol, int from_action, int to_action, int size){
    //    if(action_path_bit.test((from_action*size)+to_action))
    if(order_all[from_action][to_action])
        return true;
    else
        return false;
}

bool have_path(vector<int> *prfol, vector<int> from_actions, vector<int> to_actions, int size){
    bool found = false;
    for (vector<int>::iterator itf = from_actions.begin(); itf != from_actions.end(); ++itf){
        
        for (vector<int>::iterator itt = to_actions.begin(); itt != to_actions.end(); ++itt){
            if(have_path(prfol, *itf, *itt, size)){
                found = true;
                break;
            }
        
        }
        if(found) break;
    }
    return found;

}

vector<int>* delete_transitive_order(vector<int> *iol, int size){
    //    bool adj[size][size] = {{0}};
    //    bool tran[size][size] = {{0}};
    //    bool mul[size][size] = {{0}};
    vector<int> *ol;
    ol = new vector<int> [size];
    for(int i = 0; i < size; i++)
        ol[i] = iol[i];
    
    bool **adj = new bool*[size];
    for(int i = 0; i < size; ++i) {
        adj[i] = new bool[size];
    }
    
    bool **tran = new bool*[size];
    for(int i = 0; i < size; ++i) {
        tran[i] = new bool[size];
    }
    
    bool **mul = new bool*[size];
    for(int i = 0; i < size; ++i) {
        mul[i] = new bool[size];
    }
    
    for (int i = 0; i < size; i++)
        for (int j = 0; j < size; j++){
            adj[i][j] = false;
            tran[i][j] = false;
            
        } 
    
    // populate adj
    for (int i = 0; i < size; i++){    
        if((ol)[i].empty() || (ol)[i].front() == -1) continue;
        for (vector<int>::iterator it = (ol)[i].begin(); it != (ol)[i].end(); ++it){ 
            adj[i][*it] = true;
            tran[i][*it] = true;
        }
    }
    
    // determine tran
    for (int k = 0; k < size; k++)
        for (int i = 0; i < k; i++)
            if (tran[i][k])
                for (int j = k+1; j < size; j++)
                    if (tran[k][j])
                        tran[i][j] = true;
                
    
                
                
    // determine mul            
    for (int i = 0; i < size; i++)
        for (int j = 0; j < size; j++) {
            bool p = false;
            for (int k = 0; (k < size) && !p; k++)
                if (adj[i][k] && tran[k][j]) p = true;
            mul[i][j] = p;
        }
             
    
                
    // new adj            
    for (int i = 0; i < size; i++)
        for (int j = 0; j < size; j++) 
            adj[i][j] -= mul[i][j];
    
    // new prf
    for (int i = 0; i < size; i++){    
        if((ol)[i].empty() || (ol)[i].front() == -1) continue;
        for (vector<int>::iterator it = (ol)[i].begin(); it != (ol)[i].end(); ++it){ 
            if(!adj[i][*it]){
                it = (ol)[i].erase(it);
                --it;
            }
        }
    }
          
    
    for(int i = 0; i < size; ++i) {
        delete [] tran[i];
        delete [] adj[i];
        delete [] mul[i];
    }
    
    delete [] tran;
    delete [] adj;
    delete [] mul;

    return ol;
}

bool equal_list(vector<int>  l1, vector<int>  l2){
    bool common = true;
    if(l1.size() != l2.size()){
        return false;
    }
    vector<int>::iterator it1 = l1.begin();
    vector<int>::iterator it2 = l2.begin();
    
    while(it1 != l1.end() ){
        if(*it1 != *it2){
            common =false;
            break;
        }
        ++it1;
        ++it2;        
    }
    
    return common;    
}

bool equal_set(vector<int>  l1, vector<int>  l2){
    //    bool common = true;
    if(l1.size() != l2.size()){
        return false;
    }
    sort(l1.begin(), l1.end());
    sort(l2.begin(), l2.end());
    
    if(l1 == l2) return true;
    else return false;
 
}

bool have_common(vector<int>  l1, vector<int>  l2){
    if(l1.empty() || l2.empty()) return false;    
    for (vector<int>::iterator it1 = l1.begin(); it1 != l1.end(); it1++){
        if(contains(l2, *it1)){
            return true;
        }                  
    }
    return false;    
}

bool have_strict_subset(vector<int>  l1, vector<int>  l2){
    if(l1.empty() || l2.empty()) return false; 
    if(l1.size() <= l2.size()) return false;
    return have_subset(l1, l2);
}

bool have_subset(vector<int>  l1, vector<int>  l2){    
    if(l1.empty() || l2.empty()) return false;   
    for(vector<int>::iterator it2 = l2.begin(); it2 != l2.end(); it2++){
        if(!contains(l1, *it2)){
            return false;
        }
    }  
    return true;    
}

bool have_overlap(vector<int>  l1, vector<int>  l2){
    if(l1.empty() || l2.empty()) return false; 
    if(intersection_set(l1, l2).empty()){
        return false;
    }
    if(have_subset(l1, l2) || have_subset(l2, l1) ){
        return false;
    }  
    else{
        return true; 
    }
       
}

vector<int> intersection_set(vector<int>  l1, vector<int>  l2){
    vector<int>  l3 ;
    if(l1.empty() || l2.empty()) return l3;
    
    for (vector<int>::iterator it1 = l1.begin(); it1 != l1.end(); it1++){
        if(contains(l2, *it1))
            l3.push_back(*it1);
    }
    return l3;
}

vector<int> union_set(vector<int>  l1, vector<int>  l2){
    vector<int>  l3 = l1;
    
    for(vector<int>::iterator it2 = l2.begin(); it2 != l2.end(); it2++){
        if(contains(l3, *it2)) continue;
        l3.push_back(*it2);
    }
    
    return l3;
    
}

vector<int> difference_set(vector<int>  l1, vector<int>  l2){
    vector<int>  l3 ;
    if(l2.empty()) return l1;
    
    for (vector<int>::iterator it1 = l1.begin(); it1 != l1.end(); it1++){
        if(!contains(l2, *it1))
            l3.push_back(*it1);
    }
    return l3;
}

int last_producer(int atom, int i, int j){
    bool found = false, exist = false;
    int lp = -1;
    for(int x = i+1; x < j; x++){
        if(instance.actions[theplan[x]].pre.contains(atom)) 
            continue;
        if(instance.actions[theplan[x]].del.contains(atom)){
            exist = false;              
        }
        if(instance.actions[theplan[x]].add.contains(atom)){
            found = true;   
            exist = true;
            lp = x;
        }
    }
    if(found && exist){
        return lp;
    }
    else {
        return -1;
    }
    
}

int earliest_producer(int atom, int i, int j){
    //    bool found = false, delexist = false;
    int lp = -1;
    
    for(int x = i+1; x < j; x++){
        if(contains(del_vector[x], atom)) 
            return lp;
    }
    
    lp = i;
    for(int x = i-1; x >= 0; x--){
        if(contains(del_vector[x], atom))
            return lp;
        else if(contains(add_vector[x], atom))
            return x;
    }
    return lp;
}

void print_actions_for_atom(){
    int atom;
    string p("pre:"); 
    string a("add:");
    string d("del:");
    string seq("Chain of occurrence: ");
    cout << "atom number:";
    cin >> atom;
    
    if(contains(get_vector(instance.init_atoms), atom)){
        a += " I ";
        seq += " I ";
    }
    
    for (int i = 0; i < prf_size; i++){
        
        stringstream ss;
        ss << i;
        if(instance.actions[theplan[i]].pre.contains(atom)){
            p += " " + ss.str() +" ";
            seq += " " + ss.str() + "= ";
            
        }
        if(instance.actions[theplan[i]].add.contains(atom)){
            a += " " + ss.str() +" ";
            seq += " " + ss.str() + "+ ";
        }
        if(instance.actions[theplan[i]].del.contains(atom)){
            d += " " + ss.str() +" ";
            seq += " " + ss.str() + "- ";
        }      
    }
    
    if(contains(get_vector(instance.goal_atoms), atom)){
        seq += " G ";
        p += " G ";
    }
    
    cout << "Relevant action vector of atom: " << atom << " " << instance.atoms[atom].name << "\n"; 
    cout << p << "\n";
    cout << a << "\n";
    cout << d << "\n";
    cout << seq << "\n";
}


void print_lifecycle(char *argv[]){
    
    string plan_loc(argv[3]);
    
    string atoms_loc = "atoms_lc";
    //    string atoms_b_loc = temp_dir + "/atoms_b_lc";
    
    string actions_loc =  "actions_lc";
    string actions_b_loc = "actions_b_lc";
    
    ofstream out_atoms (atoms_loc.c_str());  
    //    ofstream out_atoms_b (atoms_b_loc.c_str());  
    
    ofstream out_actions (actions_loc.c_str());  
    //    ofstream out_actions_b (actions_b_loc.c_str());  
    
    int atom;    
    string seq, seqb;
    
    
    out_actions << "I:[O]: +" << instance.init_atoms << endl;
    //    out_actions_b << "I:[O]: +" << instance.init_atoms << endl;
    
    
    //    vector<int> atom_vector = get_active_init_atoms();
    //    for (int i = 0; i < theplan.size(); i++) {
    //        out_actions << i << ":[" << instance.actions[theplan[i]].cost << "]: =" << instance.actions[theplan[i]].pre << " -" << instance.actions[theplan[i]].del << " +" << instance.actions[theplan[i]].add << endl;
    //        vector<int> temp = get_vector(instance.actions[theplan[i]].add);
    //        atom_vector.insert(atom_vector.end(), temp);
    //    }
    //    atom_vector.sort();
    //    atom_vector.unique();
    
    vector<int> atom_vector = get_all_atoms();
    for (int i = 0; i < theplan.size(); i++){
        int j = i+1;
        out_actions << j << ":[" << instance.actions[theplan[i]].cost << "]: =" << instance.actions[theplan[i]].pre << " -" << instance.actions[theplan[i]].del << " +" << instance.actions[theplan[i]].add << endl;
    }
    //    for (int i = 0; i < fob_tot; i++){
    //        vector<int> *m = macro_vector(fob[i]);
    //        out_actions_b << i << ":[" << block_cost(fob[i]) << "]: =[" << vector_to_string(m[0]) << "] -" << vector_to_string(m[2]) << " +[" << vector_to_string(m[1]) << "]" << endl;
    //    }       
    
    for (vector<int>::iterator it = atom_vector.begin(); it != atom_vector.end(); ++it){
        atom = *it;

        if(contains(get_vector(instance.init_atoms), atom)){
            seq += " +I ";
	    // seqb += " +I ";
        }

        for (int i = 0; i < theplan.size(); i++){
            int j = i+1;
            stringstream ss;
            ss << j;
            if(instance.actions[theplan[i]].pre.contains(atom))
                seq += " =" + ss.str() + " ";
            if(instance.actions[theplan[i]].add.contains(atom))
                seq += " +" + ss.str() + " ";
            if(instance.actions[theplan[i]].del.contains(atom))
                seq += " -" + ss.str() + " ";
        }
        
        // new    
	//        for (int i = 0; i < fob_tot; i++){
	//            vector<int> *m = macro_vector(fob[i]);
	//            stringstream ss;
	//            ss << i;
	//            if(contains(m[0], atom))
	//                seqb += " =" + ss.str() + " ";
	//            if(contains(m[1], atom))
	//                seqb += " +" + ss.str() + " ";
	//            if(contains(m[2], atom))
	//                seqb += " -" + ss.str() + " ";
	//        }    
        // end-new

        if(contains(get_vector(instance.goal_atoms), atom)){
            seq += " =G ";
	    //            seqb += " =G ";
        }
        
        out_atoms << atom << ":" << seq << endl;
	//        out_atoms_b << atom << ":" << seqb << endl;
        
        seq.clear();
	//        seqb.clear();
    }
    
    out_actions << "G:[0]: =" << instance.goal_atoms << endl;
    //    out_actions_b << "G:[0]: =" << instance.goal_atoms << endl;
}

void print_atom_lc(char *argv[]){
    string atoms_loc = temp_dir + "/atoms_lc";
    ofstream out_atoms (atoms_loc.c_str());  
    vector<int> atom_vector = get_active_init_atoms(); //get_all_atoms();
    
    for (vector<int>::iterator it = atom_vector.begin(); it != atom_vector.end(); ++it){
        int atom = *it;      
        out_atoms << atom << ":";
        if(contains(get_vector(instance.init_atoms), atom))
        out_atoms << " +I ";
        for (int i = 0; i < theplan.size(); i++){

            if(instance.actions[theplan[i]].pre.contains(atom))
                out_atoms << " =" << i << " ";
            if(instance.actions[theplan[i]].add.contains(atom))
                out_atoms << " +" << i << " ";
            if(instance.actions[theplan[i]].del.contains(atom))
                out_atoms << " -" << i << " ";
        }
        
        if(contains(get_vector(instance.goal_atoms), atom))
            out_atoms << " =G ";
        
        out_atoms << endl;
        
    }
}

vector<int> apply_fixed_rules(int rule_id, int b){
    vector<int> *bu_prf;
    vector<int> block_vector, temp_vector, temp_vector_2, temp_vector_3;
    vector<int> macro = mfb[b];
    vector<int> cw_actions = macro;
    bu_prf = reverse_order_vector(prf_order_vector);
    
    switch ( rule_id ) {
        case 1: // w ← {b}
            block_vector.push_back(b);
            return block_vector;
            break;
        case 2:  // w ← {b} ∪ IP(b)
           temp_vector = nearest_cluster_neighbors(bu_prf, macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));
           break;  
        case 3:  // w ← {b} ∪ IS(b)
           temp_vector = nearest_cluster_neighbors(prf_order_vector, macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));
           break; 
        case 4:  // w ← {b} ∪ Un(b)
           temp_vector = get_unordered_actions(macro);
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));
           break; 
        case 5:  // w ← {b} ∪ Un(b) ∪ IP(b)
           temp_vector = get_unordered_actions(macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end()); 
           
           temp_vector = nearest_cluster_neighbors(bu_prf, macro); 
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));
           break; 
        case 6:  // w ← {b} ∪ Un(b) ∪ IS(b)
           temp_vector = get_unordered_actions(macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());  
           
           temp_vector = nearest_cluster_neighbors(prf_order_vector, macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));           
           break; 
        case 7:  // w ← {b} ∪ Un(b) ∪ IP(b) ∪ IS(b)
           temp_vector = get_unordered_actions(macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());  
           
           temp_vector = nearest_cluster_neighbors(bu_prf, macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           
           temp_vector = nearest_cluster_neighbors(prf_order_vector, macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));  
           break; 
        case 8:  // w ← {b} ∪ Un(b) ∪ IP({b} ∪ Un(b))
           temp_vector = get_unordered_actions(macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           cw_actions = get_window_actions(include_intermediate_blocks(get_block(cw_actions)));
           if(have_common(cw_actions, frozen_actions)) { cw_actions.clear(); return cw_actions;}
           
           temp_vector = nearest_cluster_neighbors(bu_prf, cw_actions);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));  
           break; 
        case 9:  // w ← {b} ∪ Un(b) ∪ IS({b} ∪ Un(b))
           temp_vector = get_unordered_actions(macro);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           cw_actions = get_window_actions(include_intermediate_blocks(get_block(cw_actions)));
           if(have_common(cw_actions, frozen_actions)) { cw_actions.clear(); return cw_actions;}
           
           temp_vector = nearest_cluster_neighbors(prf_order_vector, cw_actions);
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           temp_vector.clear();
           return (get_block(cw_actions));  
           break; 
        case 10:  // {b} ∪ Un(b) ∪ IP({b} ∪ Un(b)) ∪ IS({b} ∪ Un(b))
           temp_vector = get_unordered_actions(macro);           
           if(have_common(temp_vector, frozen_actions)) { temp_vector.clear(); return temp_vector;}
           
           cw_actions.insert(cw_actions.end(), temp_vector.begin(), temp_vector.end());
           cw_actions = get_window_actions(include_intermediate_blocks(get_block(cw_actions)));
           if(have_common(cw_actions, frozen_actions)) { cw_actions.clear(); return cw_actions;}
            
           temp_vector_2 = nearest_cluster_neighbors(bu_prf, cw_actions);
           if(have_common(temp_vector_2, frozen_actions)) { temp_vector_2.clear(); return temp_vector_2;}
           temp_vector_3 = nearest_cluster_neighbors(prf_order_vector, cw_actions);
           if(have_common(temp_vector_3, frozen_actions)) { temp_vector_3.clear(); return temp_vector_3;}
           
           cw_actions.insert(cw_actions.end(), temp_vector_2.begin(), temp_vector_2.end());
           cw_actions.insert(cw_actions.end(), temp_vector_3.begin(), temp_vector_3.end());
           temp_vector_2.clear();
           temp_vector_3.clear();
           return (get_block(cw_actions));  
           break; 
        default:            
            cout<<"Error, bad input, try again \n";
            break;
    }
}

double admissible_heuristic_cost(vector<int> *init_goal){
  //    vector<int> *pwq = formulate_window_pwq(cw_actions);
    
  //    cout << "pwq[0]: " << vector_to_string(pwq[0]) << endl;
  //    cout << "pwq[1]: " << vector_to_string(pwq[1]) << endl;
  //    cout << "pwq[2]: " << vector_to_string(pwq[2]) << endl;
  //    
    
  //    vector<int> *init_goal = generate_init_goal_atoms(cw_actions);
    
    HSPS::index_set opt_init, opt_goal;
    for (vector<int>::iterator itig = init_goal[0].begin(); itig != init_goal[0].end(); itig++) opt_init.insert(*itig);
    for (vector<int>::iterator itig = init_goal[1].begin(); itig != init_goal[1].end(); itig++) opt_goal.insert(*itig);
    HSPS::CostACF cost(instance);
    HSPS::ForwardLMCut h(instance, opt_goal, cost, stats);
    NTYPE value = h.eval(opt_init);
    return value.decimal();
            
    //    double adhval = value.decimal();
}

vector<int> encrypt_action_sequence(vector<int> actions){
    if(actions.empty()) return actions;
    
    if(actions.size() == 1){ 
        actions.push_back(actions.front());
        return actions;
    }
    //    actions.sort();
    
    vector<int> encrypted_actions;
    //    vector<int> vactions = vector_to_vector(actions);
    
    int caction; 
    int paction = actions[0];
    encrypted_actions.push_back(paction);
    for(int x = 1; x < actions.size(); x++){
        caction = actions[x];
        if(caction == paction+1){  
            paction = caction;
            continue;
        }
        else{
            encrypted_actions.push_back(paction);
            encrypted_actions.push_back(caction);   
            paction = caction;
        }        
        
    }
    encrypted_actions.push_back(caction); 
    return encrypted_actions;
}

vector<int> decrypt_action_sequence(vector<int> actions){
    if(actions.empty()) return actions;
    
    vector<int> decrypted_actions;
    //    vector<int> vactions = vector_to_vector(actions);
    
    for(int v = 0; v < actions.size(); v += 2)
        for(int i = actions[v]; i <= actions[v+1]; i++)
            decrypted_actions.push_back(i);
    
    return decrypted_actions;    
}

bool store_candidate_window(vector<int> cw_blocks, int rule, ofstream &fileout_cw, int &added_windows_tot, int b, int wtot){
    //    if(wstrategy == 2)
    //        cout << "lblocks: " << vector_to_string(cw_blocks) << endl;
    bool accepted = true;
    
    //    vector<int> redundant_blocks;
    int tot_iatoms, tot_gatoms;
    tot_iatoms = tot_gatoms = -1;
    int wid = -1;
    double twf, tig, tad;
    twf = -1.0;
    tig = -1.0;
    tad = -1.0;
    double swatch_loc;
    string reason;

    swatch_loc = get_wall_time();
    
    vector<int> wa = get_window_actions(cw_blocks);

    vector<int> cw_actions = formulate_window_w(wa); 
    string cw_actions_str = vector_to_string(cw_actions, ".");
    
    
    
    if(have_common(cw_actions, frozen_actions)){ 
        accepted = false;
        reason = "FROZ_OVR";
    }
    
    
    //    if(accepted){
    
    twf = get_wall_time()-swatch_loc;
    vector<int> rank_vector;
    
    if(accepted){
        W_UMAP::iterator it = window_umap.find(cw_actions_str);
        if (it != window_umap.end()){
            wid = it->second;
            if(wpid == 0 || wpid == 5){
                int fid = (wpid*2)+rule;
                if(!window[wid].get_frules()[fid]) 
                    window[wid].set_frule(fid);
            }

            if(!window[wid].get_wpolicies()[wpid]) 
                window[wid].set_wpolicy(wpid);
            accepted = false;
            reason = "EXIST_B4";
        }
    }
    
    vector<int> *init_goal_atoms;
    
    int ah_cost; 
    int ascost;
    if(accepted){
        ascost = action_set_cost(cw_actions);

        if(ascost == 0){ 
            accepted = false;
            reason = "ACOST==0";
        }
    }
    
    swatch_loc = get_wall_time();

    string iatoms_str;
    string gatoms_str;

    if(accepted){
        init_goal_atoms = generate_init_goal_atoms(cw_actions); 
        sort(init_goal_atoms[0].begin(), init_goal_atoms[0].end());
        sort(init_goal_atoms[1].begin(), init_goal_atoms[1].end());

        iatoms_str = vector_to_string(init_goal_atoms[0], ".");
        gatoms_str = vector_to_string(init_goal_atoms[1], ".");

	// string skey = iatoms_str + "|" + gatoms_str;
	// S_UMAP::iterator got = sprob_umap.find(skey);
	// if ( got != sprob_umap.end() ){ 
	//     int ocost = got->second;
	//     if(ascost <= ocost){ 
	//         hcut[wpid]++;
	//         for(int i = 0; i < 4; i++) init_goal_atoms[i].clear();
	//         accepted = false;
	//         reason = "ACST<=OP";
	//     }
	// }
    }

    if(accepted){
        tig = get_wall_time()-swatch_loc;
        swatch_loc = get_wall_time();
        double adm_h_cost = admissible_heuristic_cost(init_goal_atoms);
        tad = get_wall_time()-swatch_loc;
        ah_cost = static_cast<int>(adm_h_cost);
        tot_iatoms = init_goal_atoms[0].size();
        tot_gatoms = init_goal_atoms[1].size();

        if(ascost <= ah_cost){ 
            hcut[wpid]++;
            for(int i = 0; i < 4; i++) init_goal_atoms[i].clear();
            accepted = false;
            reason = "ACST<=AH";
        }
    }
    
    if(accepted){
        Window cw;

        rank_vector.push_back(cw_actions.size()); // 0
        rank_vector.push_back(ascost);  // 1
        rank_vector.push_back(ah_cost); // 2
        rank_vector.push_back(incoming_causal_producers(cw_actions).size()); // 3
        rank_vector.push_back(get_tot_icl(cw_actions)); // 4
        rank_vector.push_back(outgoing_causal_producers(cw_actions).size()); // 5
        rank_vector.push_back(get_tot_ocl(cw_actions)); // 6

        cw.set_actions_str(cw_actions_str);
//        cw.set_pred_str(vector_to_string(init_goal_atoms[2], " "));
//        cw.set_succ_str(vector_to_string(init_goal_atoms[3], " "));
        cw.set_iatoms_str(iatoms_str);
        cw.set_gatoms_str(gatoms_str);    
        cw.set_rank(rank_vector);
        cw.set_wpolicy(wpid);
        if(wpid == 0 || wpid == 5){
            int fid = (wpid*2)+rule;
            cw.set_frule(fid);            
        }
        window.push_back(cw);
        wid = window.size()-1;    


        window_umap[cw_actions_str] = wid;

	//    string skey = cw.get_iatoms_str() + " | " + cw.get_gatoms_str();
	//    vector<int> v(6,0); // wid - cost - hcost - costImpr - exhaust - wid - trial
	//    v[0] = 1; 
	//    v[1] = ascost; 
	//    v[2] = ah_cost;     
	//    S_UMAP::iterator got = sprob_umap.find(skey);
	//    if ( got == sprob_umap.end() ) sprob_umap[skey] = v;
    }
    
    process_mem_usage(vm, rss);
  
    if(accepted){ 
        reason = "ACCEPTED";
        added_windows_tot++;
        for(int i = 0; i < 4; i++) init_goal_atoms[i].clear();
    }
 
    fileout_cw << iteration << "\t" 
            << wpid << "\t" 
            << wid << "\t" 
            << rule << "\t" 
            << reason << "\t" 
            << wtot << "\t" 
            << added_windows_tot << "\t" 
            << b << "\t" 
            << fixed << setprecision(0) << vm << "\t"
            << fixed << setprecision(0) << rss << "\t"
            << fixed << setprecision(2) << twf << "\t"
            << fixed << setprecision(2) << tig << "\t"
            << fixed << setprecision(2) << tad << "\t" 
            << fixed << setprecision(3) << total_tm+(get_wall_time()-swatch) << "\t" 
            << fixed << setprecision(0) << cw_actions_str << endl;
    // << fixed << setprecision(0) << cw.get_iatoms_str() << "\t" 
    // << fixed << setprecision(0) << cw.get_gatoms_str() << endl;
        
    return accepted;
}

vector<int> get_wave_sequence(int maxval){
    vector<int> wv;
    int pt;
    wv.resize(maxval);    
    
    pt = 0;
    for(int x = maxval; x >= 1; x--){
        wv[pt] = x;
        pt += 2;
        if(pt >= wv.size()) break;
    }
    pt = 1;
    for(int x = 1; x <= maxval; x++){
        wv[pt] = x;
        pt += 2;
        if(pt >= wv.size()) break;
    }
    
    return wv;
}

void create_mixed_windows(ofstream &fileout_cw, int &added_windows_tot, double time_start_wf){
    vector<int> cw_blocks;
    cw_blocks.resize(mfb_tot);
    for(int b = 0 ; b < mfb_tot ; b++){
        cw_blocks[b] = b;
    }
    cw_blocks = difference_set(cw_blocks, unusable_blocks);    
    bool added = store_candidate_window(cw_blocks, -1, fileout_cw, added_windows_tot, -1, 1); 
}

void create_fixed_windows(ofstream &fileout_cw, int &added_windows_tot, double time_start_wf){

    vector<int> rule_ids = get_wave_sequence(10);
    
    int wtot = wg_status[wpid][1];
    int b = wg_status[wpid][2];
    int x = wg_status[wpid][3];
    //    cout << "mfb_tot: " << mfb_tot << endl;
    for( ; b < mfb_tot ; b++){
        
        for( ; x <= rule_ids.size()-1; x++){
            wtot++;
            int r = rule_ids[x];

            if( have_common(mfb[b], frozen_actions) || contains(mfb[b], 0) || contains(mfb[b], prf_size-1) || have_subset(redundant_actions, mfb[b])) continue;
            vector<int> cw_blocks;
            cw_blocks = apply_fixed_rules(r, b);
            
            if(cw_blocks.empty()) continue; // if mixed up with frozen windows
            
            cw_blocks = difference_set(cw_blocks, unusable_blocks);
            
            bool added = store_candidate_window(cw_blocks, r, fileout_cw, added_windows_tot, b, wtot); 
            
	    //  if(added) added_windows_tot++;
            
            
	    // if(added) fileout << "Accepted" << endl;
	    // else fileout << "Rejected" << endl;
	    // fileout << "tm-added_windows_tot-wtot-b-x: " << (get_wall_time()-time_start_wf) << " " << added_windows_tot << " " << wtot << " " << b << " " << x << endl;
            
            if((get_wall_time()-time_start_wf) >= WF_TIME_BOUND_ONCE || wtot >= MAX_WINDOW_BOUND_PER_WPOLICY || added_windows_tot >= MAX_WINDOW_BOUND_ONCE) break;
        } 
        if((get_wall_time()-time_start_wf) >= WF_TIME_BOUND_ONCE || wtot >= MAX_WINDOW_BOUND_PER_WPOLICY || added_windows_tot >= MAX_WINDOW_BOUND_ONCE) break;
        else if(b < mfb_tot-1) x = 0;
    }
    
    // save status    
    wg_status[wpid][1] = wtot;
    wg_status[wpid][2] = b;
    wg_status[wpid][3] = x;
           
    //    if(wg_status[wpid][2] >= mfb_tot-1 && wg_status[wpid][3] >= rule_ids.size()-1){ // exhausted
    if(b >= mfb_tot ){ // exhausted
        wg_status[wpid][0] = 1; // freeze
        wpid = (wpid+1) % WINDOW_POLICY_TOT;
    }
    else if(wtot >= MAX_WINDOW_BOUND_PER_WPOLICY){ 
        wg_status[wpid][1] = 0; // reset local window count (wtot))
        wpid = (wpid+1) % WINDOW_POLICY_TOT;        
    }
    //    else if(wtot >= MAX_WINDOW_BOUND_PER_WPOLICY){ // exceed MAX_WINDOW_BOUND_PER_WPOLICY
    //        wg_status[wpid][1] = 0; // reset local window count
    //        wpid = (wpid+1) % WINDOW_POLICY_TOT;        
    //    }
    //    exit(1);
    //    return added_windows_tot;
}

void create_causal_windows(ofstream &fileout_cw, int &added_windows_tot, double time_start_wf){
  //    cwindow.clear();
  //    rejected_windows = 0;
  //    swatch_temp = get_wall_time(); 
  //    vector<int> atom_vector = get_all_atoms();
    
    int wtot = wg_status[wpid][1];
    int m = wg_status[wpid][2];
    int x = wg_status[wpid][3];
    int y = wg_status[wpid][4];
    
    int thread_length;
    vector<int> wsize_order;
    
    vector<int> *causal_blocks;
    causal_blocks = new vector<int> [prf_size];
    

    bool break_flag = false;
    
    for ( ; m < live_atoms.size(); m++){
        
        int atom = live_atoms[m];   
        
        int ca_tot= 0;
        for (int p = 0; p < prf_size-1; p++){
            if(contains(redundant_actions, p) || contains(frozen_actions, p)) continue;
            if(!prf_order_vector[p].empty() && prf_order_vector[p].front() == -1) continue;
            vector<int> temp_vector, cblock;            
            if(!contains(add_vector[p], atom)) continue;
            if(p != 0) 
                temp_vector.push_back(p);
            
            for (vector<int>::iterator itc = straight_dependent_vector[p].begin(); itc!= straight_dependent_vector[p].end(); itc++){
                int c = *itc;
                if(contains(redundant_actions, c) || contains(frozen_actions, c)) continue;
                if(c == prf_size-1) continue;
                if(contains(sd_atoms[p][c], atom)) 
                    temp_vector.push_back(c);
            }
            
            if(temp_vector.empty()) continue;
            
            for (vector<int>::iterator itx = temp_vector.begin(); itx != temp_vector.end(); ++itx)
                cblock.push_back(get_block(*itx));
            
            temp_vector.clear();
//            cblock.sort();
            unique_vec(cblock);
            
            causal_blocks[ca_tot].insert(causal_blocks[ca_tot].end(), cblock.begin(), cblock.end());
            ca_tot++;
        }
            
            
        // create windows;
        thread_length = ca_tot;
        wsize_order = get_wave_sequence(thread_length);
        
        
        
        for( ; x < wsize_order.size(); x++){
            int wsize = wsize_order[x];
            for( ; y+wsize <= thread_length; y++){
                wtot++;
                vector<int> cw_blocks, cw_actions;
                for(int z = y; z < y+wsize; z++){
//                    vector<int> temp = causal_blocks[j];
                    cw_blocks.insert(cw_blocks.end(), causal_blocks[z].begin(), causal_blocks[z].end());
                }

                
                cw_blocks = difference_set(cw_blocks, unusable_blocks);
                if(window_size(cw_blocks) < 2) continue;
                if(have_common(get_window_actions(cw_blocks), frozen_actions)) continue;

		// cw_actions = get_window_actions(cw_blocks);
		// cw_actions = formulate_window_w(cw_actions);                
		// store_candidate_window(cw_actions, atom);  
		// if(wpid == 3 && x == 1 && y == 2){
		// if(wpid == 3){
		//     cout << m << " " << x << " "  << y << " : " << vector_to_string(cw_blocks, " ") << endl;
		// }
                
                bool added = store_candidate_window(cw_blocks, atom, fileout_cw, added_windows_tot, wsize, wtot);
                
		// if(added) fileout << "Accepted" << endl;
		// else fileout << "Rejected" << endl;
		// fileout << "wtot-m-x-y: " << wtot << " " << m << " " << x << " " << y << endl;
                
                
		// if(added) added_windows_tot++;
		// wtot++;
		// store_candidate_window(include_intermediate_blocks(cw_blocks), atom, btype, wstrategy, fileout_cw, fileout_cws);
		// if((get_wall_time()-swatch_temp) >WF_TIME_BOUND_ONCE || window.size() > max_tot_windows) return;
                if((get_wall_time()-time_start_wf) >= WF_TIME_BOUND_ONCE || wtot >= MAX_WINDOW_BOUND_PER_WPOLICY || added_windows_tot >= MAX_WINDOW_BOUND_ONCE){ 
                    break_flag = true;
                    break;
                }
            } 
            if(break_flag) break;
            else if(x < wsize_order.size()-1) y = 0;
	    // if((get_wall_time()-time_start_wf) >= WF_TIME_BOUND_ONCE || wtot >= MAX_WINDOW_BOUND_PER_WPOLICY || added_windows_tot >= MAX_WINDOW_BOUND_ONCE) break;
        } 
        for (int i = 0; i < ca_tot; i++) causal_blocks[i].clear();   
        if(break_flag) break;
        else if(m < live_atoms.size()-1) x = 0;
    } // END-FOR
        
    // save status    
    wg_status[wpid][1] = wtot;
    wg_status[wpid][2] = m;
    wg_status[wpid][3] = x;
    wg_status[wpid][4] = y;
           
    // if(m >= live_atoms.size()-1 && x >= wsize_order.size()-1 && y+wsize_order[x] >= thread_length){ // exhausted
    if(m >= live_atoms.size()){ // exhausted
        wg_status[wpid][0] = 1; // freeze
        wpid = (wpid+1) % WINDOW_POLICY_TOT;
    }
    else if(wtot >= MAX_WINDOW_BOUND_PER_WPOLICY){ 
        wg_status[wpid][1] = 0; // reset local window count (wtot))
        wpid = (wpid+1) % WINDOW_POLICY_TOT;        
    }
    // else if(wtot >= MAX_WINDOW_BOUND_PER_WPOLICY){ // exceed MAX_WINDOW_BOUND_PER_WPOLICY
    //     wg_status[wpid][1] = 0; // reset local window count
    //     wpid = (wpid+1) % WINDOW_POLICY_TOT;        
    // }
    
    // return added_windows_tot;
    // cout << "causal cwindow.size(): " << cwindow.size() << endl;
}

void create_cyclic_windows(ofstream &fileout_cw, int &added_windows_tot, double time_start_wf){
  //    vector<int> atom_vector = get_all_atoms();
  //    swatch_temp = get_wall_time(); 

    int wtot = wg_status[wpid][1];
    int m = wg_status[wpid][2];
    int x = wg_status[wpid][3];
    int y = wg_status[wpid][4];
    
    int thread_length;
    vector<int> wsize_order;
    
    //    cout  << endl << "las-m" << live_atoms.size()-1 << " " << m << endl;
    //    cout  << "woss-x" << wsize_order.size()-1 << " " << x << endl;
    //    cout  << "tl-y" << thread_length << " " << y+wsize_order[x] << endl;
    //    cout  << "*-wtot" << MAX_WINDOW_BOUND_PER_WPOLICY << " " << wtot << endl;
    //    cout  << "*-wtot" << MAX_WINDOW_BOUND_ONCE << " " << added_windows_tot << endl << endl;
    
    bool break_flag = false;

    for ( ; m < live_atoms.size(); m++){
        
      // cout << "m: " << m << endl;
      // if((get_wall_time()-swatch_temp) >WF_TIME_BOUND_ONCE) return;
   
        int atom = live_atoms[m];       
        
        vector<int> cp_actions;
        vector<int> cp_blocks;
        vector<int> consumers;
        
	// cp_actions.push_back(atom);
        
        int cp = 0;
        bool iflag = false;
        if(contains(add_vector[0], atom)){
            cp++;
            iflag = true;
        }

        for (int i = 1; i < prf_size-1; i++){
            if(contains(redundant_actions, i) || contains(frozen_actions, i)) continue;
            if(!prf_order_vector[i].empty() && prf_order_vector[i].front() == -1) continue;
            if(contains(pre_vector[i], atom)) 
                consumers.push_back(i);
            if(contains(add_vector[i], atom)){                
                if(get_block(i) != -1) {
                    cp++;
                    cp_actions.push_back(i);
                }
            }
        }
        
        if(cp < 2) continue;
        
        if(iflag){
            vector<int> extended_producers;
            for (vector<int>::iterator itx = consumers.begin(); itx != consumers.end(); ++itx){
                bool path_exist = false;
                for (vector<int>::iterator ity = cp_actions.begin(); ity != cp_actions.end(); ++ity){
		  // if(*ity >= *itx) break;
                    if(have_path(prf_order_vector, *ity, *itx, prf_size )){
                        path_exist = true;
                        break;
                    }                    
                }
                if(!path_exist && get_block(*itx) != -1)
                    extended_producers.push_back(*itx);
            }
            cp_actions.insert(cp_actions.begin(), extended_producers.begin(), extended_producers.end()); // newly changed !!!
            extended_producers.clear();
        }
        
        
        
	// sort(cp_actions.begin(), cp_actions.end()); // newly changed !!!
        unique_vec(cp_actions); //.unique();
        
        if(cp_actions.size() < 2) continue;
        if(have_common(cp_actions, frozen_actions)) continue;
        
        for (vector<int>::iterator itx = cp_actions.begin(); itx != cp_actions.end(); ++itx)
            cp_blocks.push_back(get_block(*itx));
        
        unique_vec(cp_blocks);
       
        // create windows;
        thread_length = cp_blocks.size();
        wsize_order = get_wave_sequence(thread_length);
        
        
        
        for( ; x < wsize_order.size(); x++){
	  // cout  << "x-woss: " << x << " " << wsize_order.size() << endl;
            int wsize = wsize_order[x];
	    // for(int wsize = 1; wsize <= thread_length; wsize++){
            for( ; y+wsize <= thread_length; y++){
	      // cout  << "y-tl: " << y+wsize_order[x] << " " << thread_length  << endl;
                wtot++;
                vector<int> cw_blocks, cw_actions;
                for(int z = y; z < y+wsize; z++)
                    cw_blocks.push_back(cp_blocks[z]);
                
                cw_blocks = difference_set(cw_blocks, unusable_blocks);
                if(window_size(cw_blocks) < 2) continue;
                
                bool added = store_candidate_window(cw_blocks, atom, fileout_cw, added_windows_tot, wsize, wtot);
                


                if((get_wall_time()-time_start_wf) >= WF_TIME_BOUND_ONCE || wtot >= MAX_WINDOW_BOUND_PER_WPOLICY || added_windows_tot >= MAX_WINDOW_BOUND_ONCE){ 
                    break_flag = true;
                    break;
                }
            } 
            if(break_flag) break;
            if(x < wsize_order.size()-1) y = 0;
        } 
        if(break_flag) break;
        if(m < live_atoms.size()-1) x = 0;
    } // End_For
    
    // save status    
    wg_status[wpid][1] = wtot;
    wg_status[wpid][2] = m;
    wg_status[wpid][3] = x;
    wg_status[wpid][4] = y;
           
    //    cout  << "m-las: " << m << " " << live_atoms.size()  << endl;
    //    cout  << "x-woss: " << x << " " << wsize_order.size() << endl;
    //    cout  << "y-tl: " << y+wsize_order[x] << " " << thread_length  << endl;
    //    cout  << "*-wtot: " << MAX_WINDOW_BOUND_PER_WPOLICY << " " << wtot << endl;
    //    cout  << "*-wtot: " << MAX_WINDOW_BOUND_ONCE << " " << added_windows_tot << endl;
    
    //    if(m >= live_atoms.size()-1 && x >= wsize_order.size()-1 && y+wsize_order[x] >= thread_length){ // exhausted
    if(m >= live_atoms.size()){ // exhausted
        wg_status[wpid][0] = 1; // freeze
        wpid = (wpid+1) % WINDOW_POLICY_TOT;
    }
    else if(wtot >= MAX_WINDOW_BOUND_PER_WPOLICY){ 
        wg_status[wpid][1] = 0; // reset local window count (wtot))
        wpid = (wpid+1) % WINDOW_POLICY_TOT;        
    }
    //    else if(wtot >= MAX_WINDOW_BOUND_PER_WPOLICY){ // exceed MAX_WINDOW_BOUND_PER_WPOLICY
    //        wg_status[wpid][1] = 0; // reset local window count
    //        wpid = (wpid+1) % WINDOW_POLICY_TOT;        
    //    }
    
    //    return added_windows_tot;
}

vector<int> get_independent_prf_elements(int wi, vector<int> *prf_new, int tot_blocks){
    
    vector<int> ind_wi;
    
    for(int i = 0; i < tot_blocks; i++){
        if(i == wi) continue;
        if(!have_path(prf_new, i, wi, tot_blocks) && !have_path(prf_new, wi, i, tot_blocks)) ind_wi.push_back(i);
    }
    return ind_wi;
}

void write_new_prf_dot_file(string file_name, vector<int> *dot_vector, int iba[], int length){

  ofstream myfile (file_name.c_str());
  
  if (myfile.is_open()){
    myfile << "digraph { \n";
    myfile << "node [width=0,height=0]; \n";    
    
    for (int i = 0; i < length; i++) {
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
        if(iba[i] < 0){
            myfile << i << " [label=\"w" << (iba[i]+100)*(-1)  << "\"]; \n";
        }
        else myfile << i << " [label=\"b" << iba[i]  << "\"]; \n";
    }
  
    for (int i = 0; i < length-1; i++) {
        if(!dot_vector[i].empty() && dot_vector[i].front() == -1)
            continue;
        for (vector<int>::iterator it = dot_vector[i].begin(); it != dot_vector[i].end(); it++){
          myfile << i << "->" << *it << ";\n";
        }        
    }
    
    myfile << "}";
    
    myfile.close();
  }
  else cout << "Unable to open file";
}


int generate_new_plan(){
    int red_pcost = 0;
    for (vector<int>::iterator it = redundant_actions.begin(); it != redundant_actions.end(); ++it)
        red_pcost += instance.actions[theplan[*it-1]].cost.decimal();
    if(red_pcost == 0) return -1;
    
    string dir = string(temp_dir);
    vector<string> files = vector<string>();
    getdir(dir,files, "bdp.soln");            
    int max = files.size();
    max++;
    ostringstream max_oss;
    max_oss << max;
    string plan_file_name = temp_dir + "/bdp.soln." + max_oss.str();
    string plan_store_name = results_dir + "/bdp.soln." + max_oss.str();
    ofstream outfile (plan_file_name.c_str());
            
    vector<int> new_plan_actions;
    for(int i = 1; i < prf_size-1; i++)
        new_plan_actions.push_back(i);
        
    new_plan_actions = difference_set(new_plan_actions, redundant_actions);
    new_plan_actions = formulate_window_w(new_plan_actions);
    
    vector<int> new_plan_action_ids =  get_plan_action_ids(new_plan_actions);        
    int new_plan_cost = check_plan_validity(new_plan_action_ids, 'n');
    
    if(new_plan_cost == -1) return -1;
    
    for (vector<int>::iterator it = new_plan_action_ids.begin(); it != new_plan_action_ids.end(); ++it)
        outfile << instance.actions[*it].name << endl;  
    
    string com = "cp " + plan_file_name + " " + plan_store_name; 
    int comout = system(com.c_str());    
    outfile.close();
    
    double total_tm_loc = total_tm + (get_wall_time()-swatch);            
    fileout << "## " << plan_file_name << ": #cost: " << new_plan_cost+red_pcost << " -> " << new_plan_cost << " #impr_tm_at: " << total_tm_loc << " ";
    fileout << "#loop: " << iteration << endl; 
    
    string param = get_restart_ingredients();     
    int output = system(param.c_str());
    return 1;
    
}

void define_unusable_blocks(){
    unusable_blocks.clear();
    for(int i = 0; i < mfb_tot; i++){
        if(contains(mfb[i], 0) || contains(mfb[i], prf_size-1) || have_subset(redundant_actions, mfb[i])) 
            unusable_blocks.push_back(i);
    }
}

void linearize_blocks(){
    for(int i = 0; i < mfb_tot; i++){
        if(contains(unusable_blocks, i)) continue;
	// cout << i << " (b4):  " << vector_to_string(mfb[i], " ") << endl;
        mfb[i] = get_linearized_blocks(i);
	// cout << i << " (a4): " << vector_to_string(mfb[i], " ") << endl;
    }
}

void generate_basic_and_extended_blocks(){
    swatch_temp = get_wall_time(); 
    formulate_blocks(); 
    define_unusable_blocks();
    fileout << "Basic Block formulation time: " << fixed << setprecision(3) << get_wall_time()-swatch_temp << endl << endl;
    swatch_temp = get_wall_time(); 
    modify_actions_orderings_based_on_blocks();  
    fileout << "Basic Block modify_actions_orderings time: " << fixed << setprecision(3) << get_wall_time()-swatch_temp << endl << endl;
    print_block_file(1);
    write_file(temp_dir + "/BDP_block_based_ordering.dot", prf_order_vector, flex, "");
    swatch_temp = get_wall_time(); 
    linearize_blocks();
    fileout << "Basic Block linearization time: " << fixed << setprecision(3) << get_wall_time()-swatch_temp << endl << endl;
    
    // backup basic block details
    mfb_basic = new vector<int> [mfb_tot];
    for(int j = 0; j < mfb_tot; j++)
        mfb_basic[j] = mfb[j];
    prf_full_basic = new vector<int> [prf_size];
    for(int j = 0; j < prf_size; j++)
        prf_full_basic[j] = prf_full[j];
    mfb_basic_tot = mfb_tot;

    // formulate_extended_blocks
    formulate_extended_blocks();  
    define_unusable_blocks();
    fileout << "Extended block formulation time: " << fixed << setprecision(3) << get_wall_time()-swatch_temp << endl;  
    modify_actions_orderings_based_on_blocks();
    fileout << "Extended Block modify_actions_orderings time: " << fixed << setprecision(3) << get_wall_time()-swatch_temp << endl << endl;
    print_block_file(2);
    write_file(temp_dir + "/BDP_extended_block_based_ordering.dot", prf_order_vector, flex, "");
    linearize_blocks();
    fileout << "Extended Block linearization time: " << fixed << setprecision(3) << get_wall_time()-swatch_temp << endl << endl;
    
    // backup extended block details
    mfb_ext = new vector<int> [mfb_tot];
    for(int j = 0; j < mfb_tot; j++)
        mfb_ext[j] = mfb[j];
    prf_full_ext = new vector<int> [prf_size];
    for(int j = 0; j < prf_size; j++)
        prf_full_ext[j] = prf_full[j];
    mfb_ext_tot = mfb_tot;
    
    basic_block = false;
}

int add_more_candidate_windows(){
    //    stringstream ss;
    //    ss << iteration;
    ofstream fileout_cw; 
    string filestr = results_dir + "/wgen.log"; //+ ss.str();
    fileout_cw.open(filestr.c_str(), ios_base::app);
    if(!fileout_cw) cout << "unable to open: " << filestr << endl;
    
    double time_start_wf = get_wall_time(); 
    
    int added_windows_tot = 0;
    
    // if(window.empty()){
    //     wpid = 6;
    //     create_mixed_windows(fileout_cw, added_windows_tot, time_start_wf); 
    //     wpid = 0;
    //     fileout << "*added:" << added_windows_tot  << " tm:" << get_wall_time()-time_start_wf << endl;
    //     return added_windows_tot;
    // }
    
    while(added_windows_tot < MAX_WINDOW_BOUND_ONCE){
        if(wg_status[0][0] == 1 && wg_status[1][0] == 1 && wg_status[2][0] == 1 && wg_status[3][0] == 1 && wg_status[4][0] == 1 && wg_status[5][0] == 1) break;
        else if((get_wall_time()-time_start_wf) > WF_TIME_BOUND_ONCE){
            if(added_windows_tot == 0) time_start_wf = get_wall_time(); 
            else break;
        }
        
        if(wg_status[wpid][0] == 1){
            wpid = (wpid+1) % WINDOW_POLICY_TOT;
            continue;
        }

        fileout << "wpid:" << wpid;
        
        for(int j = 0; j < mfb_tot; j++) mfb[j].clear();

        if(wpid == 0 || wpid == 2 || wpid == 4){ // extended
            mfb_tot = mfb_ext_tot;
            for(int j = 0; j < mfb_tot; j++) mfb[j] = mfb_ext[j];
            for(int j = 0; j < prf_size; j++){
                prf_full[j].clear(); 
                prf_full[j] = prf_full_ext[j];
            }
            basic_block = false;
        }
        else if(wpid == 1 || wpid == 3 || wpid == 5){ // basic
            mfb_tot = mfb_basic_tot;
            for(int j = 0; j < mfb_tot; j++) mfb[j] = mfb_basic[j];
            for(int j = 0; j < prf_size; j++){
                prf_full[j].clear(); 
                prf_full[j] = prf_full_basic[j];
            }
            basic_block = true;
        }

        prf_order_vector = delete_transitive_order(prf_full, prf_size);
        set_action_path();
        define_unusable_blocks();
        
	// cout << "wpid:" << wpid << " added_windows_tot_b4:" << added_windows_tot << endl;

	// if(window.empty()){
	//     wpid = 1;
	//     create_mixed_windows(fileout_cw, added_windows_tot, time_start_wf); 
	//     wpid = 0;
	//     fileout << " *added:" << added_windows_tot  << " tm:" << get_wall_time()-time_start_wf << endl;
	//     break;;
	// }
        if(wpid == 0 || wpid == 5) create_fixed_windows(fileout_cw, added_windows_tot, time_start_wf);  
        else if(wpid == 1 || wpid == 2) create_cyclic_windows(fileout_cw, added_windows_tot, time_start_wf); 
        else if(wpid == 3 || wpid == 4) create_causal_windows(fileout_cw, added_windows_tot, time_start_wf); 
        
        fileout << " added:" << added_windows_tot  << " tm:" << get_wall_time()-time_start_wf << endl;
    }
    
    if(!basic_block){ // end up with basic block
        mfb_tot = mfb_basic_tot;
        for(int j = 0; j < mfb_tot; j++) mfb[j] = mfb_basic[j];
        for(int j = 0; j < prf_size; j++){
            prf_full[j].clear(); 
            prf_full[j] = prf_full_basic[j];
        }
        
        prf_order_vector = delete_transitive_order(prf_full, prf_size);
        set_action_path();
        define_unusable_blocks();
        
        basic_block = true;
    }
    
    return added_windows_tot;
}

void initialise_events(){  
    string dom(arguments[1]);
    string prob(arguments[2]);
    string plan(arguments[3]);
    
    std::srand ( unsigned ( time(0) ) );
    
    wpid = 0;
    wg_status = new vector<int> [WINDOW_POLICY_TOT];
    for(int i = 0; i < WINDOW_POLICY_TOT; i++){
        wg_status[i].resize(6);
        fill(wg_status[i].begin(), wg_status[i].end(), 0); // [wp_exhaust  wtot  b/m  x  y  !]
    }
    
    live_atoms = get_all_atoms();
    generate_basic_and_extended_blocks();
    
    bandit_planner =  new Bandit_Planner [TOT_PLANNERS]; 
    //    for(int i = 0; i < TOT_PLANNERS; i++)
    //        bandit_planner[i].set_planner_id(i);

    if(iteration == 1){         
        ofstream fileout_planner; 
        string filestr = results_dir + "/bandit_planner.txt";
        fileout_planner.open(filestr.c_str(), ios_base::app);
        if(!fileout_planner) cout << "unable to open: " << filestr << endl;
        plan_cost_last = get_plan_cost(dom, prob, plan);
        plan_length_last = theplan.size();
        
        ofstream fileout_bp; 
        filestr = results_dir + "/better_plans.log";
        fileout_bp.open(filestr.c_str(), ios_base::app);
        if(!fileout_bp) cout << "unable to open: " << filestr << endl;
        fileout_bp << bplan_isnum << " " << plan_cost_last << " " << total_tm+(get_wall_time()-swatch) << endl;
        fileout_bp.close();
	// cout << "plan_cost_last: " << plan_cost_last << endl;
    }
    else if(iteration > 1){
        // restore bandit_planner
        string str = results_dir + "/pbandit.log";
        ifstream filein_planner(str.c_str());
        string line;
        getline(filein_planner,line);
        bandit_planner[0].add_all_rewards(string_to_vector_float(line, " "));
        line.clear();
        getline(filein_planner,line);
        bandit_planner[1].add_all_rewards(string_to_vector_float(line, " "));
        line.clear();
        filein_planner.close();
        
        // restore optimal windows
        str = results_dir + "/sprob_opt.log";
        ifstream filein_optimal(str.c_str()); 
        while( getline(filein_optimal,line) ){  
            stringstream ss;
            if (line.find("|")==string::npos) continue;
            vector<string> token_vector = split_string(line, " ");
            
            int ocost;
            string skey = token_vector[0];
            ss << token_vector[1];
            ss >> ocost;
            sprob_umap[skey] = ocost;
            ss.clear();
        }
        filein_optimal.close();
        
        plan_length_last = theplan.size();
        plan_cost_last = get_plan_cost_last(arguments[1], arguments[2]);
    }
}

void save_optimisation_result(int wid, int pid, double translation_time, double preprocess_time, vector<int> &flop_count, vector<int> &rank_policy, vector<int> *wids_sorted, vector<int> &merge_result){
    // stringstream ss;
    // ss << iteration;
    ofstream fileout_cw; 
    string filestr = results_dir + "/wopt.log";
    fileout_cw.open(filestr.c_str(), ios_base::app);
    if(!fileout_cw) cout << "unable to open: " << filestr << endl;
    fileout_cw  << iteration << "\t" 
                << bplan_isnum << "\t"   
                << merge_result[0] << "\t"   // improved total
                << merge_result[1] << "\t"   // merged total
                << wid << "\t" 
                << pid << "\t"
                << window.size() << "\t"
                << wids_sorted[0].size() << "\t"
                << wids_sorted[1].size() << "\t"
                << flop_count[0] << "\t"
                << flop_count[1] << "\t"
                << rank_policy[0] << "\t"
                << rank_policy[1] << "\t"
                << window[wid].get_trial_count(0) << "\t" 
                << window[wid].get_trial_count(1) << "\t" 
                << window[wid].get_cost() << "\t"
                << window[wid].get_cost_improve() << "\t"
                << plan_cost_last << "\t"
                << plan_length_last << "\t"
                << window[wid].exhausted() << "\t"                
                << frozen_actions.size() << "\t"            
                << fixed << setprecision(2) << translation_time << "\t"
                << fixed << setprecision(2) << preprocess_time << "\t"
                << fixed << setprecision(2) << window[wid].get_time_1st_plan() << "\t"
                << fixed << setprecision(2) << window[wid].get_exhaust_time() << "\t"                
                << fixed << setprecision(3) << total_tm+(get_wall_time()-swatch) << endl;
    fileout_cw.close();
}

bool check_exhaust(int pid, int opid, int wid, int new_cost, vector<int> *wids_sorted){
    bool exhaust = false;
    string time_str;
    if(pid == 0 && (file_keyword_exist("log.txt", "no solution!") || new_cost <= window[wid].get_adm_hcost())  ){ 
        exhaust = true;
        time_str = file_get_line_from_last_match("log.txt", "Actual search time:", "#EOF#"); 
        time_str = time_str.substr(time_str.find("=")+1, time_str.find("s]")-(time_str.find("=")+1));
        
    }
    else if(pid == 1 && (file_keyword_exist("log.txt", "Neighborhood graph does not grow") || new_cost <= window[wid].get_adm_hcost()) ){ 
        exhaust = true;
        time_str = file_get_next_token_from_last_match("log.txt", "Total_Time:"); 
        time_str.erase(time_str.end()-1);
    }
    
    if(exhaust){
        window[wid].mark_exhausted();
        remove_val(wids_sorted[opid], wid);

        string skey = window[wid].get_iatoms_str() + "|" + window[wid].get_gatoms_str();
        S_UMAP::iterator got = sprob_umap.find(skey);
        if ( got == sprob_umap.end() ) sprob_umap[skey] = new_cost;

        double time_exhaust;
        istringstream convert_time_f(time_str);
        convert_time_f >> time_exhaust;
        window[wid].set_exhaust_time(time_exhaust);
    }
    
    // cout << sprob_umap.size() << " : " << new_cost << endl;
    return exhaust;    
}

bool optimise_window(int pid, int wid, vector<int> &flop_count, vector<int> &rank_policy, vector<int> *wids_sorted){
    string dom(arguments[1]);
    
    bool op_result = false;
    
    int opid = (pid+1)%2;
    double time_stamp, translation_time, preprocess_time, planning_time;
    vector<int> merge_result(3, 0);
    
    int time_bound = PLAN_TBOUND * (window[wid].get_trial_count(pid)+1);
    int cost_bound =  window[wid].get_cost() - window[wid].get_cost_improve();

    // vector<int> *ig_atoms = generate_init_goal_atoms(string_to_vector(window[wid].get_pred_str(), " "), string_to_vector(window[wid].get_succ_str(), " ") );
    // vector<int> iatoms = ig_atoms[0]; ig_atoms[0].clear();
    // vector<int> gatoms = ig_atoms[1]; ig_atoms[1].clear();
    
    vector<int> iatoms = string_to_vector(window[wid].get_iatoms_str(), ".");
    vector<int> gatoms = string_to_vector(window[wid].get_gatoms_str(), ".");
    vector<int> cwindow = string_to_vector(window[wid].get_actions_str(), ".");
    
    // cout << "cwindow: " << vector_to_string(cwindow, ".") << endl;
    // fileout << "pred: " << window[wid].get_pred_str() << endl;
    // fileout << "actn: " << window[wid].get_actions_str() << endl;
    // fileout << "succ: " << window[wid].get_succ_str() << endl;

    write_file_sub_problem(arguments[2], iatoms, gatoms, wid);
    write_run_planner(TRAN_TBOUND);
    
    int output_1 = -1;
    int output_2 = -1;
    int output_3 = -1;   
        
    // translation
    time_stamp = get_wall_time();  
    ifstream sas_file;
    string tstr = "output.sas";
    sas_file.open(tstr.c_str(), ios::in);
    
    stringstream ss;
    ss << wid;
    
    if(sas_file.fail()){        
        string param1 = com_file + " " + fd_src_location + "/translate/translate.py " + dom + " " + temp_dir + "/sprob." + ss.str();
        output_1 = system(param1.c_str());
        int sout = system("cp log.txt log_1.txt");
    }
    else{
        sas_file.close();
        output_1 = update_translator(wid, iatoms, gatoms);
        if(output_1 < 0){
            string param1 = com_file + " " + fd_src_location + "/translate/translate.py " + dom + " " + temp_dir + "/sprob." + ss.str();
            output_1 = system(param1.c_str());
            int sout = system("cp log.txt log_1.txt");
        }
    } 
    translation_time = get_wall_time() - time_stamp;
    ss.clear();
    
    // preprocessing
    time_stamp = get_wall_time();  
    string param2 = com_file + " " + fd_src_location + "/preprocess/preprocess < output.sas";  
    output_2 = system(param2.c_str());
    
    if(!file_keyword_exist("log.txt", "done")){
        fileout << "translation_error: going back to using translator" << endl;
        string param1 = com_file + " " + fd_src_location + "/translate/translate.py " + dom + " " + temp_dir + "/sprob." + ss.str();
        output_1 = system(param1.c_str());
        int sout = system("cp log.txt log_1.txt");        
        output_2 = system(param2.c_str());
    }
    
    preprocess_time = get_wall_time() - time_stamp;
    int sys_out = system("cp log.txt log_2.txt");
        
    // config planner
    string param3 = planners_desc[pid];  
    string str_old, str_new;
    if(pid == 0){
        stringstream ssp;
        ssp << cost_bound;
        str_old = "CBD";
        str_new = ssp.str();
        param3.replace(param3.find(str_old), str_old.length(), str_new);
        ssp.clear();
    }
    else if(pid = 1){
        stringstream ssp;
        ssp << wid;
        // str_old = "DFILE";
        // param3.replace(param3.find(str_old), str_old.length(), dom);
        // str_old = "RFILE";
        // str_new = temp_dir + "/sprob." + ssp.str();
        // param3.replace(param3.find(str_old), str_old.length(), str_new);
        ssp.clear();
        str_old = "PFILE";
        str_new = temp_dir + "/splan." + ssp.str();
        param3.replace(param3.find(str_old), str_old.length(), str_new);
        ss.clear();
    }

    // cout << "param3: " << param3 << endl;
    
    bool improved = false;
    bool exhaust = false;
    
    int old_cost = window[wid].get_cost() - window[wid].get_cost_improve();
    int new_cost = old_cost; 
        
    if(output_1 != 0 && output_2 != 0){
        fileout << "output_1 != 0 && output_2 != 0" << endl;
        return op_result;
    }

    // cout << "FLAG--b" << endl;
    // run planner
    write_run_planner(time_bound);
    time_stamp = get_wall_time(); 
    output_3 = system(param3.c_str());
    planning_time = get_wall_time() - time_stamp;
    sys_out = system("cp log.txt log_3.txt");

    // update trial_count
    window[wid].increase_trial_count(pid);
    
    
    // retrieve new_cost    
    string ncost_str = file_get_next_token_from_last_match("log.txt", "cost:");
    if(!ncost_str.empty()){
        istringstream convert(ncost_str);
        convert >> new_cost;
    }
    
    // retrieve exhaust status
    exhaust = check_exhaust(pid, opid, wid, new_cost, wids_sorted);
    // cout << "FLAG--c" << endl;
    
    if(new_cost < old_cost){ // better plan
        // cout << "FLAG--improved" << endl;
        improved = true; 
        flop_count[pid] = 0;
        bandit_planner[pid].add_rewards(1);
        
        window[wid].set_cost_improve(old_cost-new_cost);
        remove_val(wids_sorted[opid], wid);
        
	// cout << "FLAG-1" << endl;
        // retrieve plan_time
        if(pid == 0){
            string time_str = file_get_line_from_1st_match("log.txt", "Actual search time:", "no solution!"); 
            if(!time_str.empty()) {
                time_str = time_str.substr(time_str.find("=")+1, time_str.find("s]")-(time_str.find("=")+1));
                istringstream convert(time_str);
                convert >> planning_time;
            }
            window[wid].set_time_1st_plan(planning_time);
        }
        else if(pid == 1){
            string time_str = file_get_next_matched_line_after_nth_token_match("log.txt", "Total_Time:", "Plan length:", 2, "no solution!"); 
            if(!time_str.empty()) {
                time_str = time_str.substr(time_str.find("Total_Time: ")+12, time_str.find("s Size:")-(time_str.find("Total_Time: ")+12));
                istringstream convert(time_str);
                convert >> planning_time;
            }
            window[wid].set_time_1st_plan(planning_time);
        }
        
	// cout << "FLAG-2" << endl;
	// cout << "FLAG--improved--2" << endl;
        // freeze window actions and remove all the overlapping windows from the candidate list
        frozen_actions.insert(frozen_actions.end(), cwindow.begin(), cwindow.end());       
//        cout << "frozen_actions: " << vector_to_string(frozen_actions, ".") << endl;
        vector<int> cwids = union_set(wids_sorted[0], wids_sorted[1]);
        for(int x = 0; x < cwids.size(); x++){
            int fwid = cwids[x];
            vector<int> fwindow = string_to_vector(window[fwid].get_actions_str(), ".");
            if(have_common(fwindow, cwindow)){
                frozen_wids.push_back(fwid);
            }
        }
        wids_sorted[0] = difference_set(wids_sorted[0], frozen_wids);
        wids_sorted[1] = difference_set(wids_sorted[1], frozen_wids);
        
        // store new subplan
        int x = store_new_sub_plan(wid, pid);   
        
	// cout << "FLAG--improved--3" << endl;
        // merge
	// cout << "FLAG-3" << endl;
        
        merge_improved_window(merge_result);    
	// cout << "FLAG--e" << endl;
	// cout << "FLAG-4" << endl;
        
        op_result = true;
        
    }    
    else{ // no improvement
        bandit_planner[pid].add_rewards(0);
        flop_count[pid]++;
    }
    
    // save optimisation result into wopt.log
    save_optimisation_result(wid, pid, translation_time, preprocess_time, flop_count, rank_policy, wids_sorted, merge_result);
    
    return op_result;
}



void save_carryover_result(){
    stringstream ssit;
    ssit << iteration;
    
    string filestr = results_dir + "/pbandit.log";
    ofstream fileout_pbandit(filestr.c_str());    
    for (int i=0; i< TOT_PLANNERS; i++) 
        fileout_pbandit << vector_to_string(bandit_planner[i].get_rewards(), " ") << endl;
    fileout_pbandit.close();
    
    filestr = results_dir + "/time.txt";
    ofstream fileout_time(filestr.c_str());    
    fileout_time << iteration  << " "  << bplan_isnum << " " << rank_policy[0] << " " << rank_policy[1] << " " << total_tm+(get_wall_time()-swatch);
    fileout_time.close();
    
    ofstream fileout_wgen;
    filestr = results_dir + "/wgen_details";
    fileout_wgen.open(filestr.c_str(), ios_base::app);
    filestr = results_dir + "/sprob_opt.log";
    ofstream fileout_optimal(filestr.c_str()); 
    for(int wid = 0; wid < window.size(); wid++){
        fileout_wgen    << iteration << "\t" 
                        << wid << "\t" 
                        << vector_to_string(window[wid].get_rank(), " ") << "\t"
                        << window[wid].get_trial_count(0) << "\t"
                        << window[wid].get_trial_count(1) << "\t"
                        << window[wid].get_cost_improve() << "\t"
                        << window[wid].exhausted() << "\t"                
                        << vector_to_string(window[wid].get_wpolicies()," ") << "\t"
                        << vector_to_string(window[wid].get_frules()," ") << "\t" 
                        << fixed << setprecision(2) << window[wid].get_time_1st_plan() << "\t"
                        << fixed << setprecision(2) << window[wid].get_exhaust_time() << "\t"       
                        << window[wid].get_actions_str() << "\t" 
                        << window[wid].get_iatoms_str() << "\t" 
                        << window[wid].get_gatoms_str() << endl;
        
	// if(window[wid].exhausted() || window[wid].get_cost()-window[wid].get_cost_improve() <= window[wid].get_adm_hcost())
	//     fileout_optimal << window[wid].get_iatoms_str() << "|" << window[wid].get_gatoms_str() << " " << window[wid].get_cost()-window[wid].get_cost_improve() << endl;
    }
    
    for ( S_UMAP::iterator it = sprob_umap.begin(); it != sprob_umap.end(); ++it){ 
        fileout_optimal << it->first << " " << it->second << endl;
	// cout << it->first << " " << it->second << endl;
    }
    
    fileout_wgen.close();
    fileout_optimal.close();
}

bool explore_neighborhood(){
    const float REM_FACTOR = .75;
    const int FLOP_LIMIT = MAX_WINDOW_BOUND_ONCE*2/3; // 60;
    //    const int FLOP_POL_LIMIT = 60;
    const float ICOVERAGE_LIMIT = .5;
    
    bool hlb_flag = false;
    bool better_plan = false;
    //    bool restart_flag = false;
    
    string dom(arguments[1]);
    string prob(arguments[2]);
    string plan(arguments[3]);
    double time_stamp, translation_time, preprocess_time;
    
    bool wp_exhausted = false;
    int qempty_counter = 0;
    int added_windows_tot = 0;
    vector<int> *wids_sorted; 
    wids_sorted = new vector<int> [TOT_PLANNERS];

    vector<int> flop_count(2,0); // consecutive failure in optimising windows
    
    ofstream fileout_wg;
    string filestr = results_dir + "/wg_status.log";
    fileout_wg.open(filestr.c_str(), ios_base::app);
    
    initialise_events();
    
    //    int policy_id = 0;
    //    int temp_count = 0;
    bool bandit = true;
    bool ranking = true;
    float improvement_coverage = 0.0;
    int pid = 0; //-1;
    
    while(total_tm+(get_wall_time()-swatch) < alloted_tm){
        
        // cout << "FLAG--a" << endl;
        // select bandit_planner
        
        
        
        if(!wp_exhausted && (window.empty() || wids_sorted[pid].size() < REM_FACTOR * window.size()) ){ //|| flop_count[pid] > FLOP_LIMIT){
	    // cout << "FLAG--b1 " << vector_to_string(wids_sorted[pid], ".") << endl;
            added_windows_tot = 0;
            added_windows_tot = add_more_candidate_windows();
            if(added_windows_tot > 0) ranking = true;

            if(wg_status[0][0] == 1 && wg_status[1][0] == 1 && wg_status[2][0] == 1 && wg_status[3][0] == 1 && wg_status[4][0] == 1 && wg_status[5][0] == 1) 
                wp_exhausted = true;

	    // for(int k = 0; k < TOT_PLANNERS; k++) set_window_rank(k, rank_policy[k], wids_sorted[k]);   

            fileout_wg << "added_windows:" << added_windows_tot << " wg_status:" << wg_status[0][0] << "." << wg_status[1][0] << "." << wg_status[2][0] << "." 
                    << wg_status[3][0] << "." << wg_status[4][0] << "." << wg_status[5][0] << " t:" << total_tm+(get_wall_time()-swatch) << endl;                               
        }
        
        if(bandit){
            vector<int> pid_bandit;
            pid_bandit = ucb_bandit_planner(); 
            pid = pid_bandit[0];
            bandit = false;
        }
	// cout << "pid_vec: " << vector_to_string(pid_bandit, " ") << endl;  
        if(ranking){
            for(int k = 0; k < TOT_PLANNERS; k++) set_window_rank(k, rank_policy[k], wids_sorted[k]);   
	    // set_window_rank(pid, rank_policy[pid], wids_sorted[pid]);   
            ranking = false;
        }
        
        if(wids_sorted[pid].empty()){
            if(wp_exhausted){
                bandit_planner[pid].increment_trial_limit();
                fileout << "after incrementing trial limit: cq_size:"  << wids_sorted[0].size() << "." << wids_sorted[1].size() << " cpid:" << pid << endl;
                ranking = true;
                qempty_counter++;
                 if(qempty_counter > 1){
                    fileout << "repair_exhausted: cq_size:"  << wids_sorted[0].size() << "." << wids_sorted[1].size() << " cpid:" << pid << endl;
                    fileout_wg.close();
                    return better_plan;
                }
            }
           
            continue;
        }
        
	// cout << endl;
	// pid = 1;
	// cout << "pid:" << pid << endl;
	// cout << "flop_count:" << flop_count[0] << "." << flop_count[1] << " 3*FLOP_LIMIT:" << 3*FLOP_LIMIT << endl;
	// cout << "improvement_coverage:" << improvement_coverage;
	// cout << " ICOVERAGE_LIMIT:" << ICOVERAGE_LIMIT << endl;
	// cout << "improvement_coverage:" << improvement_coverage << endl;
	// cout << "cq_size:"  << wids_sorted[0].size() << "." << wids_sorted[1].size() << endl;
                    
        int wid = wids_sorted[pid].back();
        
        wids_sorted[pid].pop_back();
        bool op_success = optimise_window(pid, wid, flop_count, rank_policy, wids_sorted);
        
        bandit = true;
        ranking = true;
        qempty_counter = 0;
        
        if(op_success){ 
	    // return true;
            better_plan = true;
        }
        
        if(flop_count[pid] > 0 && flop_count[pid] % FLOP_LIMIT == 0){ 
            rank_policy[pid] = (rank_policy[pid]+1) % 3;
            ranking = true;
        }
        
        improvement_coverage = (1.0)*frozen_actions.size()/theplan.size();
        if(better_plan && (improvement_coverage > ICOVERAGE_LIMIT || flop_count[pid] > 3*FLOP_LIMIT) ){
            
	  // cout << endl << "restarting .....";
	  // cout << "pid:" << pid << endl;
	  // cout << "flop_count:" << flop_count[0] << "." << flop_count[1] << " 3*FLOP_LIMIT:" << 3*FLOP_LIMIT << endl;
	  // cout << "improvement_coverage:" << improvement_coverage;
	  // cout << " ICOVERAGE_LIMIT:" << ICOVERAGE_LIMIT << endl;
	  // cout << "improvement_coverage:" << improvement_coverage << endl;
	  // cout << "cq_size:"  << wids_sorted[0].size() << "." << wids_sorted[1].size() << endl;
	  // exit(1);
            
	  // restart_flag = true;
            break;
        }
        
    } // END-WHILE
    
    fileout_wg.close();
    return better_plan;
}


int main(int argc, char *argv[]) {
    arguments = argv;

    swatch = get_wall_time();
    
    HSPS::StringTable symbols(50, HSPS::lowercase_map);
    HSPS::Parser* reader = new HSPS::Parser(symbols);

    for (HSPS::index_type k = 1; k <= 3; k++) {
        reader->read(argv[k], false);
    }

    for (HSPS::index_type k = 4; k < argc; k++) {
        if(unproductive_arm_param.compare(argv[k]) == 0)
	    switch_off_unproductive_arms_flag = true;
	if(reset_bandit_param.compare(argv[k]) == 0)
	    reset_bandit_flag = true;
    }
  
    reader->post_process();

    if (reader->n_plans() == 0) {
        std::cerr << "error: there is no plan!" << std::endl;
	exit(1);
    }
  
    stats.enable_interrupt();
    stats.start();

    //HSPS::Instance instance;
    HSPS::PDDL_Base::del_before_add_semantics = true;
    reader->instantiate(instance);

    HSPS::Preprocessor prep(instance, stats);
    instance.cross_reference();
  
    bool ok = reader->export_plan(0, instance, prep.action_map, theplan);
    if (!ok) {
        std::cerr << "error: export plan failed" << std::endl;
	exit(1);
    }
    
    // if exist it will not create any directory
  
    int status;  
    status = mkdir(temp_dir.c_str(), S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);

    write_run_planner(TRAN_TBOUND);
    string param1 = com_file + " " + fd_src_location + "/translate/translate.py " + arguments[1] + " " + arguments[2];  
    int ot = system(param1.c_str());
    //  time_file initialize=========================================
    ifstream time_file;
    string str = results_dir + "/time.txt";
    time_file.open(str.c_str(), ios::in);
  
    if(!time_file.fail()){
        string line;
	getline(time_file,line); 
	vector<string> token_vector = split_string(line, " ");
	stringstream ss;
	ss << token_vector[0];
	ss >> iteration; 
	ss.clear();
	ss << token_vector[1];
	ss >> bplan_isnum;
	ss.clear();
	ss << token_vector[2];
	ss >> rank_policy[0];
	ss.clear();
	ss << token_vector[3];
	ss >> rank_policy[1];
	ss.clear();
	ss << token_vector[4];
	ss >> total_tm;
	ss.clear();
    }
    time_file.close();  
    iteration++;
    // =======================================================================
  
  
    string filestr = results_dir + "/run.log";
    fileout.open(filestr.c_str(), ios_base::app);
    if(!fileout){
        cout << "unable to fileout" << endl;
    }
    
    fileout << instance.n_atoms() << " atoms and "
	    << instance.n_actions() << " actions" << endl;
    
    fileout << "iteration: " << iteration << " bplan_isnum: " << bplan_isnum << " total_tm: " << total_tm << endl;
    int cost = 0;
    for(int i = 0; i < theplan.size(); i++)
        cost += instance.actions[theplan[i]].cost.decimal();
    fileout << endl << "Plan cost: " << cost << endl;
    fileout << "Plan length: " << theplan.size() << endl;


    string temp_str =  temp_dir + "/static_atom.txt";
    ofstream outfile (temp_str.c_str()); 
  
    for (unsigned int i = 0; i < reader->dom_init.length(); i++) {
        if (!reader->dom_init[i]->pred->modded) {
	    reader->dom_init[i]->print(outfile);
	    outfile << endl;
	}
    }
    outfile.close();
  
    prf_size = theplan.size()+2;
    prf_order_vector = new vector<int> [prf_size];

    order_all = new vector<bool> [prf_size];
    for (int i = 0; i < prf_size; i++){
        order_all[i].resize(prf_size);
	fill(order_all[i].begin(), order_all[i].end(), false);
    }
    // order_full_r = new vector<bool> [prf_size];
  
  
    // prf_order_vector_r = new vector<int> [prf_size];
    prf_full = new vector<int> [prf_size];
  
    straight_dependent_vector = new vector<int> [prf_size];
    sd_atoms = new vector<int>* [prf_size];
    for (int i = 0; i < prf_size; i++){
        sd_atoms[i] = new vector<int> [prf_size];
    }
          
    macro_clusters = new vector<int> [prf_size * 100];
  
    pre_vector = new vector<int> [prf_size];
    add_vector = new vector<int> [prf_size];
    del_vector = new vector<int> [prf_size];  
    set_pad();
  
    //new============================================
  
    for (int i = 0; i < prf_size-1; i++){
        for (int j = i+1; j < prf_size; j++){
            if(have_straight_dependency(i, j)){
	      // cout << i << "-" << j << ": Y" << endl;
	      straight_dependent_vector[i].push_back(j);
	    }
	    // else cout << i << "-" << j << ": N" << endl;
	}
    }
  
    // Generating PRF vector
    fileout << "Generating POP at: " << fixed << setprecision(3) << total_tm+(get_wall_time()-swatch) << endl;
  
    for (int j = 1; j < prf_size; j++){
        // prf_order_vector[0].push_back(j);
        prf_full[0].push_back(j);
	// action_path_bit.set(j);
        order_all[0][j] = true;
    }

    for (int i = 1; i < prf_size-1; i++){
        for (int j = i+1; j < prf_size;j++){
            if( have_any_dependency(i, j) ){
	        // prf_order_vector[i].push_back(j);
                prf_full[i].push_back(j);
		// save into complete path vector
		//  action_path_bit.set((i*prf_size)+j);
		order_all[i][j] = true;
		for (int x = 0; x < i; x++){
                    if(order_all[x][j])
                        continue;
		    if(order_all[x][i])
                        order_all[x][j] = true;
		}
	    }          
	}          
    }
  
    // Delete transitive order from PRF
    // fileout << "Delete transitive order from PRF at: " << total_tm+(get_wall_time()-swatch) << endl;
  
    for (int j = 0; j < prf_size; j++) prf_order_vector[j].clear();
    prf_order_vector = delete_transitive_order(prf_full, prf_size); 
  
    // Removing inactive actions from PRF
    //  fileout << "Removing inactive actions from PRF at: " << total_tm+(get_wall_time()-swatch) << endl;
    remove_inactive_actions();
   
    // writing dot files;
    write_file(temp_dir + "/DPOP_0.dot", prf_order_vector, flex, "Initial State");
    //  print_action_dependencies_to_file();
  
    fileout << "Block Deordering starts at: " << fixed << setprecision(3) << total_tm+(get_wall_time()-swatch) << endl;

    fileout << "Initial flex: " << calculate_flex() << endl;
    create_deordered_macros_of_pop(prf_order_vector);
    fileout << "New flex: " << calculate_flex() << endl;
  
    //  do_iterative_test();    
    //  write_file(temp_dir + "/prf_full.dot", prf_full, flex, "");
    //  write_file(temp_dir + "/SD.dot", straight_dependent_vector, flex, "");
  
    //  deorder_tm += (get_wall_time()-swatch);
  
    //  print_action_dependencies_to_file();
  
    fileout << "Plan Optimisation starts at: " << total_tm+(get_wall_time()-swatch) << endl;
    bool need_restart = explore_neighborhood();
    fileout << "Optimisation ends at: " << fixed << setprecision(3) << total_tm+(get_wall_time()-swatch) << endl << endl;
    fileout.close();
  
    save_carryover_result();
    stringstream ss;
    ss << iteration;
    string com = "mv " + temp_dir +" " + ss.str();
    int comout = system(com.c_str()); 
  
    if(need_restart){    
        string param = get_restart_ingredients();
	int output = system(param.c_str());
    }
  
    return 0;
}
